<?php
namespace App\Http\Controllers\Api\V1;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\UserLoginData;
use App\Models\User;
use App\Models\Package;
use App\Models\Setting;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use Session;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;

class ApiController extends Controller
{
    
    public  function __construct()
    {

    }

    public function GetUsers(){
        try{
            $users = User::select('user_id','mailbox','email','first_name','last_name','phone')->where('role_id' , 0)->orderBy('first_name' , 'ASC')->get();
            //return count($trims);
            $usersArray = [];
            if(count($users) > 0){
                
                return response()->json(['status'=>"success","message"=>'Users data found.','data' => $users],200);
            }else{
                return response()->json(['status'=>"success","message"=>'No data found.','data' => []],200);
            }
        }catch(\Exception $e){
            return response()->json(['status'=>"failed","message"=>$e->getMessage(),"user_access" => 1],200);
        }
    }
    
    public function savePackage(Request $request){
        try{
            $packagesCheck = DB::table('packages')->where('supplier_tracking_no',$request->supplier_tracking_no)->first();
            if($packagesCheck){
                return ['status'=>false,"message"=>'Supplier tracking no. already exist, try with another one'];
            }
            $TrackingCheck = DB::table('packages')->where('tracking_no',$request->tracking_no)->first();
            if($TrackingCheck){
                return ['status'=>false,"message"=>'Tracking no. already exist, try with another one'];
            }
            $packages = new Package();
            $packages->tracking_no = $request->tracking_no;
            $packages->mailbox = $request->mailbox;
            $packages->courier = $request->courier;
            $packages->supplier_tracking_no = $request->supplier_tracking_no;
            $packages->package_type = $request->package_type;
            $packages->package_code = $request->package_type;
            $packages->weight = $request->weight;
            $packages->manifest_no = $request->manifest_no;
            $packages->price = $request->price;
            $packages->item_description = $request->item_description;
            $packages->created_at = date('Y-m-d h:i:s');
            $packages->updated_at = date('Y-m-d h:i:s');
            $packages->save();
            return ["status" => true,"message"=>"Package has been created successfully."];
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    public function checkPackage(Request $request){
        try{
            $packagesCheck = DB::table('packages')->where('supplier_tracking_no',$request->supplier_tracking_no)->first();
            if($packagesCheck){
                return ['status'=>false,"message"=>'Supplier tracking no. already exist, try with another one'];
            }
            $TrackingCheck = DB::table('packages')->where('tracking_no',$request->tracking_no)->first();
            if($TrackingCheck){
                return ['status'=>false,"message"=>'Tracking no. already exist, try with another one'];
            }
            return ["status" => true,"message"=>"Package has been created successfully."];
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    
    
    public function firebase($device_token,$message) {
	//echo '<pre>';print_r($message);exit;
        // Message should contain key and value. It should be an array like =====  message=>'Hi test'
        $url = 'https://fcm.googleapis.com/fcm/send';
		
        $fields = array(
            'to' => $device_token,
            'content_available' => true,
	    'mutable_content' => true,
            'data' => $message,
	    'notification' =>  $message
        );
		//echo json_encode($fields);exit;
        // Authentication..... Identification for project on firebase

        $header = array(
            'Authorization:key =AAAAasYy5JQ:APA91bFfw0DZHXZIhb5or73hsMokgehBkyMJRx_NKo59DVwQiPerNERyiYQHyJXL8Vv39E4W5UHm3OOu0JUZ9vvya5BOOv_IWL0kQFYpjPDaF6isKqvu8x83TtYlgwVchuzEdNLw6WPH',
            'Content-Type: application/json'
        );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);
	//echo '<pre>'; print_r($result);exit;
        if ($result === false) {
            die('Curl Failed: ' . curl_error($ch));
        }
        
        curl_close($ch);
        return $result;
    }

    function distance($lat1, $lon1, $lat2, $lon2, $unit) {

        $theta = $lon1 - $lon2;
        $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
        $dist = acos($dist);
        $dist = rad2deg($dist);
        $miles = $dist * 60 * 1.1515;
        $unit = strtoupper($unit);
        if ($unit == "K") {
            return ($miles * 1.609344);
        } else if ($unit == "N") {
            return ($miles * 0.8684);
        } else {
            return $miles;
        }
    }   
    
    function getdate($second_time){
        $string = "";
        $seconds = time()- $second_time;
        //$days = date('d-M-Y' , strtotime($second_time));
        $year = intval(intval($seconds) / (365 * 24 * 60 * 60));
        $momth = intval(intval($seconds) / (30 * 24 * 60 * 60));
        $weeks = intval(intval($seconds) / (7 * 24 * 60 * 60));
        $days = intval(intval($seconds) / (3600*24));
        $hours = (intval($seconds) / 3600) % 24;
        $minutes = (intval($seconds) / 60) % 60;
        $seconds = (intval($seconds)) % 60;
        //echo $weeks.'======'.$days.'===='. $hours .'====' . $minutes. '=====' . $seconds;exit;
        if($year > 0){
            return  $string .= "$year Year ago";
        }
        if($momth > 0){
            return  $string .= "$momth Month ago";
        }
        if($weeks > 0){
            return  $string .= "$weeks weeks ago";
        }
        if($hours > 24 && $hours < 48){
                return $string .= "Yesterday";
        }
        if($hours > 1 && $hours < 24){
                return $string .= "Today";
        }
        if($days > 0){
                return  $string .= "$days days ago";
        }
        if($hours > 0){
                return $string .= "$hours hours ago";
        }
        if($minutes > 0){
                return $string .= "$minutes minutes ago";
        }
        if ($seconds < 59){
                return $string .= "Just now";
        }
    }
	
}