<?php

namespace App\Exports;

use App\BrandModel;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class ModelsExport implements FromCollection, WithHeadings, ShouldAutoSize, WithEvents
{
    public function collection()
    {
        $all_models = BrandModel::select('id','brand_id','model_name','model_type','pulse_setting','continuous_flow','model_price','warranty','created_at')->get();

        foreach ($all_models as $key => $model) {
        $brandName = \DB::table('brands')->where('id', $model->brand_id)
                                           ->select('brand_name')->first();
        $model->brand_id = $brandName->brand_name;
        
        }

        return $all_models;
    }

    public function headings(): array
    {   
        return [
            '#',
            'Brand Name',
            'Model Name',
            'Model Type',
            'Pulse Setting',
            'Continuous Flow',
            'Model Price',
            'Warranty',
            'Created at'
        ];
    }

    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $cellRange = 'A1:W1'; // All headers
                $event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(14);
            },
        ];
    }



}