<?php

namespace App\Exports;

use App\Models\User;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class UsersExport implements FromCollection, WithHeadings, ShouldAutoSize, WithEvents
{
    public function collection()
    {
        return User::select('user_id','first_name','last_name','outlet_id','mailbox','email','phone','address_1','address_2','city','state','country','created_at')->where('is_superadmin' , 0)->get();
    }
    public function headings(): array
    {
        return [
            '#',
            'First Name',
            'Last Name',
            'Outlet ID',
            'Account No.',
            'Email',
            'Phone',
            'Address Line 1',
            'Address Line 2',
            'City',
            'State',
            'Country',
            'Created at'
        ];
    }

    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $cellRange = 'A1:W1'; // All headers
                $event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(14);
            },
        ];
    }



}
