<?php

namespace App\Exports;

use App\LeadCall;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class LeadsExport implements FromCollection, WithHeadings, ShouldAutoSize, WithEvents
{
    public function collection()
    {
        return LeadCall::select('id','caller_name','requirement_city','CallFrom','source','product_name','requirement_details','status','reason','last_update')->get();
    }
    public function headings(): array
    {
        return [
            'ID',
            'Name',
            'City',
            'Phone',
            'Source',
            'Product',
            'Comment',
            'Status',
            'Status Detail',
            'Date'
        ];
    }

    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $cellRange = 'A1:W1'; // All headers
                $event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(14);
            },
        ];
    }



}
