<?php
namespace App\Http\Controllers\Api\V1;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\User;
use App\Models\Driver;
use App\Models\Resident;
use App\Models\GarbageCollection;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use Session;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;

class ApiController extends Controller
{

    public  function __construct()
    {

    }

    public function logoutUser(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $checkUser = UserLoginData::where('userId',$jsonrequest['user_id'])->where('loginToken',$jsonrequest['loginToken'])->where('tokenStatus',0)->first();
            if($checkUser){
                UserLoginData::where('userId',$jsonrequest['user_id'])->where('loginToken',$jsonrequest['loginToken'])->delete();
                return response()->json(['status'=>"success","message"=>"User Logout successfully."],200);
            }else{
                return response()->json(['status'=>"failed","message"=>"Session expired please login again.","user_access" => 0],200);
            }
        }catch(\Exception $e){
            return response()->json(['success'=>"failed","message"=>$e->getMessage(),"user_access" => 1],200);
        }
    }
    
    public function GetMetraAppInformation(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $mailbox = Auth::user()->mailbox;
            $setting = DB::table('settings')->first();
            $setting->site_logo = base_url('settings').'/'.$setting->site_logo;
            $data['setting'] = $setting;
            return ['status' => true, 'message' => 'Meta information data found.','data' => $data];
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    function distance($lat1, $lon1, $lat2, $lon2, $unit) {

        $theta = $lon1 - $lon2;
        $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
        $dist = acos($dist);
        $dist = rad2deg($dist);
        $miles = $dist * 60 * 1.1515;
        $unit = strtoupper($unit);
        if ($unit == "K") {
            return ($miles * 1.609344);
        } else if ($unit == "N") {
            return ($miles * 0.8684);
        } else {
            return $miles;
        }
    }
    function getdate($second_time){
        $string = "";
        $seconds = time()- $second_time;
        //$days = date('d-M-Y' , strtotime($second_time));
        $year = intval(intval($seconds) / (365 * 24 * 60 * 60));
        $momth = intval(intval($seconds) / (30 * 24 * 60 * 60));
        $weeks = intval(intval($seconds) / (7 * 24 * 60 * 60));
        $days = intval(intval($seconds) / (3600*24));
        $hours = (intval($seconds) / 3600) % 24;
        $minutes = (intval($seconds) / 60) % 60;
        $seconds = (intval($seconds)) % 60;
        //echo $weeks.'======'.$days.'===='. $hours .'====' . $minutes. '=====' . $seconds;exit;
        if($year > 0){
            return  $string .= "$year Year ago";
        }
        if($momth > 0){
            return  $string .= "$momth Month ago";
        }
        if($weeks > 0){
            return  $string .= "$weeks weeks ago";
        }
        if($hours > 24 && $hours < 48){
                return $string .= "Yesterday";
        }
        if($hours > 1 && $hours < 24){
                return $string .= "Today";
        }
        if($days > 0){
                return  $string .= "$days days ago";
        }
        if($hours > 0){
                return $string .= "$hours hours ago";
        }
        if($minutes > 0){
                return $string .= "$minutes minutes ago";
        }
        if ($seconds < 59){
                return $string .= "Just now";
        }
    }
}
