<?php
namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\GarbageCollection;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use App\Models\AuthUser;
use App\Models\Payment;
use App\Models\Appointment;
use Session;
use Auth;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;
use Razorpay\Api\Api;

class AuthorizeuserApiController extends Controller
{

    public $order_number;
    public function __construct()
    {
        $this->order_number = date("Ymd") . strtoupper(substr(uniqid(sha1(time())),0,4));

        //$this->middleware('auth')->except('thanks');
    }

    public function AddAuthorizeUser(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $user_id = Auth::user()->user_id;
            $purchase = new AuthUser();
            $purchase->user_id = $user_id;
            $purchase->name = request()->name;
            $purchase->phone = request()->phone;
            $purchase->proof = request()->proof;
            $purchase->created_at = date('Y-m-d h:i:s');
            $purchase->updated_at = date('Y-m-d h:i:s');
            $purchase->save();
            return ['status' => true, 'message' => 'Authorize user created successfully.', 'data' => $purchase];
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function GetAuthorizeUsers(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $offset = request()->offset * 20;
            $authUser = AuthUser::where('user_id' , Auth::user()->user_id)->skip($offset)->take(20)->get();
            if($authUser){
                return ['status' => true,  'message' => 'Authorize user data found.','data' => $authUser];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => $authUser];
            }
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }

    public function editAuthorizeUser(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $authUser = AuthUser::where('id' , request()->id)->first();
            if($authUser){
                return ['status' => true,  'message' => 'Authorize user data found.','data' => $authUser];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => null];
            }
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function UpdateAuthorizeUser(){
        try{
           $authUser = AuthUser::where('id' , request()->id)->first();
            if($authUser){
                AuthUser::where('id' , request()->id)->update(['name' => request()->name,'phone' => request()->phone,'proof' => request()->proof]);
                $authUser = AuthUser::where('id' , request()->id)->first();
                return ['status' => true,  'message' => 'Authorize user data updated successfully.','data' => $authUser];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => null];
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function DeleteAuthorizeUser(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $authUser = AuthUser::where('id' , request()->id)->first();
            if($authUser){
                AuthUser::where('id' , request()->id)->delete();
                return ['status' => true,  'message' => 'Authorize user deleted successfully.','data' => null];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => null];
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
}
