<?php
namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\GarbageCollection;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use App\Models\Enquiry;
use App\Models\Payment;
use App\Models\Appointment;
use Session;
use Auth;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;
use Razorpay\Api\Api;
use commonHelper;

class InvoicesApiController extends Controller
{

    public $order_number;
    public function __construct()
    {
        $this->order_number = date("Ymd") . strtoupper(substr(uniqid(sha1(time())),0,4));

        //$this->middleware('auth')->except('thanks');
    }
    
    public function GetInvoicesSearch(){
        try{
            //return Auth::user()->mailbox;
            $invoicesArr = [];
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $offset = request()->offset * 20;
            $search = request()->keyword;
            if($search != ''){
                if($search == 'paid' || $search == 'Paid'){
                    $paramsArr['status_paid'] = 1;
                }elseif($search == 'unpaid' || $search == 'Unaid'){
                    $paramsArr['status_unpaid'] = 0;
                }else{
                    $paramsArr['invoice_no'] = $search;
                }
                $invoices = DB::table('invoices')->select('invoice_id','invoice_no','mailbox_no','user_name','status','created_at','updated_at as date_paid')
                                ->where('mailbox_no',Auth::user()->mailbox)
                                ->where(function($q) use ($paramsArr)
                                {
                                    foreach($paramsArr as $key => $value)
                                    {
                                        if($key == 'status_paid'){
                                            $q->orWhere('status', 1);
                                        }elseif($key == 'status_unpaid'){
                                            $q->orWhere('status', 0);
                                        }elseif($key == 'invoice_no'){
                                            $q->orWhere('invoice_no', 'LIKE',"%{$value}%");
                                        }
                                    }
                                })
                                ->skip($offset)
                                ->take(20)
                                ->orderby('created_at','DESC')
                                ->get();
                if(count($invoices) > 0){
                    foreach($invoices as $row){
                        if($row->status == 0){
                            $row->status = 'Unpaid';
                        }else{
                            $row->status = 'Paid';
                        }
                        $row->total_invoice = commonHelper::getInvoiceCount($row->invoice_id);
                        $row->total_paid = commonHelper::getInvoiceCountPaid($row->invoice_id);
                        $invoicesArr[] = $row;
                    }
                    return ['status' => true,  'message' => 'Invoice data found.','data' => $invoicesArr];
                }else{
                    return ['status' => true,  'message' => 'No data found.','data' => $invoicesArr];
                }
            }else{
                $invoices = DB::table('invoices')->select('invoice_id','invoice_no','mailbox_no','user_name','status','created_at','updated_at as date_paid')->where('mailbox_no',Auth::user()->mailbox)->skip($offset)->take(20)->orderby('created_at','DESC')->get();
                if(count($invoices) > 0){
                    foreach($invoices as $row){
                        if($row->status == 0){
                            $row->status = 'Unpaid';
                        }else{
                            $row->status = 'Paid';
                        }
                        $row->total_invoice = commonHelper::getInvoiceCount($row->invoice_id);
                        $row->total_paid = commonHelper::getInvoiceCountPaid($row->invoice_id);
                        $invoicesArr[] = $row;
                    }
                    return ['status' => true,  'message' => 'Invoice data found.','data' => $invoicesArr];
                }else{
                    return ['status' => true,  'message' => 'No data found.','data' => $invoicesArr];
                }
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }

    
    public function GetAllInvoices(){
        try{
            //return Auth::user()->mailbox;
            $invoicesArr = [];
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $offset = request()->offset * 20;
            $invoices = DB::table('invoices')->select('invoice_id','invoice_no','mailbox_no','user_name','status','created_at','updated_at as date_paid')->where('mailbox_no',Auth::user()->mailbox)->skip($offset)->take(20)->orderby('created_at','DESC')->get();
            if(count($invoices) > 0){
                foreach($invoices as $row){
                    if($row->status == 0){
                        $row->status = 'Unpaid';
                    }else{
                        $row->status = 'Paid';
                    }
                    $row->total_invoice = commonHelper::getInvoiceCount($row->invoice_id);
                    $row->total_paid = commonHelper::getInvoiceCountPaid($row->invoice_id);
                    $invoicesArr[] = $row;
                }
                return ['status' => true,  'message' => 'Invoice data found.','data' => $invoicesArr];
            }else{
                return ['status' => true,  'message' => 'No data found.','data' => $invoicesArr];
            }
            
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function InvoicesDetail(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $invoicesArr = [];
            $setting = DB::table('settings')->first();
            $invoices = DB::table('invoices')->join('users','users.mailbox','=','invoices.mailbox_no')->select('invoices.invoice_id','invoices.invoice_no','invoices.mailbox_no','invoices.user_name','invoices.gct','invoices.discount_price','invoices.updated_at as date_paid','users.email','users.address_1')->where('invoice_no',request()->invoice_no)->first();
            if($invoices){
                $invoices->company_name = $setting->company_name;
                $invoices->local_address = $setting->local_address;
                $invoices->admin_account = 'BB00001';
                $invoices->phone = $setting->phone;
                $invoices->site_email = $setting->site_email;
                $invoices->gst_persent = 15;
                $invoicesPack = DB::table('invoice_packages')->join('packages', 'invoice_packages.tracking_no', '=', 'packages.tracking_no')->select('invoice_packages.*','packages.manifest_no')->where('invoice_id' , $invoices->invoice_id)->get();
                if(count($invoicesPack) > 0){
                    $totalAmount = 0;
                    $totalServiceFee = 0;
                    foreach($invoicesPack as $pack){
                        $pack->package_total = number_format(($pack->package_price + $pack->custom_fee + $pack->service_fee) * $setting->us_rate,2).' ';
                        $totalAmount +=  ($pack->package_price + $pack->custom_fee + $pack->service_fee) * $setting->us_rate;
                        $totalServiceFee += ($pack->package_price + $pack->service_fee) * $setting->us_rate;
                        $pack->custom_fee = $pack->custom_fee * $setting->us_rate.' ';
                        $pack->service_fee = $pack->service_fee * $setting->us_rate.' ';
                        $pack->package_price = number_format($pack->package_price * $setting->us_rate,2).' ';
                        $invoicesArr[] = $pack;
                    }
                    //return $totalServiceFee;
                    if($invoices->gct == 0){
                        $total_gct = 0;
                        $invoices->gst_persent = '0%';
                        $invoices->gst_total = '0.00';
                    }else{
                        $invoices->gst_persent = '15%';
                        $total_gct = $totalServiceFee * 15 / 100;
                        $invoices->gst_total = number_format($total_gct,2);
                    }
                }
                $g_total = $totalAmount + $total_gct;
                $invoices->sub_total = number_format($g_total,2);
                $invoices->grand_total = number_format($g_total - $invoices->discount_price,2);
                $invoices->invoice_detail = $invoicesArr;
                return ['status' => true,  'message' => 'Invoice detail found.','data' => $invoices];
            }else{
                return ['status' => false, 'message' => 'No enquiry found.','data' => null];
            }
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
}
