<?php
namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\GarbageCollection;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use App\Models\Package;
use App\Models\PackageRequest;
use App\Models\Appointment;
use Session;
use Auth;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;
use Razorpay\Api\Api;
use commonHelper;

class PackagesApiController extends Controller
{

    public $order_number;
    public function __construct()
    {
        $this->order_number = date("Ymd") . strtoupper(substr(uniqid(sha1(time())),0,4));

        //$this->middleware('auth')->except('thanks');
    }
    
    public function GetPackagesSearch(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $mailbox = Auth::user()->mailbox;
            $packageArr = [];
            $offset = request()->offset * 20;
            $paramsArr = [];
            $search = request()->keyword;
            if($search != ''){
                $paramsArr['packages.tracking_no'] = $search;
                //$paramsArr['users.last_name'] = $search;
                $paramsArr['packages.manifest_no'] = $search;
                $paramsArr['packages.supplier_tracking_no'] = $search;
                $paramsArr['packages.status_name'] = $search;
                //$paramsArr['packages.mailbox'] = $search;
                //$paramsArr['packages.freight_type'] = $search;
                $dataList = DB::table('packages')
                            ->where('packages.mailbox' , $mailbox)
                            ->where(function($q) use ($paramsArr)
                            {
                                foreach($paramsArr as $key => $value)
                                {
                                    if($key == 'packages.tracking_no'){
                                        $q->orWhere('packages.tracking_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.manifest_no'){
                                        $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.supplier_tracking_no'){
                                        $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.status_name'){
                                        $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                    }
                                }
                            })
                            ->skip($offset)->take(20)
                            ->get();
                if(count($dataList) > 0){
                    foreach($dataList as $row){
                        if($row->invoice != ''){
                            $row->invoice = url('/public/invoices').'/'.$row->invoice;
                        }
                        $checkInvoice = commonHelper::checkInvoice($row->tracking_no);
                        if($checkInvoice != 0){
                            $row->is_invoice = 1;
                            $row->invoice_no = $checkInvoice;
                        }else{
                            $row->is_invoice = 0;
                            $row->invoice_no = 0;
                        }
                        $packageArr[] = $row;
                    }
                    return ['status' => true,  'message' => 'User packages data found.','data' => $packageArr];
                }else{
                    return ['status' => false,  'message' => 'No data found.' , 'data'=>$packageArr];
                }
            }else{
                $dataList = DB::table('packages')
                        ->where('packages.mailbox' , $mailbox)
                        ->skip($offset)->take(20)
                        ->get();
                if(count($dataList) > 0){
                    foreach($dataList as $row){
                        if($row->invoice != ''){
                            $row->invoice = url('/public/invoices').'/'.$row->invoice;
                        }
                        $checkInvoice = commonHelper::checkInvoice($row->tracking_no);
                        if($checkInvoice != 0){
                            $row->is_invoice = 1;
                            $row->invoice_no = $checkInvoice;
                        }else{
                            $row->is_invoice = 0;
                            $row->invoice_no = 0;
                        }
                        $packageArr[] = $row;
                    }
                    return ['status' => true,  'message' => 'User packages data found.','data' => $packageArr];
                }else{
                    return ['status' => false,  'message' => 'No data found.' , 'data'=>$packageArr];
                }
            }
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function GetAllPackages(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $mailbox = Auth::user()->mailbox;
            $packageArr = [];
            $offset = request()->offset * 20;
            $dataList = DB::table('packages')
                        ->where('packages.mailbox' , $mailbox)
                        ->skip($offset)->take(20)
                        ->get();
            if(count($dataList) > 0){
                foreach($dataList as $row){
                    if($row->invoice != ''){
                        $row->invoice = url('/public/invoices').'/'.$row->invoice;
                    }
                    $checkInvoice = commonHelper::checkInvoice($row->tracking_no);
                    if($checkInvoice != 0){
                        $row->is_invoice = 1;
                        $row->invoice_no = $checkInvoice;
                    }else{
                        $row->is_invoice = 0;
                        $row->invoice_no = 0;
                    }
                    $packageArr[] = $row;
                }
                return ['status' => true,  'message' => 'User packages data found.','data' => $packageArr];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data'=>$packageArr];
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function GetDeliveryPackagesold(){
        try{
            $packageArr = [];
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $mailbox = Auth::user()->mailbox;
            //$offset = request()->offset * 20;
            $dataList = DB::table('packages')
                        ->where('mailbox' , $mailbox)
                        ->where('status' , 1)
                        ->where('packages.is_request' , 0)
                        //->skip($offset)->take(20)
                        ->get();
            if(count($dataList) > 0){
                foreach($dataList as $row){
                    if($row->invoice != ''){
                        $row->invoice = url('/public/invoices').'/'.$row->invoice;
                    }
                    $checkInvoice = commonHelper::checkInvoice($row->tracking_no);
                    if($checkInvoice != 0){
                        $row->is_invoice = 1;
                        $row->invoice_no = $checkInvoice;
                    }else{
                        $row->is_invoice = 0;
                        $row->invoice_no = 0;
                    }
                    $packageArr[] = $row;
                }
                return ['status' => true,  'message' => 'User packages data found.','data' => $packageArr];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data'=>$packageArr];
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function GetDeliveryPackages(){
        try{
            $packageArr = [];
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $mailbox = Auth::user()->mailbox;
            //$offset = request()->offset * 20;
            $dataList = DB::table('invoice_packages')
                                ->select('packages.*','users.first_name','users.location','users.address_1','package_status.name','outlets.outlet_name')
                                ->join('packages', 'invoice_packages.tracking_no', '=', 'packages.tracking_no')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                ->join('package_status', 'package_status.id', '=', 'packages.status')
                                ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('packages.status' , 1)
                                ->where('packages.is_request' , 0)
                                ->where('packages.mailbox' , $mailbox)
                                ->get();
            if(count($dataList) > 0){
                foreach($dataList as $row){
                    if($row->invoice != ''){
                        $row->invoice = url('/public/invoices').'/'.$row->invoice;
                    }
                    $row->packageInvoice = commonHelper::getPackageAmount($row->tracking_no);
                    $packageArr[] = $row;
                }
                return ['status' => true,  'message' => 'User packages data found.','data' => $packageArr];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data'=>$packageArr];
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function AddPreAlert(){
        $checkPkg = DB::table('packages')->where('supplier_tracking_no',request()->supplier_tracking_no)->first();
        if($checkPkg){
            return ['status' => false, 'message' => 'This supplier tracking number already axist. please try another.', 'data' => null];
        }
        $user_id = Auth::user()->user_id;
        $name = '';
        if (request()->hasFile('upload_invoice')) {
            $image = request()->file('upload_invoice');
            $name = time().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/invoices');
            $image->move($destinationPath, $name);
        }
        //$package_type = explode('-' , request()->package_type);
        $tracking_no = $this->generate_password(13);
        //$packages = DB::table('packages')->orderBy('packeg_id','DESC')->first();
        //dd($packages);
        //if($packages){
            //$manifest_no = $packages->manifest_no + 1;
        //}else{
            $manifest_no = '100'.$this->generate_password(3);
        //}
        $user_name = commonHelper::getUserName(Auth::user()->mailbox);
        $packages = new Package();
        $packages->tracking_no = $tracking_no;
        $packages->user_name = $user_name;
        $packages->nick_name = request()->nick_name;
        $packages->merchant = request()->merchant;
        $packages->mailbox = Auth::user()->mailbox;
        $packages->courier = request()->courier;
        $packages->supplier_tracking_no = request()->supplier_tracking_no;
        $packages->weight = request()->weight;
        $packages->price = request()->price;
        $packages->manifest_no = $manifest_no;
        $packages->invoice = $name;
        $packages->is_temprary_logs = 1;
        $packages->status = 9;
        $packages->status_name = 'PreAlert';
        $packages->item_description = request()->item_description;
        $packages->created_at = date('Y-m-d h:i:s');
        $packages->updated_at = date('Y-m-d h:i:s');
        $packages->save();
        $packages->invoice = url('/public/invoices').'/'.$name;
        return ['status' => true, 'message' => 'Pre-Alert created successfully.', 'data' => $packages];
    }
    
    public function UploadInvoice(){
        $checkPkg = DB::table('packages')->where('packeg_id',request()->packeg_id)->first();
        if($checkPkg == null){
            return ['status' => false, 'message' => 'This package not found. please try another.', 'data' => null];
        }
        $name = '';
        if (request()->hasFile('upload_invoice')) {
            $image = request()->file('upload_invoice');
            $name = time().'.'.$image->getClientOriginalExtension();
            $destinationPath = public_path('/invoices');
            $image->move($destinationPath, $name);
        }else{
            return ['status' => false, 'message' => 'Please select file.', 'data' => null];
        }
        $checkPkg = DB::table('packages')->where('packeg_id',request()->packeg_id)->update(['invoice' => $name]);
        $packages = DB::table('packages')->select('invoice')->where('packeg_id',request()->packeg_id)->first();
        $packages->invoice = url('/public/invoices').'/'.$packages->invoice;
        return ['status' => true, 'message' => 'Package invoice upload successfully.', 'data' => $packages];
    }
    
    function generate_password($length) {
        $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        return substr(str_shuffle($chars), 0, $length);
    }
    
    public function CreateDeliveryRequest(){
        $mailbox = Auth::user()->mailbox;
        $packageRequest = new PackageRequest();
        $packageRequest->mailbox = $mailbox;
        $packageRequest->name = request()->name;
        $packageRequest->phone = request()->phone;
        $packageRequest->delivery_date = request()->req_date;
        $packageRequest->delivery_time = request()->req_time;
        $packageRequest->no_of_packages = request()->no_of_packages;
        $packageRequest->package_total = request()->package_total;
        $packageRequest->packages = request()->package_ids;
        $packageRequest->notes = request()->notes;
        $packageRequest->address = request()->address;
        $packageRequest->day = request()->day;
        $packageRequest->area_id = request()->area_id;
        $packageRequest->cost = request()->cost;
        $packageRequest->save();
        
        $package_ids = explode(',' , request()->package_ids);
        if(count($package_ids) > 0){
            foreach($package_ids as $key => $val){
                Package::where('tracking_no',$val)->update(['is_request' => 1]);
            }
        }
        return ['status' => true, 'message' => 'Pick Up Request scheduled successfully.', 'data' => ''];
    }
}
