<?php
namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Response;
use Illuminate\Support\Facades\Mail;
use App\Models\Invoice;
use App\Models\Package;
use App\Models\PackageStatus;
use App\Models\Weight;
use App\Models\Setting;
use App\Models\MemberPoint;
use App\Models\User;
use App\Models\Discount;
use Yajra\DataTables\Facades\DataTables;
use Symfony\Component\Console\Input\Input;
use Session;
use Validator;
use DB;
use PDF;
use URL;
use DateTime;
use DateInterval;
use commonHelper;

class InvoiceControllor extends Controller
{

    public function __construct() {
        $this->middleware('guest', ['except' => 'logout']);
    }

    public function view(){
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Manage Invoices';
        $start_date = $_GET['start_date'];
        $end_date = $_GET['end_date'];
        $data['start_date'] = $start_date;
        $data['end_date'] = $end_date;
        if($start_date != '' && $end_date != ''){
            $invoice = DB::table('invoices')->where('invoices.email_sent' , 0)->where('invoices.invoice_type' , 1)->whereBetween('invoices.created_at', [$start_date." 00:00:00", $end_date." 23:59:59"])->get();
        }else{
            $invoice = DB::table('invoices')->where('invoices.email_sent' , 0)->where('invoices.invoice_type' , 1)->get();
        }
        $total = 0;
        if(count($invoice) > 0){
            foreach($invoice as $row){
                $totalInv = commonHelper::getAllInvoiceCount($row->invoice_id);
                $total = $total + $totalInv;
            }
        }
        $data['totalInvoice'] = number_format($total,2);
        return view("admin.invoices.list",$data);
    }
    
    public function addNew(Request $request , $tracking_no = ''){
        //return $tracking_no;
        $data['title'] = 'Create Invoice';
        $data['class'] = 'invoices';
        $data['table'] = 'Create Invoice';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $invoice = Package::where('tracking_no' , $tracking_no)->first();
        if ($request->isMethod('get')) {
            DB::table('invice_temp')->delete();
            $data['users'] = User::where('role_id' , 0)->get();
            $data['discounts'] = Discount::get();
            //dd($invoice);
            $data['invoice'] = $invoice;
            
            $packegesInvice = Package::where('tracking_no' , $tracking_no)->get();
            if(count($packegesInvice) > 0){
                foreach($packegesInvice as $row){
                    $weight = round($row->weight);
                    //$weight = $row->weight;
                    if($weight > 100){
                        $weightRes = DB::table('weights')->where('weight' , 100)->first();
                        if($weightRes){
                            $price = $weightRes->price;
                        }
                    }else{
                        $weightRes = DB::table('weights')->where('weight' , $weight)->first();
                        if($weightRes){
                            $price = $weightRes->price;
                        }
                    }
                    $row->price = $price;
                    $packagesArr[] = $row;
                }
            }
            $data['packeges'] = $packagesArr;
            return view('admin/invoices/addNew' , $data);
        }else{
            $validator = Validator::make($request->all(), [

                            ]);
            if ($validator->fails()) {
                    return redirect('admin/package/invoice/add/'.$tracking_no)
                                    ->withInput()
                                    ->withErrors($validator);
            }else{
                $invoice_no = time();
                $user_name = commonHelper::getUserName($invoice->mailbox);
                //$is_discount = isset($request->is_discount) ? 1 : 0;
                $gct = isset($request->gct) ? 1 : 0;
                // $invoice_check = Invoice::where('invoice_no' , $invoice_no)->first();
                // if($invoice_check){
                //     $invoice_no = $invoice_no;
                // }else{
                //     $invoice_no = time();
                // }
                //return $request->discount;
                if($request->discount != ''){
                    $discountRes = explode('-',$request->discount);
                    $discount_id = $discountRes[0];
                    $discount_value = $discountRes[1];
                }else{
                    $discount_id = 0;
                    $discount_value = 0;
                }
                
                $invoice_no = substr(str_shuffle('12345678912345678554678689889123456789321654987'),0,10);
                $invoices = new Invoice();
                $invoices->invoice_no = $invoice_no;
                $invoices->mailbox_no = $invoice->mailbox;
                $invoices->user_name = $user_name;
                $invoices->service_fee = 0;
                $invoices->gct = $gct;
                $invoices->discount_id = $discount_id;
                $invoices->discount_value = $discount_value;
                $invoices->status = '0';
                $invoices->created_at = date('Y-m-d h:i:s');
                $invoices->updated_at = date('Y-m-d h:i:s');
                $invoices->save();
                $invoice_id = $invoices->invoice_id;
                $item_description = $request->item_description;
                $supplier_invoice = $request->supplier_invoice;
                $custom_fee = $request->custom_fee;
                $service_fee = $request->service_fee;
                $weight = $request->weight;
                $tracking_no = $request->tracking_no;
                if(!empty($item_description)){
                    for ($i = 0; $i < count($item_description); $i++) {
                        if($weight[$i] > 100){
                            $weightRes = DB::table('weights')->where('weight' , 100)->first();
                            if($weightRes){
                                $price = $weightRes->price;
                            }
                        }else{
                            $weightRes = DB::table('weights')->where('weight' , $weight[$i])->first();
                            if($weightRes){
                                $price = $weightRes->price;
                            }
                        }
                        $pack_dataArr = array();
                        $pack_dataArr['invoice_id'] = $invoice_id;
                        $pack_dataArr['tracking_no'] = $tracking_no[$i];
                        $pack_dataArr['package_description'] = $item_description[$i];
                        $pack_dataArr['package_price'] = $price;
                        $pack_dataArr['custom_fee'] = $custom_fee[$i];
                        $pack_dataArr['service_fee'] = $service_fee[$i];
                        $pack_dataArr['package_weight'] = $weight[$i];
                        DB::table('invoice_packages')->insert($pack_dataArr);
                    }
                }
                $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
                $us_rate = DB::table('settings')->first()->us_rate;
                $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $invoice->invoice_id)->get();
                if($request->discount != ''){
                    $package_price = 0;
                    if(count($invoicesPack) > 0){
                        foreach($invoicesPack as $pack){
                            $package_price += $pack->package_price * $us_rate;
                        }
                    }
                    $discount = $package_price * $discount_value / 100;
                }else{
                    $discount = 0;
                }
                Invoice::where('invoice_id' , $invoice_id)
                        ->update([
                          'email_sent' => 1,
                          'discount_price' => $discount
                      ]);
                //End
                //Send Invoice Email
                $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
                $service_type = DB::table('service_type')->where('invoice_id' , $invoice->invoice_id)->get();
                
                $settings = DB::table('settings')->first();
                $user = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
                
                $user_name = $user->first_name.' '.$user->last_name;
                $email_subject = $settings->company_name.' invoice detail';
                $settings = DB::table('settings')->first();
                if($settings){
                    $email_from = $settings->from_email;
                }
                $settings = DB::table('settings')->first();
                $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
                $company_name = $settings->company_name;
                
                $this->send_email_invoice($user->email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name, 'invoice_print_email');
                
                //Update status Email
                $packages = Package::where('tracking_no' , $tracking_no)->first();
                $usersRes = User::where('mailbox' , $packages->mailbox)->first();
                //dd($usersRes);
                $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                $link = URL::to('/') . '/admin/dashboard';
                $settings = DB::table('settings')->first();
                $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                
                if($settings){
                    $email_from = $settings->from_email;
                }
                $name = PackageStatus::where('id' , $packages->status)->first()->name;
                $status = $name;
                if (filter_var($usersRes->email, FILTER_VALIDATE_EMAIL)) {
                    $settings = DB::table('settings')->first();
                    $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
                    $company_name = $settings->company_name;
                    $this->send_email_packeg_update($usersRes->email, $user_name,$packages->tracking_no,$packages->supplier_tracking_no,$packages->mailbox,$packages->courier,$packages->item_description,$packages->weight,$status,$email_subject, $email_from,$logo,$company_name, 'update_packege');
                }
                //Save invoice in pdf
                Package::where('tracking_no' , $tracking_no)->update(['status' => 1,'status_name'=> 'Ready for Pickup']);
                Session::flash('success_msg', 'Invoice has been added successfully.');
                return redirect('admin/packeges/logs');
            }
        }

    }
    
    public function send_email_packeg_update($email, $user_name,$tracking_no,$supplier_tracking_no,$mailbox,$courier,$item_description,$weight, $status,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $subject = $email_subject;
        $headers = "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
      //  $headers .= "From: SendX Jamaica LTD <info@sendxja.com>\n";
        $message = '<!DOCTYPE html>
                        <html lang="en">
                        <head>
                            <title>Email</title>
                            <meta charset="utf-8">
                            <meta name="viewport" content="width=device-width, initial-scale=1">
                            <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
                            <style>
                                body{
                                    overflow-x: hidden;
                                }
                                @media (max-width:1180px) {

                                }

                                @media (max-width: 767.98px) {

                                }
                                @media (max-width:812px) {
                            .email-bg{
                                       width: 90%  !important;
                                   }
                        }
                        .main_content ul {
                            width: 80% !important;
                        }
                                @media (max-width: 600px) {
                                    .main_content ul {
                            width: 96% !important;
                        }
                                   .email-bg{
                                       width: 90%  !important;
                                       padding: 10px !important;
                                   }
                                }
                                     @media (max-width:480px){
                                    .main_content ul {
                            width: 98% !important;
                            padding: 6px !important;
                            font-size: 14px;
                        }
                        .email_content p {
                            font-size: 16px !important;
                        }
                        .email-bg{
                                       width: 93%  !important;
                                       padding: 10px !important;
                                   }
                                     }
                                @media (max-width:380px){
                                  .small_text{
                                      font-size: 16px  !important;
                                  }
                                  .email_content p {
                            font-size: 16px !important;
                        }
                        .big_head {
                            font-size: 13px !important;
                            width: 25% !important;
                        }
                                }
                                @media (max-width:380px){
                                  .small_text{
                                      font-size: 12px  !important;
                                  }
                                }
                            </style>

                        </head>

                        <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
                            <main>
                                <!----- EMAIL-SECTOION-START ------>
                                <section class="email-bg"
                                    style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                                    <div class="container">
                                        <header style="border-bottom: 1px solid #ccc;">
                                            <img class="logo" src="'.$logo.'" alt="logo" style=" width:20%;">
                                        </header>
                                        <div class="email_content" style="
                                        width: 100%;
                                    ">
                                            <h4 style="font-size: 24px;margin-bottom:0;">Brand New UPDATE from '.$company_name.'</h4>
                                            <p style="font-size: 20px;">Dear '.$user_name.',</p>
                                            <p style="font-size: 20px;">Please see your package details listed below:</p>

                                                <div class="main_content" style="border-bottom: 1px solid #ccc;">
                                                    <ul style="list-style: none;width: 50%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                        <li class="big_head"style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373; vertical-align: middle;">
                                                            Supplier Tracking #
                                                        </li>
                                                        <li class="small_text" style="display: inline-block; width: 68%; padding: 0 0 10px 0; vertical-align: middle;">'.$supplier_tracking_no.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;">
                                                            Account no
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$mailbox.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Supplier
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$courier.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Weight
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$weight.' lbs</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Description
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$item_description.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Status
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$status.'</li>
                                                    </ul>
                                                </div>

                                        </div>
                                        <footer style="font-size: 14px; border-top: 1px solid #ccc;">
                                            <h4 style=" font-size: 13px;color: #8c8c8c;">Thanks for your support Enjoy your shopping experience.
                                            </h4>
                                            <p style=" font-size: 13px;color: #8c8c8c;">Best Wishes</p>
                                            <p style=" font-size: 13px;color: #8c8c8c;">'.$company_name.' Client Services</p>
                                        </footer>
                                    </div>
                                </section>
                                <!----- EMAIL-SECTOION-END ------>

                            </main>
                        </body>
                        </html>';
            $user_email = $email;
            mail($user_email,$subject,$message,$headers);
    }
    
    public function listView($type = '')
    {
        $start_date = $_GET['start_date'];
        $end_date = $_GET['end_date'];
        if($start_date != '' && $end_date != ''){
            $data = DB::table('invoices')
                        ->select('invoices.*','users.first_name','users.last_name')
                        ->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                        ->where('invoices.email_sent' , 0)
                        ->where('invoices.invoice_type' , 1)
                        ->whereBetween('invoices.created_at', [$start_date." 00:00:00", $end_date." 23:59:59"]);
        }else{
            $data = DB::table('invoices')
                        ->select('invoices.*','users.first_name','users.last_name')
                        ->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                        ->where('invoices.email_sent' , 0)->where('invoices.invoice_type' , 1);
        }
        //dd($data);
        return DataTables::of($data)
                ->editColumn('totalInv', function ($data) {
                    $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                    return $totalInv.' JMD';
                })
                ->editColumn('status', function ($data) {
                    if($data->status == '0'){
                        return 'Unpaid';
                    }
                    if($data->status == '1'){
                        return 'Unpaid';
                    }
                })
                ->editColumn('check_status', function ($data) {
                    return '<input name="check_status[]" type="checkbox"><input type="hidden" name="invoice_no[]" value="'.$data->invoice_no.'">';
                })
                ->rawColumns(['check_status' => 'check_status','action' => 'action'])
                ->addColumn('action', function($data){
                    $btn = "<a href='".url('/')."/admin/invoice/print/".$data->invoice_id."'  target='_blank'  class='all_button btn  btn-sm btn-primary' id='".$data->invoice_id."'>View PDF</a><a href='".url('/')."/admin/invoice/print/".$data->invoice_id."'  target='_blank'  class='all_button btn  btn-sm btn-primary' id='".$data->invoice_id."'>View PDF</a><a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a><a href='".url('/')."/admin/invoice/edit/".$data->invoice_id."'  class='all_button btn  btn-sm btn-info'  id='".$data->invoice_id."'>Edit</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$data->invoice_id."'>Delete</a>";
                    return $btn;
                })
                ->make(true);
    }

    public function viewEmail($status = ''){
        $data['status'] = $status;
        $start_date = $_GET['start_date'];
        $end_date = $_GET['end_date'];
        $data['start_date'] = $start_date;
        $data['end_date'] = $end_date;
        if($status == 0){
            $data['title'] = 'Manage Unpaid Invoices';
            $data['class'] = 'invoices';
            $data['table'] = 'Manage Unpaid Invoices';

            if($start_date != '' && $end_date != ''){
                $invoice = DB::table('invoices')->where('invoices.email_sent' , 1)->where('invoices.invoice_type' , 1)->where('invoices.status' , $status)->whereBetween('invoices.created_at', [$start_date." 00:00:00", $end_date." 23:59:59"])->get();
                $invoiceImount = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"),DB::raw("SUM(invoices.discount_price) as discount_price"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 0)
                            ->whereDate('invoices.created_at' ,'>=', $start_date)
                            ->whereDate('invoices.created_at' ,'<=', $end_date)
                            ->first();
                $invoiceImountGct = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 0)
                            ->whereDate('invoices.created_at' ,'>=', $start_date)
                            ->whereDate('invoices.created_at' ,'<=', $end_date)
                            ->where('invoices.gct' , 1)
                            ->first();  
            }else{
                $invoice = DB::table('invoices')->where('invoices.email_sent' , 1)->where('invoices.invoice_type' , 1)->where('invoices.status' , $status)->get();
                $invoiceImount = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"),DB::raw("SUM(invoices.discount_price) as discount_price"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 0)
                            ->first();
                $invoiceImountGct = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 0)
                            ->where('invoices.gct' , 1)
                            ->first();            

            }
            $total = 0;
            $us_rate = DB::table('settings')->first()->us_rate;
            if($invoiceImount){
                if($invoiceImount->pk_price != ''){
                    if($invoiceImountGct){
                        $ser_fee = $invoiceImountGct->ser_fee * $us_rate;
                        $gctAmount = $ser_fee * 15 / 100;
                    }else{
                        $gctAmount = 0;
                    }
                    $totalInv = ($invoiceImount->pk_price + $invoiceImount->cus_fee + $invoiceImount->ser_fee) * $us_rate;
                    $subTotal = $totalInv - $invoiceImount->discount_price;
                    $total = $total + $subTotal + $gctAmount;
                }
            }
            $data['totalInvoice'] = number_format($total,2);
            return view("admin.invoices.listEmailUnPaid",$data);
        }else{
            $data['title'] = 'Manage Paid Invoices';
            $data['class'] = 'invoices';
            $data['table'] = 'Manage Paid Invoices';
            if($start_date != '' && $end_date != ''){
                $invoice = DB::table('invoices')->where('invoices.email_sent' , 1)->where('invoices.invoice_type' , 1)->where('invoices.status' , $status)->whereBetween('invoices.created_at', [$start_date." 00:00:00", $end_date." 23:59:59"])->get();
                // $invoiceImount = DB::table('invoices')
                //             ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                //             ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                //             ->where('invoices.email_sent' , 1)
                //             ->where('invoices.status' , $status)
                //             ->where('invoices.invoice_type' , 1)
                //             ->where('invoice_packages.status' , 1)
                //             ->whereBetween('invoices.created_at', [$start_date." 00:00:00", $end_date." 23:59:59"])
                //             ->first();
                $invoiceImount = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"),DB::raw("SUM(invoices.discount_price) as discount_price"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 1)
                            ->whereDate('invoices.created_at' ,'>=', $start_date)
                            ->whereDate('invoices.created_at' ,'<=', $end_date)
                            ->first();
                $invoiceImountGct = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 1)
                            ->whereDate('invoices.created_at' ,'>=', $start_date)
                            ->whereDate('invoices.created_at' ,'<=', $end_date)
                            ->where('invoices.gct' , 1)
                            ->first();  
                
            }else{
                $invoice = DB::table('invoices')->where('invoices.email_sent' , 1)->where('invoices.invoice_type' , 1)->where('invoices.status' , $status)->get();
                $invoiceImount = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"),DB::raw("SUM(invoices.discount_price) as discount_price"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 1)
                            ->first();
                $invoiceImountGct = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoice_packages.status' , 1)
                            ->where('invoices.gct' , 1)
                            ->first();            
            }
            //dd($invoiceImountGct);
            $total = 0;
            $us_rate = DB::table('settings')->first()->us_rate;
            if($invoiceImount){
                if($invoiceImount->pk_price != ''){
                    if($invoiceImountGct){
                        $ser_fee = $invoiceImountGct->ser_fee * $us_rate;
                        $gctAmount = $ser_fee * 15 / 100;
                    }else{
                        $gctAmount = 0;
                    }
                    $totalInv = ($invoiceImount->pk_price + $invoiceImount->cus_fee + $invoiceImount->ser_fee) * $us_rate;
                    $subTotal = $totalInv - $invoiceImount->discount_price;
                    $total = $total + $subTotal + $gctAmount;
                }
            }
            $data['totalInvoice'] = number_format($total,2);
            return view("admin.invoices.listEmailPaid",$data);
        }

    }

    public function listViewEmail($status = '')
    {
        $start_date = $_GET['start_date'];
        $end_date = $_GET['end_date'];
        if(isset($_GET['outlet_id']) && $_GET['outlet_id'] != ''){
            $outlet_id = $_GET['outlet_id'];
        }else{
            $outlet_id = '';
        }
        if($status == 0){
            if($start_date != '' && $end_date != ''){
                if($outlet_id != ''){
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->whereDate('invoices.created_at' ,'>=', $start_date)
                            ->whereDate('invoices.created_at' ,'<=', $end_date)
                            //->whereBetween('invoices.created_at', [$start_date, $end_date])
                            ->where('invoices.outlet_id' , $outlet_id)
                            ->orderby('invoices.updated_at' , 'DESC');
                    
                }else{
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->whereDate('invoices.created_at' ,'>=', $start_date)
                            ->whereDate('invoices.created_at' ,'<=', $end_date)
                            //->whereBetween('invoices.created_at', [$start_date, $end_date])
                            ->orderby('invoices.updated_at' , 'DESC');
                }
                

                return DataTables::of($data)
                        ->editColumn('totalInv', function ($data) {
                            $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                            return $totalInv.' JMD';
                        })
                        ->editColumn('total_paid', function ($data) {
                            $totalPaid = commonHelper::getInvoiceCountPaid($data->invoice_id);
                            return $totalPaid.' JMD';
                        })
                        ->editColumn('status', function ($data) {
                            $setting = Setting::first();
                            $credit_points = DB::table('member_points')->where('user_id' , $data->mailbox_no)->where('status' , 0)->where('type' , 1)->sum('balance');
                            $debit_points = DB::table('member_points')->where('user_id' , $data->mailbox_no)->where('status' , 0)->where('type' , 2)->sum('balance');
                            $member_points = $credit_points - $debit_points;
                            $member_points1 = $member_points * $setting->us_rate;
                            $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                            
                            $users = User::where('mailbox' , $data->mailbox_no)->first();
                            $credit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 1)->where('type' , 1)->sum('balance');
                            $debit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 2)->sum('balance');
                            $ref_debit_points = DB::table('member_points')->where('user_id' , $data->mailbox_no)->where('status' , 0)->where('type' , 3)->sum('balance');
                            $ref_available_balance = $credit_ref_points - $debit_ref_points;
                            $available_balance = $ref_available_balance - $ref_debit_points;
                            $available_balance = $available_balance * $setting->us_rate;
                            //return '<a href="'.url('/')."/admin/invoice/update/1/".$data->invoice_id.'"><button type="button" class="btn btn-sm btn-danger"><i class="fa fa-times"></i> Unpaid</button></a>';
                            return '<a href="javascript:void(0)"><button type="button" class="btn btn-sm btn-danger paid_button" id="'.$data->invoice_id.'" member_points="'.$member_points1.'" ref_points="'.$available_balance.'" totalInv="'.str_replace(",", "", $totalInv).'"><i class="fa fa-times" ></i> Unpaid</button></a>';
                        })
                        ->rawColumns(['status' => 'status','action' => 'action'])
                        ->addColumn('action', function($data){
                            $btn = "<a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a><a href='".url('/')."/admin/invoice/edit/".$data->invoice_id."'  class='all_button btn  btn-sm btn-default'  id='".$data->invoice_id."'>Edit</a><a href='".url('/')."/admin/resend/email/".$data->invoice_id."'  class='all_button btn  btn-sm btn-info'  id='".$data->invoice_id."'>Resend Email</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$data->invoice_id."'>Delete</a>";
                            return $btn;
                        })
                        ->make(true);
            }else{
                if($outlet_id != ''){
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoices.outlet_id' , $outlet_id)
                            ->orderby('invoices.updated_at' , 'DESC');
                }else{
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->orderby('invoices.updated_at' , 'DESC');
                }
                
                return DataTables::of($data)
                        ->editColumn('totalInv', function ($data) {
                            $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                            return $totalInv.' JMD';
                        })
                        ->editColumn('total_paid', function ($data) {
                            $totalPaid = commonHelper::getInvoiceCountPaid($data->invoice_id);
                            return $totalPaid.' JMD';
                        })
                        ->editColumn('status', function ($data) {
                            $setting = Setting::first();
                            $credit_points = DB::table('member_points')->where('user_id' , $data->mailbox_no)->where('status' , 0)->where('type' , 1)->sum('balance');
                            $debit_points = DB::table('member_points')->where('user_id' , $data->mailbox_no)->where('status' , 0)->where('type' , 2)->sum('balance');
                            $member_points = $credit_points - $debit_points;
                            $member_points1 = $member_points * $setting->us_rate;
                            $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                            
                            $users = User::where('mailbox' , $data->mailbox_no)->first();
                            $credit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 1)->where('type' , 1)->sum('balance');
                            $debit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 2)->sum('balance');
                            $ref_debit_points = DB::table('member_points')->where('user_id' , $data->mailbox_no)->where('status' , 0)->where('type' , 3)->sum('balance');
                            $ref_available_balance = $credit_ref_points - $debit_ref_points;
                            $available_balance = $ref_available_balance - $ref_debit_points;
                            $available_balance = $available_balance * $setting->us_rate;
                            //return '<a href="'.url('/')."/admin/invoice/update/1/".$data->invoice_id.'"><button type="button" class="btn btn-sm btn-danger"><i class="fa fa-times"></i> Unpaid</button></a>';
                            return '<a href="javascript:void(0)"><button type="button" class="btn btn-sm btn-danger paid_button" id="'.$data->invoice_id.'" member_points="'.$member_points1.'" ref_points="'.$available_balance.'" totalInv="'.str_replace(",", "", $totalInv).'"><i class="fa fa-times" ></i> Unpaid</button></a>';
                            //return '<a href="'.url('/')."/admin/invoice/update/1/".$data->invoice_id.'"><button type="button" class="btn btn-sm btn-danger"><i class="fa fa-times"></i> Unpaid</button></a>';
                        })
                        ->rawColumns(['status' => 'status','action' => 'action'])
                        ->addColumn('action', function($data){
                            $btn = "<a href='".url('/')."/admin/invoice/print/".$data->invoice_id."'  target='_blank'  class='all_button btn  btn-sm btn-primary' id='".$data->invoice_id."'>View PDF</a><a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a><a href='".url('/')."/admin/invoice/edit/".$data->invoice_id."'  class='all_button btn  btn-sm btn-default'  id='".$data->invoice_id."'>Edit</a><a href='".url('/')."/admin/resend/email/".$data->invoice_id."'  class='all_button btn  btn-sm btn-info'  id='".$data->invoice_id."'>Resend Email</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$data->invoice_id."'>Delete</a>";
                            return $btn;
                        })
                        ->make(true);
            }
        }else{
            if($start_date != '' && $end_date != ''){
                if($outlet_id != ''){
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->whereDate('invoices.updated_at' ,'>=', $start_date)
                            ->whereDate('invoices.updated_at' ,'<=', $end_date)
                            ->where('invoices.outlet_id' , $outlet_id)
                            //->whereBetween('invoices.created_at', [$start_date, $end_date])
                            ->orderby('invoices.updated_at' , 'DESC');
                }else{
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->whereDate('invoices.updated_at' ,'>=', $start_date)
                            ->whereDate('invoices.updated_at' ,'<=', $end_date)
                            //->whereBetween('invoices.created_at', [$start_date, $end_date])
                            ->orderby('invoices.updated_at' , 'DESC');
                }
                
                return DataTables::of($data)
                        ->editColumn('totalInv', function ($data) {
                            $totalInv = commonHelper::getInvoiceCountPaid($data->invoice_id);
                            return $totalInv.' JMD';
                        })
                        ->editColumn('payment_method_new', function ($data) {
                            $totalA = commonHelper::getInvoiceCountPaid($data->invoice_id);
                            $totalInv = str_replace( ',', '', $totalA );
                            if($data->is_reward_pay == 1){
                                if($totalInv > 0){
                                    $paymentAmount = $totalInv - $data->reward_points;
                                }else{
                                    $paymentAmount = $totalInv;
                                }
                                
                            }else{
                                $paymentAmount = $totalInv;
                            }
                            $paymeny = '';
                            $paymeny .= '<span>'.$data->payment_method.'</span><br>';
                            $paymeny .= '<b>'.$paymentAmount.' JMD</b>';
                            return $paymeny;
                        })
                        ->editColumn('reward_points', function ($data) {
                            return $data->reward_points.' JMD';
                        })
                        ->editColumn('status', function ($data) {
                            return '<a href="javascript:void(0)"><button type="button" class="btn btn-sm btn-info "><i class="fa fa-check"></i> Paid</button></a>';

                        })
                        ->rawColumns(['status' => 'status','action' => 'action','payment_method_new'=>'payment_method_new'])
                        ->addColumn('action', function($data){
                            $btn = "<a href='".url('/')."/admin/invoice/print/".$data->invoice_id."'  target='_blank'  class='all_button btn  btn-sm btn-primary' id='".$data->invoice_id."'>View PDF</a><a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$data->invoice_id."'>Delete</a>";
                            return $btn;
                        })
                        ->make(true);
            }else{
                if($outlet_id != ''){
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->where('invoices.outlet_id' , $outlet_id)
                            ->orderby('invoices.updated_at' , 'DESC');
                }else{
                    $data = DB::table('invoices')
                            ->select('invoices.*')
                            //->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.status' , $status)
                            ->orderby('invoices.updated_at' , 'DESC');
                }
                
                return DataTables::of($data)
                        ->editColumn('totalInv', function ($data) {
                            $totalInv = commonHelper::getInvoiceCountPaid($data->invoice_id);
                            return $totalInv.' JMD';
                        })
                        ->editColumn('payment_method_new', function ($data) {
                            $totalA = commonHelper::getInvoiceCountPaid($data->invoice_id);
                            $totalInv = str_replace( ',', '', $totalA );
                            if($data->is_reward_pay == 1){
                                if($totalInv > 0){
                                    $paymentAmount = $totalInv - $data->reward_points;
                                }else{
                                    $paymentAmount = $totalInv;
                                }
                            }else{
                                $paymentAmount = $totalInv;
                            }
                            
                            $paymeny = '';
                            $paymeny .= '<span>'.$data->payment_method.'</span><br>';
                            $paymeny .= '<b>'.$paymentAmount.' JMD</b>';
                            return $paymeny;
                        })
                        ->editColumn('reward_points', function ($data) {
                            return $data->reward_points.' JMD';
                        })
                        ->editColumn('status', function ($data) {
                            return '<a href="javascript:void(0)"><button type="button" class="btn btn-sm btn-info "><i class="fa fa-check"></i> Paid</button></a>';

                        })
                        ->rawColumns(['status' => 'status','action' => 'action','payment_method_new'=>'payment_method_new'])
                        ->addColumn('action', function($data){
                            $btn = "<a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$data->invoice_id."'>Delete</a>";
                            return $btn;
                        })
                        ->make(true);
            }
        }
    }
    
    public function getInvoiceData(Request $request){
        $setting = Setting::first();
        $data['invoice_id'] = $request->id;
        $data['member_points'] = $request->member_points;
        $data['totalInv'] = $request->totalInv;
        $invoiceMailbox = Invoice::where('invoice_id' , $request->id)->first();
        $invoice = Invoice::where('is_reward_pay' , 1)->where('mailbox_no' , $invoiceMailbox->mailbox_no)->orderby('updated_at' , 'DESC')->first();
        //dd($invoice);
        if($invoice){
            $month = '+'.$setting->reward_use_duration.' months';
            $data['effectiveDate'] = strtotime($month, strtotime($invoice->updated_at));
            $data['effectiveDate1'] = date('Y-m-d H:i:s' , strtotime($month, strtotime($invoice->updated_at)));
        }else{
            $data['effectiveDate'] = '';
            $data['effectiveDate1'] = '';
        }
        
        $invoice1 = Invoice::where('is_referral_pay' , 1)->where('mailbox_no' , $invoiceMailbox->mailbox_no)->orderby('updated_at' , 'DESC')->first();
        //dd($invoice);
        if($invoice){
            $invoice1 = '+'.$setting->reffral_use_duration.' months';
            $data['effectiveDateRef'] = strtotime($month, strtotime($invoice->updated_at));
            $data['effectiveDateRef1'] = date('Y-m-d H:i:s' , strtotime($month, strtotime($invoice->updated_at)));
        }else{
            $data['effectiveDateRef'] = '';
            $data['effectiveDateRef1'] = '';
        }
        // $users = User::where('mailbox' , $invoiceMailbox->mailbox_no)->first();
        // $credit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 1)->where('type' , 1)->sum('balance');
        // $debit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 2)->sum('balance');
        // $data['available_balance'] = $credit_ref_points - $debit_ref_points;
        $ref_debit_points = DB::table('member_points')->where('user_id' , $invoiceMailbox->mailbox_no)->where('status' , 0)->where('type' , 3)->sum('balance');
        $data['available_balance'] = $request->ref_points - $ref_debit_points;
        return view("admin.invoices.ajaxinvoice",$data);
    }
    
    public function getMassInvoiceData(Request $request){
        $setting = Setting::first();
        $credit_points = DB::table('member_points')->where('user_id' , $request->mailbox_no)->where('status' , 0)->where('type' , 1)->sum('balance');
        $debit_points = DB::table('member_points')->where('user_id' , $request->mailbox_no)->where('status' , 0)->where('type' , 2)->sum('balance');
        $member_points = $credit_points - $debit_points;
        $member_points1 = $member_points * $setting->us_rate;
        $data['invoice_id'] = $request->mailbox;
        $data['member_points'] = $member_points1;
        $data['totalInv'] = $request->package_total;
        $invoice = Invoice::where('is_reward_pay' , 1)->where('mailbox_no' , $request->mailbox)->orderby('updated_at' , 'DESC')->first();
        //dd($invoice);
        if($invoice){
            $month = '+'.$setting->reward_use_duration.' months';
            $data['effectiveDate'] = strtotime($month, strtotime($invoice->updated_at));
            $data['effectiveDate1'] = date('Y-m-d H:i:s' , strtotime($month, strtotime($invoice->updated_at)));
        }else{
            $data['effectiveDate'] = '';
            $data['effectiveDate1'] = '';
        }
        
        $invoice1 = Invoice::where('is_referral_pay' , 1)->where('mailbox_no' , $request->mailbox)->orderby('updated_at' , 'DESC')->first();
        //dd($invoice);
        if($invoice){
            $invoice1 = '+'.$setting->reffral_use_duration.' months';
            $data['effectiveDateRef'] = strtotime($month, strtotime($invoice1->updated_at));
            $data['effectiveDateRef1'] = date('Y-m-d H:i:s' , strtotime($month, strtotime($invoice1->updated_at)));
        }else{
            $data['effectiveDateRef'] = '';
            $data['effectiveDateRef1'] = '';
        }
        //return $request->mailbox;
        $users = User::where('mailbox' , $request->mailbox)->first();
        // $credit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 1)->where('type' , 1)->sum('balance');
        // $debit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 2)->sum('balance');
        // $data['available_balance'] = $credit_ref_points - $debit_ref_points;
        // $ref_debit_points = DB::table('member_points')->where('user_id' , $request->mailbox)->where('status' , 0)->where('type' , 3)->sum('balance');
        $credit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 1)->where('type' , 1)->sum('balance');
        $debit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 2)->sum('balance');
        $ref_debit_points = DB::table('member_points')->where('user_id' , $request->mailbox)->where('status' , 0)->where('type' , 3)->sum('balance');
        $ref_available_balance = $credit_ref_points - $debit_ref_points;
        $available_balance = $ref_available_balance - $ref_debit_points;
        $available_balance = $available_balance * $setting->us_rate;
        $data['available_balance'] = $available_balance;
        return view("admin.invoices.ajaxmassinvoice",$data);
    }

    public function viewMassPayments(Request $request){
        $data['title'] = 'Manage Mass Payments';
        $data['class'] = 'invoices';
        $data['table'] = 'Manage Mass Payments';
        $data['users'] = User::where('role_id' , 0)->get();
        if ($request->isMethod('get')) {
            $data['start_date'] = '';
            $data['end_date'] = '';
            $data['mailbox'] = '';
            $data['invoice_no'] = '';
            $data['invoices'] = [];
                // $data['invoices'] = DB::table('invoices')
                //             ->select('invoices.*')
                //             ->where('invoices.email_sent' , 1)
                //             ->where('invoices.invoice_type' , 1)
                //             ->where('invoices.status' , 0)
                //             ->orderby('invoices.updated_at' , 'DESC')->paginate(30);
            return view("admin.invoices.listMassPayments",$data);
        }else{
            $mailbox = $request->mailbox;
            $invoice_no = $request->invoice_no;
            $data['start_date'] = $request->start_date;
            $data['end_date'] = $request->end_date;
            $data['mailbox'] = $mailbox;
            $data['invoice_no'] = $invoice_no;
            $paramsArr = [];
            if($request->start_date != '' && $request->end_date != ''){
                $currentdate = date('Y-m-d', strtotime($request->end_date));
                $enddate = date('Y-m-d', strtotime($request->start_date));
                //$paramsArr['invoices.created_at'] = [$enddate,$currentdate];
                $paramsArr['invoices.created_at'] = [$enddate." 00:00:00", $currentdate." 23:59:59"];
            }
            if($mailbox != ''){
                $paramsArr['invoices.mailbox_no'] = $mailbox;
            }
            if($invoice_no != ''){
                $paramsArr['invoices.invoice_no'] = $invoice_no;
            }
            if(count($paramsArr) > 0){
                $data['invoices'] = DB::table('invoices')
                             ->select('invoices.*')
                             ->where(function($q) use ($paramsArr)
                            {
                                foreach($paramsArr as $key => $value)
                                {
                                    if($key == 'invoices.created_at'){
                                        $q->whereBetween('invoices.created_at', $value);
                                    }elseif($key == 'invoices.mailbox_no'){
                                        $q->where('invoices.mailbox_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'invoices.invoice_no'){
                                        $q->where('invoices.invoice_no', $value);
                                    }
                                }
                            })
                             ->where('invoices.email_sent' , 1)
                             ->where('invoices.invoice_type' , 1)
                             ->where('invoices.status' , 0)
                             ->orderby('invoices.updated_at' , 'DESC')
                             ->paginate(30);
            }else{
                $data['invoices'] = DB::table('invoices')
                            ->select('invoices.*')
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , 0)
                            ->orderby('invoices.updated_at' , 'DESC')->paginate(30);
            }
            return view("admin.invoices.listMassPayments",$data);
        }

    }
    
    
    public function payMassPayments(Request $request){
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Manage Invoices';
        $package_ids = explode(',' , $request->package_ids);
        $invoice_ids = array_unique(explode(',' , $request->invoice_ids));
        //dd($invoice_ids[0]);
        //return $request->is_reward_pay;
        if($request->is_reward_pay == ''){
            $is_reward_pay = 0;
        }else{
            $is_reward_pay = 1;
        }
        if($request->is_referral_pay == ''){
            $is_referral_pay = 0;
        }else{
            $is_referral_pay = 1;
        }
        $setting = Setting::first();
        $invoice_id = $request->id;
        $checkInvoice = Invoice::where('invoice_id' , $invoice_ids[0])->first();
        Invoice::where('invoice_id' , $invoice_ids[0])->update(['status' => 1,'payment_method' => $request->payment_method,'is_reward_pay' => $is_reward_pay,'reward_points' => $request->reward_point,'is_referral_pay' => $is_referral_pay,'referral_points' => $request->referral_points,'updated_at'=>date('Y-m-d H:i:s')]);
        if($is_reward_pay == 1){
            $reward_point = $request->reward_point / $setting->us_rate;
            $this->addDebitNoteRefPoints($invoice_ids[0],$checkInvoice->mailbox_no,$reward_point);
        }
        
        if($is_referral_pay == 1){
            $referral_points = $request->referral_points / $setting->us_rate;
            $this->addDebitNotePoints($invoice_ids[0],$checkInvoice->mailbox_no,$referral_points);
        }
        $invoice = Invoice::with(['getInvoicePackage','getUser'])->whereIn('invoice_id' , $invoice_ids)->get();
        //dd($invoice);
        $data['invoice'] = $invoice;
        if(count($package_ids) > 0){
            foreach($package_ids as $key => $val){
                $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $val)->update(['status' => 1]);
                Package::where('tracking_no', $val)
                  ->update([
                    'status' => 12,
                    'status_name' => 'DELIVERED'
                ]);
                
                $totalWeight = 0;
                $pkg = Package::where('tracking_no', $val)->first();
                if($pkg){
                    $totalWeight = $pkg->weight;
                }else{
                    $totalWeight = 0;
                }
                //For reward points
                $packageArray = [];
                $packageObject = (object) array();
                $checkTransactionsDB = DB::table('transactions')->where('mailbox' , $checkInvoice->mailbox_no)->first();
                //dd($checkTransactionsDB);
                if($checkTransactionsDB){
                    $totalWeight = $totalWeight + $checkTransactionsDB->weight;
                    $packageObject->id = $val;
                    $packageObject->weight = $totalWeight;
                    $packageArray[] = $packageObject;
                    $package_ids = json_decode($checkTransactionsDB->package_ids);
                    if($package_ids != ''){
                        $pkgArray = array_merge($package_ids,$packageArray);
                    }else{
                        $pkgArray = $packageArray;
                    }
                    
                    DB::table('transactions')->where('id' , $checkTransactionsDB->id)->update(['package_ids' => json_encode($pkgArray,true),'weight' => $totalWeight]);
                }else{
                    $packageObject->id = $val;
                    $packageObject->weight = $totalWeight;
                    $packageArray[] = $packageObject;
                    $totalWeight = $totalWeight;
                    DB::table('transactions')->insert(['package_ids' => json_encode($packageArray,true),'mailbox' => $checkInvoice->mailbox_no , 'weight' => $totalWeight]);
                }
                
                
                $transactions = DB::table('transactions')->where('mailbox' , $checkInvoice->mailbox_no)->sum('weight');
                if($transactions >= $setting->reward_packages || $totalWeight >= $setting->reward_weight){
                    $reward_points = $setting->reward_amount;
                    $this->addCreditNotePoints($checkInvoice->invoice_id , $checkInvoice->mailbox_no , $reward_points);
                    $remainWeight = $totalWeight - $setting->reward_packages;
                    $checkTransactions = DB::table('transactions')->where('mailbox' , $checkInvoice->mailbox_no)->update(['package_ids' => '' , 'weight' => $remainWeight]);
                    //DB::table('transactions')->delete();
                }
                
                //For referral points
                $users = User::where('mailbox' , $checkInvoice->mailbox_no)->first();
                
                $check_ref_points = DB::table('member_referral_points')->where('user_id' , $users->user_id)->where('status' , 0)->where('type' , 1)->first();
                if($check_ref_points){
                    $usersRef = User::where('mailbox' , $users->ref_by)->first();
                    $totalWeight = 0;
                    $pkg = Package::where('tracking_no', $val)->first();
                    if($pkg){
                        $totalWeight = $pkg->weight;
                    }else{
                        $totalWeight = 0;
                    }
                    $checkTransactionsDBrf = DB::table('transactions_referral')->where('mailbox' , $checkInvoice->mailbox_no)->first();
                    if($checkTransactionsDBrf){
                        $totalWeight = $totalWeight + $checkTransactionsDBrf->weight;
                        DB::table('transactions_referral')->where('id' , $checkTransactionsDBrf->id)->update(['weight' => $totalWeight]);
                    }else{
                        $totalWeight = $totalWeight;
                        DB::table('transactions_referral')->insert(['mailbox' => $checkInvoice->mailbox_no , 'weight' => $totalWeight]);
                    }
                    $transactionsrf = DB::table('transactions_referral')->where('mailbox' , $checkInvoice->mailbox_no)->sum('weight');
                    if($transactionsrf >= $setting->reffral_packages || $totalWeight >= $setting->reffral_weight){
                        $reward_points = $setting->reward_amount;
                        DB::table('member_referral_points')->insert(['from_user_id' => $check_ref_points->from_user_id ,'user_id' => $users->user_id , 'balance'=> $check_ref_points->balance,'type'=> 2,'status'=> 1,  'created_at' => date('Y-m-d h:i:s'), 'updated_at' => date('Y-m-d h:i:s')]);
                        DB::table('member_referral_points')->where('id' , $check_ref_points->id)->update(['status' => 1]);
                        // $reward_points = $setting->reward_amount;
                        // $this->addCreditNotePoints($checkInvoice->invoice_id , $checkInvoice->mailbox_no , $reward_points);
                        $remainWeight = $totalWeight - $setting->reffral_packages;
                        $checkTransactions = DB::table('transactions_referral')->where('mailbox' , $checkInvoice->mailbox_no)->update(['weight' => 50]);
                        //DB::table('transactions')->delete();
                    }
                }
            }
        }

        if(count($invoice_ids) > 0){
            foreach($invoice_ids as $keyInv => $valInv){
                $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $valInv)->where('status' , 0)->count();
                if($invoicesPack == 0){
                    Invoice::where('invoice_id' , $valInv)->update(['status' => 1,'updated_at'=>date('Y-m-d H:i:s')]);
                }
            }

        }
        // if(count($invoice) >0){
        //     foreach($invoice as $row){
        //         $user = $row->getInvoicePackage;
        //         dd($user);
        //     }
        // }
        
        $data['settings'] = DB::table('settings')->first();
        $us_rate = DB::table('settings')->first()->us_rate;
        $data['usRate'] = $us_rate;
        return view("admin.invoices.invoice-mass",$data);
        // Session::flash('success_msg', 'Invoice status changed to paid successfully.');
        // return redirect('admin/invoices/mass/payments/0?start_date=&end_date=');
    }

    public function listViewMassPayments($status = '')
    {
        $start_date = $_GET['start_date'];
        $end_date = $_GET['end_date'];
        if($start_date != '' && $end_date != ''){
            $data = DB::table('invoices')
                        ->select('invoices.*','users.first_name','users.last_name')
                        ->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                        ->where('invoices.email_sent' , 1)
                        ->where('invoices.invoice_type' , 1)
                        ->where('invoices.status' , $status)
                        ->whereBetween('invoices.created_at', [$start_date." 00:00:00", $end_date." 23:59:59"])
                        ->orderby('invoices.updated_at' , 'DESC');

            return DataTables::of($data)
                    ->editColumn('totalInv', function ($data) {
                        $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                        return $totalInv.' JMD';
                    })
                    ->editColumn('total_paid', function ($data) {
                        $totalPaid = commonHelper::getInvoiceCountPaid($data->invoice_id);
                        return $totalPaid.' JMD';
                    })
                    ->editColumn('status', function ($data) {
                        return '<a href="'.url('/')."/admin/invoice/update/1/".$data->invoice_id.'"><button type="button" class="btn btn-sm btn-danger"><i class="fa fa-times"></i> Unpaid</button></a>';
                    })
                    ->rawColumns(['status' => 'status','action' => 'action'])
                    ->addColumn('action', function($data){
                        //$btn = "<a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a><a href='".url('/')."/admin/resend/email/".$data->invoice_id."'  class='all_button btn  btn-sm btn-info'  id='".$data->invoice_id."'>Resend Email</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$data->invoice_id."'>Delete</a>";
                        $btn = "<a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a>";
                        return $btn;
                    })
                    ->make(true);
        }else{
            $data = DB::table('invoices')
                        ->select('invoices.*','users.first_name','users.last_name')
                        ->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                        ->where('invoices.email_sent' , 1)
                        ->where('invoices.invoice_type' , 1)
                        ->where('invoices.status' , $status)
                        ->orderby('invoices.updated_at' , 'DESC');;
            return DataTables::of($data)
                    ->editColumn('totalInv', function ($data) {
                        $totalInv = commonHelper::getInvoiceCount($data->invoice_id);
                        return $totalInv.' JMD';
                    })
                    ->editColumn('total_paid', function ($data) {
                        $totalPaid = commonHelper::getInvoiceCountPaid($data->invoice_id);
                        return $totalPaid.' JMD';
                    })
                    ->editColumn('status', function ($data) {
                        return '<a href="'.url('/')."/admin/invoice/update/1/".$data->invoice_id.'"><button type="button" class="btn btn-sm btn-danger"><i class="fa fa-times"></i> Unpaid</button></a>';
                    })
                    ->rawColumns(['status' => 'status','action' => 'action'])
                    ->addColumn('action', function($data){
                        $btn = "<a href='".url('/')."/admin/invoice/".$data->invoice_no."'  class='all_button btn  btn-sm btn-warning'  id='".$data->invoice_id."'>Invoice Detail</a>";
                        return $btn;
                    })
                    ->make(true);
        }
    }

    public function userInvoices(){
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'account';
        $data['table'] = 'Manage Invoices';
        $mailbox = Session::get('mailbox');
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $data['invoices'] = DB::table('invoices')
                                ->select('invoices.*','users.first_name','users.last_name')
                                ->join('users', 'users.mailbox', '=', 'invoices.mailbox_no')
                                ->where('invoices.mailbox_no' , $mailbox)
                                ->get();
        return view('admin/invoices/user_index' , $data);
    }

    public function create(Request $request){
        $data['title'] = 'Create Invoice';
        $data['class'] = 'invoices';
        $data['table'] = 'Create Invoice';
        $mailbox = Session::get('mailbox');
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        
        $data['discounts'] = Discount::get();
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            DB::table('invice_temp')->delete();
            Session::put('mailbox' , '');
            $data['users'] = User::where('role_id' , 0)->get();
            return view('admin/invoices/create' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                                    'mailbox' => 'required',
                                    'tracking_no' => 'required',
                                    'service_fee' => 'required'
                            ]);
            if ($validator->fails()) {
                    return redirect('admin/invoice/add')
                                    ->withInput()
                                    ->withErrors($validator);
            }else{

//                $weightUpdate = Package::where('tracking_no' , $request->tracking_no)->update(['weight' => $request->weight]);
//                $weight = $request->weight;
//                $location = User::where('mailbox' , $request->mailbox)->first()->location;
//                $supplier_invoice = $request->supplier_invoice;
//                if($weight == '0.5'){
//                    $actuallWeight = $weight;
//                }else{
//                    $actuallWeight = round($weight);
//                }
                //echo $service_fee;exit;
                $user_name = commonHelper::getUserName($request->mailbox);
                $gct = isset($request->gct) ? 1 : 0;
                $invoices = new Invoice();
                $invoices->invoice_no = time();
                $invoices->mailbox_no = $request->mailbox;
                $invoices->user_name = $user_name;
                $invoices->service_fee = 0;
                $invoices->gct = $gct;
                $invoices->status = '0';
                $invoices->created_at = date('Y-m-d h:i:s');
                $invoices->updated_at = date('Y-m-d h:i:s');
                $invoices->save();
                $invoice_id = $invoices->invoice_id;
                $item_description = $request->item_description;
                $supplier_invoice = $request->supplier_invoice;
                $custom_fee = $request->custom_fee;
                $service_fee = $request->service_fee;
                $weight = $request->weight;
                $tracking_no = $request->tracking_no;
                if(!empty($item_description)){
                    for ($i = 0; $i < count($item_description); $i++) {
                        $pack_dataArr = array();
                        $pack_dataArr['invoice_id'] = $invoice_id;
                        $pack_dataArr['tracking_no'] = $tracking_no[$i];
                        $pack_dataArr['package_description'] = $item_description[$i];
                        $pack_dataArr['package_price'] = $supplier_invoice[$i];
                        $pack_dataArr['custom_fee'] = $custom_fee[$i];
                        $pack_dataArr['service_fee'] = $service_fee[$i];
                        $pack_dataArr['package_weight'] = $weight[$i];
                        if($item_description[$i]){
                            DB::table('invoice_packages')->insert($pack_dataArr);
                        }
                    }
                }
                // $name = $request->name;
                // $custome_fee = $request->custome_fee;
                // if(!empty($name)){
                //     for ($i = 0; $i < count($name); $i++) {
                //         $service_dataArr = array();
                //         $service_dataArr['invoice_id'] = $invoice_id;
                //         $service_dataArr['name'] = $name[$i];
                //         $service_dataArr['service_fee'] = $custome_fee[$i];
                //         if($name[$i]){
                //             DB::table('service_type')->insert($service_dataArr);
                //         }
                //     }
                // }



                //Save invoice in pdf
                $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
                $data['invoice'] = $invoice;
                $data['service_type'] = DB::table('service_type')->where('invoice_id' , $invoice_id)->get();
                $data['invoicesPack'] = DB::table('invoice_packages')->join('packages', 'invoice_packages.tracking_no', '=', 'packages.tracking_no')->where('invoice_id' , $invoice->invoice_id)->where('invoice_packages.status',0)->get();
                $data['settings'] = DB::table('settings')->first();
                $data['user'] = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
                $us_rate = DB::table('settings')->first()->us_rate;
                $data['usRate'] = $us_rate;
                //dd($data);
                $unique = time().'_invoice.pdf';
                //view('admin/invoices/invoice_print_pdf' , $data);
                $pdfpathforgenerate = 'invoices/'.$unique;
                //$pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data);
                //$pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data)->save($pdfpathforgenerate);
                Invoice::where('invoice_id' , $invoice_id)->update(['pdf_invoice' => $unique]);

                return redirect('admin/invoices?start_date=&end_date=');
            }
        }
    }

    public function findPackeg(Request $request){
        $data['title'] = 'Create Invoice';
        $data['class'] = 'invoices';
        $data['table'] = 'Create Invoice';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            $mailbox = Session::get('mailbox');
            $usersRes = Package::where('mailbox' , $mailbox)->get();
            //dd($usersRes);
            $data['packeges'] = $usersRes;
            $data['mailbox'] = $mailbox;
            return view('admin/invoices/create1' , $data);
        }else{
            $mailbox = $request->mailbox;
            Session::put('mailbox' , $mailbox);
            $usersRes = Package::where('mailbox' , $mailbox)->get();
            $data['packeges'] = $usersRes;
            $data['mailbox'] = $mailbox;
            return view('admin/invoices/create1' , $data);
        }
    }

    public function createInvoice(Request $request){
        $data['title'] = 'Create Invoice';
        $data['class'] = 'invoices';
        $data['table'] = 'Create Invoice';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $mailbox = $request->mailbox;
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            $usersRes = Package::where('mailbox' , $mailbox)->get();
            $data['packeges'] = $usersRes;
            $data['mailbox'] = $mailbox;
            $data['total_rows'] = Session::get('total_rows');
            return view('admin/invoices/create2' , $data);
        }else{
            $invoices = new Invoice();
            $invoices->invoice_no = time();
            $invoices->tracking_no = $request->tracking_no;
            $invoices->mailbox_no = $request->mailbox_no;
            $invoices->type = $request->type;
            $invoices->gct = $request->gct;
            $invoices->weight = $request->weight;
            $invoices->processing_fee = $request->processing_fee;
            $invoices->CAF = $request->CAF;
            $invoices->ENV_levy = $request->ENV_levy;
            $invoices->service_fee = $request->service_fee;
            $invoices->SCF = $request->SCF;
            $invoices->status = '0';
            $invoices->added_by = $user_id;
            $invoices->created_at = date('Y-m-d h:i:s');
            $invoices->updated_at = date('Y-m-d h:i:s');
            $invoices->save();
            return redirect('admin/invoices?start_date=&end_date=');
        }
    }

    public function submitInvoice(Request $request){
        $data['title'] = 'Create Invoice';
        $data['class'] = 'invoices';
        $data['table'] = 'Create Invoice';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $invoices = new Invoice();
        $invoices->invoice_no = time();
        $invoices->tracking_no = $request->tracking_no;
        $invoices->mailbox_no = $request->mailbox_no;
        $invoices->type = $request->type;
        $invoices->gct = $request->gct;
        $invoices->status = '0';
        $invoices->added_by = $user_id;
        $invoices->created_at = date('Y-m-d h:i:s');
        $invoices->updated_at = date('Y-m-d h:i:s');
        $invoices->save();
        $invoice_no = $invoices->invoice_no;
        $name = $request->name;
        $usd = $request->usd;
        $jmd = $request->jmd;
        if(!empty($name)){
            for ($i = 0; $i < count($name); $i++) {
                $service_dataArr = array();
                $service_dataArr['invoice_no'] = $invoice_no;
                $service_dataArr['name'] = $name[$i];
                $service_dataArr['usd'] = $usd[$i];
                $service_dataArr['jmd'] = $jmd[$i];
                $service_dataArr['created_at'] = date('Y-m-d h:i:s');
                $service_dataArr['updated_at'] = date('Y-m-d h:i:s');
                if($name[$i]){
                    DB::table('service_type')->insert($service_dataArr);
                }
            }
        }
        return redirect('admin/invoices?start_date=&end_date=');
    }

    public function edit(Request $request , $invoice_id = ''){
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Edit Invoices';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            DB::table('invice_temp')->delete();
            $data['users'] = User::where('role_id' , 0)->get();
            $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
            $data['invoice'] = $invoice;
            $data['service_type'] = DB::table('service_type')->where('invoice_id' , $invoice_id)->get();
            $data['invoice_packages'] = DB::table('invoice_packages')->where('invoice_id' , $invoice_id)->get();

            //DB::table('invice_temp')->insert(['mailbox' => $packages->mailbox,'tracking_no' => $packages->tracking_no,'price' => $price,'weight' => $packages->weight,'description' => $packages->item_description]);
            $data['packagesInv'] = DB::table('invice_temp')->where('mailbox' , $invoice->mailbox_no)->get();
            //dd($data['package']);
            $packegesInvice = Package::where('mailbox' , $invoice->mailbox_no)->get();
            if(count($packegesInvice) > 0){
                $packagesArr = [];
                foreach($packegesInvice as $row){

                    $invoices = DB::table('invice_temp')->where('tracking_no' , $row->tracking_no)->first();
                    if($invoices == null){
                        $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $row->tracking_no)->first();
                        if($invoicesPack == null){
                            $packagesArr[] = $row;
                        }
                    }
                }
                if(count($packagesArr) > 0){
                    $data['packeges'] = $packagesArr;
                }else{
                    $data['packeges'] = $packagesArr;
                }
            }
            return view('admin/invoices/edit' , $data);
        }else{
            $validator = Validator::make($request->all(), [

                            ]);
            if ($validator->fails()) {
                    return redirect('admin/invoice/edit/'.$invoice_id)
                                    ->withInput()
                                    ->withErrors($validator);
            }else{
                $gct = isset($request->gct) ? 1 : 0;

                Invoice::where('invoice_id', $invoice_id)
                        ->update([
                                'gct' => $gct,
                                //'service_fee' => $request->service_fee,
                            ]);
                $item_description = $request->item_description;
                $supplier_invoice = $request->supplier_invoice;
                $custom_fee = $request->custom_fee;
                $service_fee = $request->service_fee;
                $weight = $request->weight;
                //dd($weight);
                $tracking_no = $request->tracking_no;
                //dd($weight);
                if(!empty($item_description)){
                    DB::table('invoice_packages')->where('invoice_id' , $invoice_id)->delete();
                    for ($i = 0; $i < count($item_description); $i++) {
                        //return $weight[$i];
                        //$weight = $weight[$i];
                        $weight = $weight[$i];
                        if($weight > 100){
                            $weightRes = DB::table('weights')->where('weight' , 100)->first();
                            if($weightRes){
                                $price = $weightRes->price;
                            }
                        }else{
                            if($weight < 1){
                                $weightRes = DB::table('weights')->where('weight' , 1)->first();
                                if($weightRes){
                                    $price = $weightRes->price;
                                }
                            }else{
                                $weightRes = DB::table('weights')->where('weight' , $weight)->first();
                                if($weightRes){
                                    $price = $weightRes->price;
                                }
                            }
                            
                        }
                        $pack_dataArr = array();
                        $pack_dataArr['invoice_id'] = $invoice_id;
                        $pack_dataArr['tracking_no'] = $tracking_no[$i];
                        $pack_dataArr['package_description'] = $item_description[$i];
                        $pack_dataArr['package_price'] = $price;
                        $pack_dataArr['custom_fee'] = $custom_fee[$i];
                        $pack_dataArr['service_fee'] = $service_fee[$i];
                        $pack_dataArr['package_weight'] = $weight[$i];
                        DB::table('invoice_packages')->insert($pack_dataArr);
                    }
                }
                // $name = $request->name;
                // $custome_fee = $request->custome_fee;
                // if(!empty($name)){
                //     DB::table('service_type')->where('invoice_id' , $invoice_id)->delete();
                //     for ($i = 0; $i < count($name); $i++) {
                //         $service_dataArr = array();
                //         $service_dataArr['invoice_id'] = $invoice_id;
                //         $service_dataArr['name'] = $name[$i];
                //         $service_dataArr['service_fee'] = $custome_fee[$i];
                //         if($name[$i]){
                //             DB::table('service_type')->insert($service_dataArr);
                //         }
                //     }
                // }
                //Save invoice in pdf
                $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
                $data['invoice'] = $invoice;
                $data['service_type'] = DB::table('service_type')->where('invoice_id' , $invoice_id)->get();
                $data['invoicesPack'] = DB::table('invoice_packages')->where('invoice_id' , $invoice_id)->get();
                $data['settings'] = DB::table('settings')->first();
                $data['user'] = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
                $us_rate = DB::table('settings')->first()->us_rate;
                $data['usRate'] = $us_rate;
                $unique = time().'_invoice.pdf';
                //return view('admin/invoices/invoice_print_pdf' , $data);
                $pdfpathforgenerate = 'invoices/'.$unique;
                //$pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data);
               // $pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data)->save($pdfpathforgenerate);
                Invoice::where('invoice_id' , $invoice_id)->update(['pdf_invoice' => $unique]);
                Session::flash('success_msg', 'Invoice has been updated successfully.');
                return redirect('admin/invoices?start_date=&end_date=');
            }
        }

    }

    public function invoice($invoice_no = ''){
        //return $invoice_no;
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Manage Invoices';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $invoice = Invoice::where('invoice_no' , $invoice_no)->first();
        $data['invoice'] = $invoice;
        if($invoice->status == 1){
            $data['invoicesPack'] = DB::table('invoice_packages')->join('packages', 'invoice_packages.tracking_no', '=', 'packages.tracking_no')->where('invoice_id' , $invoice->invoice_id)->where('invoice_packages.status',1)->get();
        }else{
            $data['invoicesPack'] = DB::table('invoice_packages')->join('packages', 'invoice_packages.tracking_no', '=', 'packages.tracking_no')->where('invoice_id' , $invoice->invoice_id)->where('invoice_packages.status',0)->get();
        }
        
        $data['service_type'] = DB::table('service_type')->where('invoice_id' , $invoice->invoice_id)->get();
        $data['settings'] = DB::table('settings')->first();
        $data['user'] = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
        $us_rate = DB::table('settings')->first()->us_rate;
        $data['usRate'] = $us_rate;
        return view('admin/invoices/invoice' , $data);
    }

    

    public function delete() {
        $delete = DB::table('invoice_packages')->where('invoice_id' , request()->id)->delete();
        $delete = Invoice::where('invoice_id' , request()->id)->delete();
        return ["status" => true,"message" =>"Invoice deleted successfully"];
    }

    public function sendInvoice(Request $request){
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Manage Invoices';
        $invoice_no = $request->invoice_no;
        $check_status = $request->check_status;
        //dd($check_status);
        if(count($check_status) > 0){
            for($i = 0; $i<count($check_status); $i++){
                $invoice = Invoice::where('invoice_no' , $invoice_no[$i])->first();
                $service_type = DB::table('service_type')->where('invoice_id' , $invoice->invoice_id)->get();
                $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $invoice->invoice_id)->get();
                $settings = DB::table('settings')->first();
                $user = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
                $us_rate = DB::table('settings')->first()->us_rate;
                $user_name = $user->first_name.' '.$user->last_name;
                $email_subject = $settings->company_name.' invoice detail';
                $settings = DB::table('settings')->first();
                if($settings){
                    $email_from = $settings->from_email;
                }
                $settings = DB::table('settings')->first();
                $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
                $company_name = $settings->company_name;
                $this->send_email_invoice($user->email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name, 'invoice_print_email');
                Invoice::where('invoice_no' , $invoice_no[$i])
                        ->update([
                          'email_sent' => 1
                      ]);
            }
            Session::flash('success_msg', 'Invoice has been sent successfully.');
            return redirect('admin/invoices?start_date=&end_date=');
        }else{
            Session::flash('success_msg', 'Please select invoice first.');
            return redirect('admin/invoices?start_date=&end_date=');
        }
        

    }

    public function resendInvoice($invoice_id = ''){
        $data['title'] = 'Manage Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Manage Invoices';
        $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
        $service_type = DB::table('service_type')->where('invoice_id' , $invoice->invoice_id)->get();
        $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $invoice->invoice_id)->get();
        $settings = DB::table('settings')->first();
        $user = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
        $us_rate = DB::table('settings')->first()->us_rate;
        $user_name = $user->first_name.' '.$user->last_name;
        $email_subject = $settings->company_name.' invoice detail';
        $settings = DB::table('settings')->first();
        if($settings){
            $email_from = $settings->from_email;
        }
        $settings = DB::table('settings')->first();
            $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
            $company_name = $settings->company_name;
            $this->send_email_invoice($user->email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name, 'invoice_print_email');
        Invoice::where('invoice_id' , $invoice_id)
                ->update([
                  'email_sent' => 1
              ]);
        $status = $invoice->status;
        Session::flash('success_msg', 'Invoice has been sent successfully.');
        return redirect('admin/invoices/email/'.$status.'?start_date=&end_date=');

    }

    public function exportInvoice( Request $request )
    {
        $data['title'] = 'Export Invoices';
        $data['class'] = 'invoices';
        $data['table'] = 'Export Invoices';

        $role_id = Session::get('role_id');
        $user_id = Session::get('user_id');

        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();

        $data['settings'] = DB::table( 'settings' )->first();

        // set default dates week period
        $date = new DateTime( 'now' );
        $data[ 's' ][ 'start_date' ] = $date->format( 'm/d/Y' );
        $date->add( new DateInterval( 'P7D' ) );
        $data[ 's' ][ 'end_date' ] = $date->format( 'm/d/Y' );

        // set default search values
        $data[ 's' ][ 'invoice_no' ] = null;
        $data[ 's' ][ 'tracking_no' ] = null;
        $data[ 's' ][ 'mailbox_no' ] = null;
        $data[ 's' ][ 'price' ] = null;
        $data[ 's' ][ 'type' ] = null;

        // default invoices results
        $data[ 'invoices' ] = [];

        // serach for invoices
        if ( $request->isMethod( 'post' ) && $request->input( 'search' ) == 1 )
        {
            // get search date period
            $data[ 's' ][ 'start_date' ] = $request->input( 'start_date' );
            $start_date = date( 'Y-m-d', strtotime( $data[ 's' ][ 'start_date' ] ) );

            $data[ 's' ][ 'end_date' ] = $request->input( 'end_date' );
            $end_date = date( 'Y-m-d', strtotime( $data[ 's' ][ 'end_date' ] ) );

            // get search values
            $data[ 's' ][ 'invoice_no' ] = $request->input( 'invoice_no' );
            $data[ 's' ][ 'tracking_no' ] = $request->input( 'tracking_no' );
            $data[ 's' ][ 'mailbox_no' ] = $request->input( 'mailbox_no' );
            $data[ 's' ][ 'price' ] = $request->input( 'price' );
            $data[ 's' ][ 'type' ] = $request->input( 'type' );

            // build search query and get results
            $sql = 'SELECT
                I.invoice_no AS invoice_no,
                I.invoice_id AS invoice_id,
                U.first_name AS first_name,
                U.last_name AS last_name,
                I.email_sent AS email_sent,
                I.created_at AS created_at
            FROM invoices AS I JOIN users AS U ON U.mailbox = I.mailbox_no
            WHERE ( I.created_at BETWEEN ? AND ? )
            ';

            if( !empty( $data[ 's' ][ 'invoice_no' ] ) )
                $sql .= ' AND invoice_no LIKE \'%'. $data[ 's' ][ 'invoice_no' ] .'%\' ';

            if( !empty( $data[ 's' ][ 'tracking_no' ] ) )
                $sql .= ' AND tracking_no LIKE \'%'. $data[ 's' ][ 'tracking_no' ] .'%\' ';

            if( !empty( $data[ 's' ][ 'mailbox_no' ] ) )
                $sql .= ' AND mailbox_no LIKE \'%'. $data[ 's' ][ 'mailbox_no' ] .'%\' ';

            if( !empty( $data[ 's' ][ 'price' ] ) )
                $sql .= ' AND price LIKE \'%'. $data[ 's' ][ 'price' ] .'%\' ';

            if( !empty( $data[ 's' ][ 'type' ] ) )
                $sql .= ' AND type LIKE \'%'. $data[ 's' ][ 'type' ] .'%\' ';

            $data[ 'invoices' ] = DB::select( $sql, [ $start_date, $end_date ] );
        }

        return view( 'admin/invoices/export', $data );
    }

    public function exportDownloadInvoice( Request $request )
    {
        $data[ 'title' ] = 'Export_Invoices';
        $data[ 'class' ] = 'invoices';
        $data[ 'table' ] = 'Export Invoices';

        $role_id = Session::get( 'role_id' );
        $user_id = Session::get( 'user_id' );

        $data[ 'getModues' ] = DB::table( 'role_modules' )->where( 'user_id', '=', $user_id)->where( 'role_id', '=', $role_id )->first();
        $data[ 'settings' ] = DB::table( 'settings' )->first();

        $file = $data[ 'title' ] . '_' . date( 'Y-m-d' ) . '.csv';

        $headers = array(
            "Content-type" => "text/csv",
            "Content-Disposition" => "attachment; filename={$file}",
            "Pragma" => "no-cache",
            "Cache-Control" => "must-revalidate, post-check=0, pre-check=0",
            "Expires" => "0"
        );

        // set JMD rate
        // $rate = 130;

        $invoice_nos = $request->input( 'invoice_no' );
        //dd($invoice_nos);
        $list[] = [ "Invoice #", "Customer", "Date", "Item", "Item Description", "Amount" , "Package Description" , "Package Amount" ];

        $invoice_nos = $request->input( 'invoice_no' );
        if( isset( $invoice_nos ) && is_array( $invoice_nos ) && !empty( $invoice_nos ) )
        {
            foreach ( $invoice_nos as $invoice_no )
            {
                //return $invoice_no;
                /*/
                $sql = 'SELECT
                    I.invoice_no AS invoice_no,
                    I.created_at AS created_at,
                    I.type AS type,
                    I.price AS price,
                    I.weight AS weight,
                    U.first_name AS first_name,
                    U.last_name AS last_name,
                    I.mailbox_no AS mailbox_no,
                    U.email AS email,
                    I.tracking_no AS tracking_no,
                    I.processing_fee AS processing_fee,
                    I.ENV_levy AS env_levy,
                    I.service_fee AS service_fee,
                    I.CAF AS caf,
                    I.SCF AS scf
                FROM invoices AS I JOIN users AS U ON U.mailbox = I.mailbox_no
                WHERE ( I.invoice_no = ? )';
                //*/

                $sql = 'SELECT
                    I.invoice_no AS invoice_no,
                    U.first_name AS first_name,
                    U.last_name AS last_name,
                    I.created_at AS created_at,
                    S.name AS item,
                    S.name AS item_discription,
                    S.service_fee AS amount,
                    I.service_fee AS service_fee,
                    I.mailbox_no AS mailbox_no,
                    U.email AS email,
                    P.package_description,
                    P.package_price
                FROM invoices AS I JOIN users AS U ON U.mailbox = I.mailbox_no
                LEFT JOIN service_type AS S ON S.invoice_id = I.invoice_id
                JOIN invoice_packages AS P ON P.invoice_id = I.invoice_id
                WHERE ( I.invoice_id = ? )';

                $i = DB::select( $sql, [ $invoice_no ] );
                //echo '<pre>';print_r($i);exit;
                foreach ( $i as $tmp )
                {
                    $CreateTime = date( 'j/n/Y G:i', strtotime( $tmp->created_at ) );
                    $CustomerName = "{$tmp->first_name} {$tmp->last_name}";
                    $list[] = [ $tmp->invoice_no, $CustomerName, $CreateTime, $tmp->item, $tmp->item_discription, $tmp->amount,$tmp->package_description,$tmp->package_price ];
                }
                if(isset($i[0]->created_at)){
                    // Service Fee
                    $CreateTime = date( 'j/n/Y G:i', strtotime( $i[0]->created_at ) );
                    $CustomerName = "{$i[0]->first_name} {$i[0]->last_name}";
                    $list[] = [ $i[0]->invoice_no, $CustomerName, $CreateTime, 'Services Charges', 'Services Charges', $i[0]->service_fee ];

                    // GCT
                    $CreateTime = date( 'j/n/Y G:i', strtotime( $i[0]->created_at ) );
                    $CustomerName = "{$i[0]->first_name} {$i[0]->last_name}";
                    $list[] = [ $i[0]->invoice_no, $CustomerName, $CreateTime, 'GCT', 'GCT', ( $i[0]->service_fee * 0.165 ) ];
                }

                /*/
                $CreateTime = date( 'j/n/Y G:i', strtotime( $i[0]->created_at ) );
                $CustomerName = "{$i[0]->first_name} {$i[0]->last_name} {$i[0]->mailbox_no}";
                $DocumentNo = $invoice_no;
                $LineDescription = $i[0]->type;

                $LineAmount = (float) ( $i[0]->price * $rate );
                $LineAmount = number_format( $LineAmount, 2, '.', '' );

                $LineSalesItemName = "RCJ Weight ({$i[0]->weight}lbs)";
                $BillEmail = $i[0]->email;
                $PackageNumber = $i[0]->tracking_no;

                // item
                $list[] = [ $CreateTime, $DocumentNo, "JMD", $LineDescription, $LineAmount, $LineSalesItemName, $LineAmount, 1, $CustomerName, $BillEmail, $CreateTime, $LineAmount, $PackageNumber ];

                // processing fee
                $LineDescription = 'Processing fee';
                $LineAmount = (float) ( $i[0]->processing_fee * $rate );
                $LineAmount = number_format( $LineAmount, 2, '.', '' );
                $list[] = [ $CreateTime, $DocumentNo, "JMD", $LineDescription, $LineAmount, $LineDescription, $LineAmount, 1, $CustomerName, $BillEmail, $CreateTime, $LineAmount, $PackageNumber ];

                // env levy
                $LineDescription = 'Env Levy';
                $LineAmount = (float) ( $i[0]->env_levy * $rate );
                $LineAmount = number_format( $LineAmount, 2, '.', '' );
                $list[] = [ $CreateTime, $DocumentNo, "JMD", $LineDescription, $LineAmount, $LineDescription, $LineAmount, 1, $CustomerName, $BillEmail, $CreateTime, $LineAmount, $PackageNumber ];

                // service fee
                $LineDescription = 'Service fee';
                $LineAmount = (float) ( $i[0]->service_fee );
                $LineAmount = number_format( $LineAmount, 2, '.', '' );
                $list[] = [ $CreateTime, $DocumentNo, "JMD", $LineDescription, $LineAmount, $LineDescription, $LineAmount, 1, $CustomerName, $BillEmail, $CreateTime, $LineAmount, $PackageNumber ];

                // C.A.F
                $LineDescription = 'C.A.F';
                $LineAmount = (float)$i[0]->caf;
                $LineAmount = number_format( $LineAmount, 2, '.', '' );
                $list[] = [ $CreateTime, $DocumentNo, "JMD", $LineDescription, $LineAmount, $LineDescription, $LineAmount, 1, $CustomerName, $BillEmail, $CreateTime, $LineAmount, $PackageNumber ];

                // S.C.F
                $LineDescription = 'S.C.F';
                $LineAmount = (float) $i[0]->scf;
                $LineAmount = number_format( $LineAmount, 2, '.', '' );
                $list[] = [ $CreateTime, $DocumentNo, "JMD", $LineDescription, $LineAmount, $LineDescription, $LineAmount, 1, $CustomerName, $BillEmail, $CreateTime, $LineAmount, $PackageNumber ];
                //*/
            }
        }

        $callback = function() use ( $list )
        {
            $FH = fopen( 'php://output', 'w' );
            foreach ( $list as $row )
            {
                fputcsv( $FH, $row );
            }
            fclose( $FH );
        };

        // column names
        // echo "<pre>";
        // build search query and get export results
        //echo "</pre>";
        //exit();

        return Response::stream( $callback, 200, $headers ); //use Illuminate\Support\Facades\Response;
    }

   public function send_email_invoice($email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $res['logo'] = URL::to('/') . '/public/settings/'.$settings->site_logo;
        $res['invoice'] = $invoice;
        $res['service_type'] = $service_type;
        $res['settings'] = $settings;
        $res['user'] = $user;
        $res['invoicesPack'] = $invoicesPack;
        $res['usRate'] = $us_rate;
        //return view('admin/invoices/'.$view_name , $res);
        try {
        Mail::send('admin/invoices/'.$view_name , $res, function ($message) use ($email_from, $email, $user_name, $email_subject,$company_name) {
            $message->from($email_from, $name = $company_name);
            $message->to($email, $user_name)->subject($email_subject);
           // $message->to('rizwangill132@gmail.com', $user_name)->subject($email_subject);
            //$message->to('shopvmjbb@gmail.com', $user_name)->subject($email_subject);
        });
   } catch (\Exception $e) {
        \Log::error('Package update email sending failed: ' . $e->getMessage()); // Log error but continue execution
    }
    }

    public function send_email_invoiceold($email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $subject = $email_subject;
        $headers = "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
        $message = '<!DOCTYPE html>
                        <html lang="en">
                        <head>
                            <title>Email</title>
                            <meta charset="utf-8">
                            <meta name="viewport" content="width=device-width, initial-scale=1">
                            <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
                            <style>
                                body {
                                    overflow-x: hidden;
                                }
                                @media (max-width:1280px) {
                                    .main_content ul {
                                        width: 60% !important;
                                    }
                                }
                                @media (max-width:1180px) {
                                    .account_info {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width:812px) {
                                    .email-bg {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width: 767.98px) {
                                    .main_content ul {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width: 600px) {
                                    .email-bg {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width:480px) {
                                    .main_content ul {
                                        width: 98% !important;
                                        padding: 6px !important;
                                        font-size: 14px;
                                    }
                                }
                                @media (max-width:380px) {
                                    .small_text {
                                        font-size: 16px !important;
                                    }
                                    .email_content p {
                                        font-size: 16px !important;
                                    }
                                    .main_content li {
                                        font-size: 14px !important;
                                    }
                                }
                                @media (max-width:320px) {
                                    .small_text {
                                        font-size: 14px !important;
                                    }
                                }
                            </style>
                        </head>
                        <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
                            <main>
                                <!----- EMAIL-SECTOION-START ------>
                                <section class="email-bg"
                                    style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                                    <div class="container">
                                        <header style="border-bottom: 1px solid #ccc;">
                                            <img class="logo" src="'.$logo.'" alt="logo" style=" width:20%;">
                                        </header>
                                        <div class="email_content" style="
                                        width: 100%;
                                    ">
                                            <div style="border-bottom: 1px solid #ccc;">
                                                <h4 style="font-size: 18px;margin-bottom: 0;color: #757575cc; ">BILL FROM:</h4>
                                                <h3 style="font-size: 26px; margin:0; padding-top: 5px;">'.$company_name.'</h3>
                                                <p style="font-size: 20px; margin: 0; padding-top: 5px;">'.$settings->local_address.'</p>
                                                <p style="font-size: 18px; margin: 0; padding: 6px 0;">Phone: '.$settings->phone.'</p>
                                            </div>
                                            <div style="border-bottom: 1px solid #ccc;">
                                                <h4 style="font-size: 18px;margin-bottom: 0;color: #757575cc;">BILL TO:</h4>
                                                <h3 style="font-size: 26px; margin:0;  padding-top: 5px;">'.$user->first_name.' '.$user->last_name.'</h3>
                                                <p style="font-size: 20px; margin: 0; padding-top: 5px;">'.$user->address_1.'</p>
                                                <p style="font-size: 20px; margin: 0; padding-top: 5px;">Account no: '.$user->mailbox.'</p>

                                                <p style="margin: 0; padding: 6px 0;">Email: <a href="mailto:'.$user->email.'">'.$user->email.'</a></p>
                                            </div>
                                            <div style="border-bottom: 1px solid #ccc;">
                                                <p style="font-size: 20px;margin-bottom: 0;color: #757575cc;">Invoice #: <span style="color: #000; font-weight: 600;">'.$invoice->invoice_no.'</span></p>

                                                <p style="font-size: 20px; margin: 0; padding: 5px 0; color: #757575cc;">Date #: <span style="color: #000; font-weight: 600;">'.date('d M, Y' , strtotime($invoice->created_at)).'</span></p>
                                            </div>
                                            <div class="main_content" style="border-bottom: 1px solid #ccc;">';
                                        $count = 0;
                                        $totalAmount = 0;
                                        if(count($invoicesPack) > 0){
                                            foreach($invoicesPack as $pack){
                                                $count1 = $count + 1;
                                                        $message .= '<ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                                #
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$count1.'</li>
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;vertical-align: text-bottom;">
                                                                Description
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$pack->package_description.' / '.$pack->package_weight.' lbs </li>
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                                Price
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.number_format(($pack->package_price + $pack->custom_fee + $pack->service_fee) * $us_rate ,2).' JMD</li>
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                                Amount
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 12px 0;">'.number_format(($pack->package_price + $pack->custom_fee + $pack->service_fee) * $us_rate ,2).' JMD</li>
                                                        </ul>';
                                                $count ++;
                                                $package_price = $pack->package_price * $us_rate;
                                                $service_fee = $pack->service_fee * $us_rate;
                                                $custom_fee = $pack->custom_fee * $us_rate;
                                                $totalAmount = $totalAmount + $package_price + $service_fee + $custom_fee;
                                            }
                                        }


                                                $message .= '<ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                        #
                                                    </li>
                                                    <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">3</li>
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;vertical-align: text-bottom;">
                                                        Description
                                                    </li>
                                                    <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">GCT</li>
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                        Price
                                                    </li>';
                                                    if($invoice->gct == 0){
                                                        $gct_label = '0%';
                                                    }else{
                                                        $gct_label = '16.50%';
                                                    }

                                        $message .= '<li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$gct_label.'</li>
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                        Amount
                                                    </li>';
                                                    if($invoice->gct == 0){
                                                        $total_gct = 0  * $us_rate;
                                                        $gct = number_format(0  , 2).' JMD';
                                                    }else{
                                                        $total_gct = $totalAmount * 16.50 / 100;
                                                        $gct = number_format($totalAmount * 16.50 / 100  ,2).' JMD';
                                                    }
                                        $message .= '<li style="display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$gct.'</li>
                                                </ul>';
                                                    $message .= '

                                                <ul
                                                style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">


                                                <li
                                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                                    Sub- Total amount
                                                </li>
                                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0; ">'.number_format($totalAmount + $total_gct ,2).' JMD</li>
                                                <li
                                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                                    Grand Total
                                                </li>
                                                <li style="display: inline-block; width: 68%; padding: 0 0 12px 0;">'.number_format($totalAmount + $total_gct ,2).' JMD</li>
                                            </ul>
                                            </div>
                                            <div>
                                                <h4 style="color: #636363;">Thank You for your business</h4>
                                                <h4 style="color: #636363;">Invoice powered by Musscome Shipping Courier Ja</h4>
                                            </div>
                                        </div>

                                    </div>
                                    <footer>
                                        <h4 style="border-top: 1px solid #ccc; font-size: 13px; color: #8c8c8c;">Thanks for your support Enjoy
                                            your shopping experience. </h4>
                                        <p style="font-size: 13px; color: #8c8c8c;">Best Wishes</p>
                                        <p style="font-size: 13px; color: #8c8c8c;">Musscome Shipping Client Services</p>
                                    </footer>
                                    </div>
                                </section>
                                <!----- EMAIL-SECTOION-END ------>
                            </main>
                        </body>
                        </html>';
            $user_email = $email;
           // $user_email = 'rizwangill132@gmail.com';
            mail($user_email,$subject,$message,$headers);
    }

    public function printInvoice($invoice_id = ''){

            $data['title'] = 'Manage Invoices';
            $data['class'] = 'invoices';
            $data['table'] = 'Manage Invoices';
            $user_id = Session::get('user_id');
            $data['users'] = User::where('user_id' , $user_id)->first();
            $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
            $client_id = $invoice->client_id;
            $currency_id = $invoice->currency_id;
            $client = Client::where('client_id' , $client_id)->first();
            $data['client'] = $client;
            $country_id = $client->country_id;
            $state_id = $client->state_id;
            $city_id = $client->city_id;
            $data['countries'] = Country::where('id' , $country_id)->first();
            $data['states'] = State::where('id' , $state_id)->first();
            $data['cities'] = City::where('id' , $city_id)->first();
            $data['invoice'] = $invoice;
            if($invoice->tex_type == 1){
                    $tex = $invoice->SGST_tex + $invoice->CGST_tex;
                    $total_tex = $invoice->total_amount * $tex / 100;
                    $total_amount = $invoice->total_amount + $total_tex;
                    $amount = number_format($total_amount);
                    $data['amountInWord'] = $this->getAmountInWords($total_amount);
            }elseif($invoice->tex_type == 2){
                    $tex = $invoice->IGST_tex;
                    $total_tex = $invoice->total_amount * $tex / 100;
                    $total_amount = $invoice->total_amount + $total_tex;
                    $amount = number_format($total_amount);
                    $data['amountInWord'] = $this->getAmountInWords($total_amount);
            }else{
            $total_amount = $invoice->total_amount;
                    $amount = number_format($total_amount);
                    $data['amountInWord'] = $this->getAmountInWords($total_amount);
            }
            $data['currencies'] = Currency::where('currency_id' ,$currency_id)->first();
            //return view('pdfinvoice' , $data);
            $pdf = PDF::loadView('pdfinvoice' , $data);
            return $pdf->download(time().'_invoice.pdf');
    }
public function invoicePrint($invoice_id = ''){
        
        //Save invoice in pdf
        $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
        //dd($invoice);
        $data['invoice'] = $invoice;
        $data['service_type'] = DB::table('service_type')->where('invoice_id' , $invoice_id)->get();
        $data['invoicesPack'] = DB::table('invoice_packages')->join('packages', 'invoice_packages.tracking_no', '=', 'packages.tracking_no')->where('invoice_id' , $invoice_id)->get();
        $data['settings'] = DB::table('settings')->first();
        $data['user'] = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
        $us_rate = DB::table('settings')->first()->us_rate;
        $settings = DB::table('settings')->first();
        $data['logo'] = URL::to('/') . '/public/settings/'.$settings->site_logo;
        $data['usRate'] = $us_rate;
        $unique = time().'_invoice.pdf';
       return view('admin/invoices/invoice_print_pdf' , $data);
        $pdfpathforgenerate = 'invoices/'.$unique;
        $pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data);
        return $pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data)->download($pdfpathforgenerate);
    }
    public function getAmountInWords($amount){
		$number = $amount;
		$no = round($number);
		$point = round($number - $no, 2) * 100;
		$hundred = null;
		$digits_1 = strlen($no);
		$i = 0;
		$str = array();
		$words = array('0' => '', '1' => 'one', '2' => 'two',
				'3' => 'three', '4' => 'four', '5' => 'five', '6' => 'six',
				'7' => 'seven', '8' => 'eight', '9' => 'nine',
				'10' => 'ten', '11' => 'eleven', '12' => 'twelve',
				'13' => 'thirteen', '14' => 'fourteen',
				'15' => 'fifteen', '16' => 'sixteen', '17' => 'seventeen',
				'18' => 'eighteen', '19' =>'nineteen', '20' => 'twenty',
				'30' => 'thirty', '40' => 'forty', '50' => 'fifty',
				'60' => 'sixty', '70' => 'seventy',
				'80' => 'eighty', '90' => 'ninety');
		$digits = array('', 'hundred', 'thousand', 'lakh', 'crore');
		while ($i < $digits_1) {
			$divider = ($i == 2) ? 10 : 100;
			$number = floor($no % $divider);
			$no = floor($no / $divider);
			$i += ($divider == 10) ? 1 : 2;
			if ($number) {
			$plural = (($counter = count($str)) && $number > 9) ? 's' : null;
			$hundred = ($counter == 1 && $str[0]) ? ' and ' : null;
			$str [] = ($number < 21) ? $words[$number] .
			" " . $digits[$counter] . $plural . " " . $hundred
			:
			$words[floor($number / 10) * 10]
			. " " . $words[$number % 10] . " "
			. $digits[$counter] . $plural . " " . $hundred;
			} else $str[] = null;
		}
		$str = array_reverse($str);
		$result = implode('', $str);
		//$points = ($point) ?"." . $words[$point / 10] . " " . $words[$point = $point % 10] : '';
		return  $result . "Rupees only";
	}

    public function uploadInvoice(Request $request , $traking_no = ''){
        $data['title'] = 'Upload Invoice';
        $data['class'] = 'invoices';
        $data['table'] = 'Shipment Tracking Details';
        $mailbox = Session::get('mailbox');
        if ($request->isMethod('get')) {
            $packege = Package::where('tracking_no' , $traking_no)->first();
            $data['packege'] = $packege;
            $data['title'] = PackageStatus::where('id' , $packege->status)->first()->name;
            return view('admin/invoices/upload_invoice' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                                'input_img' => 'required',
                            ]);
            if ($validator->fails()) {
                    return redirect('user/invoice/upload/'.$traking_no)
                                    ->withInput()
                                    ->withErrors($validator);
            }else{
                if ($request->hasFile('input_img')) {
                    $image = $request->file('input_img');
                    $name = time().'.'.$image->getClientOriginalExtension();
                    $destinationPath = public_path('/invoices');
                    $image->move($destinationPath, $name);
                }
                $usersRes = Package::where('tracking_no' , $traking_no)->update(['invoice' => $name]);
                return redirect('user/invoice/upload/'.$traking_no);
            }
        }
    }

    public function deleteInvoice($tracking_no = '') {
        $packeg = Package::where('tracking_no' , $tracking_no)->first();
        if($packeg){
            @unlink(base_path() . '/public/invoices/' . $packeg->invoice);
            $usersRes = Package::where('tracking_no' , $tracking_no)->update(['invoice' => '']);
        }
        Session::flash('del_msg', 'Invoice has been deleted successfully.');
        return redirect('user/invoice/upload/'.$tracking_no);
    }

    public function updateInvoiceStatus($status = '' , $invoice_id = '') {

        Invoice::where('invoice_id' , $invoice_id)->update(['status' => $status,'updated_at'=>date('Y-m-d H:i:s')]);
        if($status == 0){
            Session::flash('success_msg', 'Invoice status changed to unpaid successfully.');
        }else{
            $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $invoice_id)->get();
            if(count($invoicesPack) > 0){
                foreach($invoicesPack as $row){
                    $tracking_no = $row->tracking_no;
                    Package::where('tracking_no', $tracking_no)
                      ->update([
                        'status' => 12
                    ]);
                    DB::table('invoice_packages')->where('invoice_id' , $row->invoice_id)->update([
                        'status' => 1
                    ]);
                }
            }
            Session::flash('success_msg', 'Invoice status changed to paid successfully.');
        }
        return redirect('admin/invoices/email/'.$status.'?start_date=&end_date=');

    }
    
    public function updateInvoiceStatusNew(Request $request) {
        $setting = Setting::first();
        $invoice_id = $request->id;
        $checkInvoice = Invoice::where('invoice_id' , $invoice_id)->first();
        Invoice::where('invoice_id' , $invoice_id)->update(['status' => 1,'payment_method' => $request->payment_method,'is_reward_pay' => $request->is_reward_pay,'reward_points' => $request->reward_point,'is_referral_pay' => $request->is_referral_pay,'referral_points' => $request->referral_points,'updated_at'=>date('Y-m-d H:i:s')]);
        if($request->is_reward_pay == 1){
            $reward_point = $request->reward_point / $setting->us_rate;
            $this->addDebitNoteRefPoints($invoice_id,$checkInvoice->mailbox_no,$reward_point);
        }
        
        if($request->is_referral_pay == 1){
            $referral_points = $request->referral_points / $setting->us_rate;
            $this->addDebitNotePoints($invoice_id,$checkInvoice->mailbox_no,$referral_points);
        }
        
        $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $invoice_id)->get();
        if(count($invoicesPack) > 0){
            foreach($invoicesPack as $row){
                $tracking_no = $row->tracking_no;
                Package::where('tracking_no', $tracking_no)
                  ->update([
                    'status' => 12,
                    'status_name' => 'DELIVERED'
                ]);
                DB::table('invoice_packages')->where('tracking_no', $tracking_no)
                  ->update([
                    'status' => 1
                ]);
                $totalWeight = 0;
                $pkg = Package::where('tracking_no', $tracking_no)->first();
                if($pkg){
                    $totalWeight = $pkg->weight;
                }else{
                    $totalWeight = 0;
                }
                //For reward points
                $packageArray = [];
                $packageObject = (object) array();
                $checkTransactionsDB = DB::table('transactions')->where('mailbox' , $checkInvoice->mailbox_no)->first();
                if($checkTransactionsDB){
                    $totalWeight = $totalWeight + $checkTransactionsDB->weight;
                    $packageObject->id = $tracking_no;
                    $packageObject->weight = $pkg->weight;
                    $packageArray[] = $packageObject;
                    $package_ids = json_decode($checkTransactionsDB->package_ids);
                    if($package_ids != ''){
                        $pkgArray = array_merge($package_ids,$packageArray);
                    }else{
                        $pkgArray = $packageArray;
                    }
                    
                    DB::table('transactions')->where('id' , $checkTransactionsDB->id)->update(['package_ids' => json_encode($pkgArray,true),'weight' => $totalWeight]);
                }else{
                    $packageObject->id = $tracking_no;
                    $packageObject->weight = $totalWeight;
                    $packageArray[] = $packageObject;
                    $totalWeight = $totalWeight;
                    DB::table('transactions')->insert(['package_ids' => json_encode($packageArray,true),'mailbox' => $checkInvoice->mailbox_no , 'weight' => $totalWeight]);
                }
                
                
                $transactions = DB::table('transactions')->where('mailbox' , $checkInvoice->mailbox_no)->sum('weight');
                if($transactions >= $setting->reward_packages || $totalWeight >= $setting->reward_weight){
                    $reward_points = $setting->reward_amount;
                    $this->addCreditNotePoints($checkInvoice->invoice_id , $checkInvoice->mailbox_no , $reward_points);
                    $remainWeight = $totalWeight - $setting->reward_packages;
                    $checkTransactions = DB::table('transactions')->where('mailbox' , $checkInvoice->mailbox_no)->update(['package_ids' => '' , 'weight' => $remainWeight]);
                    //DB::table('transactions')->delete();
                }
                
                //For referral points
                $users = User::where('mailbox' , $checkInvoice->mailbox_no)->first();
                
                $check_ref_points = DB::table('member_referral_points')->where('user_id' , $users->user_id)->where('status' , 0)->where('type' , 1)->first();
                if($check_ref_points){
                    $usersRef = User::where('mailbox' , $users->ref_by)->first();
                    $totalWeight = 0;
                    $pkg = Package::where('tracking_no', $tracking_no)->first();
                    if($pkg){
                        $totalWeight = $pkg->weight;
                    }else{
                        $totalWeight = 0;
                    }
                    $checkTransactionsDBrf = DB::table('transactions_referral')->where('mailbox' , $checkInvoice->mailbox_no)->first();
                    if($checkTransactionsDBrf){
                        $totalWeight = $totalWeight + $checkTransactionsDBrf->weight;
                        DB::table('transactions_referral')->where('id' , $checkTransactionsDBrf->id)->update(['weight' => $totalWeight]);
                    }else{
                        $totalWeight = $totalWeight;
                        DB::table('transactions_referral')->insert(['mailbox' => $checkInvoice->mailbox_no , 'weight' => $totalWeight]);
                    }
                    $transactionsrf = DB::table('transactions_referral')->where('mailbox' , $checkInvoice->mailbox_no)->sum('weight');
                    if($transactionsrf >= $setting->reffral_packages || $totalWeight >= $setting->reffral_weight){
                        $reward_points = $setting->reward_amount;
                        DB::table('member_referral_points')->insert(['from_user_id' => $check_ref_points->from_user_id ,'user_id' => $users->user_id , 'balance'=> $check_ref_points->balance,'type'=> 2,'status'=> 1,  'created_at' => date('Y-m-d h:i:s'), 'updated_at' => date('Y-m-d h:i:s')]);
                        DB::table('member_referral_points')->where('id' , $check_ref_points->id)->update(['status' => 1]);
                        // $reward_points = $setting->reward_amount;
                        // $this->addCreditNotePoints($checkInvoice->invoice_id , $checkInvoice->mailbox_no , $reward_points);
                        $remainWeight = $totalWeight - $setting->reffral_packages;
                        $checkTransactions = DB::table('transactions_referral')->where('mailbox' , $checkInvoice->mailbox_no)->update(['weight' => 50]);
                        //DB::table('transactions')->delete();
                    }
                }
                
            }
        }
        
        // if($setting->reward_points > 0){
        //     $FreightTotal = $this->getFreightTotal($checkInvoice->invoice_id);
        //     $reward_points = $FreightTotal * $setting->reward_points / 100;
        //     $this->addCreditNotePoints($checkInvoice->invoice_id , $checkInvoice->mailbox_no , $reward_points);
        // }
        $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
        $data['invoice'] = $invoice;
        $service_type = DB::table('service_type')->where('invoice_id' , $invoice->invoice_id)->get();
        $data['service_type'] = $service_type;
        $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $invoice->invoice_id)->get();
        $data['invoicesPack'] = $invoicesPack;
        $settings = DB::table('settings')->first();
        $data['settings'] = $settings;
        $user = DB::table('users')->where('mailbox' , $invoice->mailbox_no)->first();
        $us_rate = DB::table('settings')->first()->us_rate;
        $user_name = $user->first_name.' '.$user->last_name;
        $email_subject = $settings->company_name.' invoice detail';
        $settings = DB::table('settings')->first();
        if($settings){
            $email_from = $settings->from_email;
        }
        // $settings = DB::table('settings')->first();
        // $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
        // $company_name = $settings->company_name;
        // $data['user'] = $user;
        // $us_rate = DB::table('settings')->first()->us_rate;
        // $data['usRate'] = $us_rate;
        // //dd($data);
        // $unique = time().'_invoice.pdf';
        // //return view('admin/invoices/invoice_print_pdf' , $data);
        // $pdfpathforgenerate = 'public/invoices/'.$unique;
        // $pdf = PDF::loadView('admin/invoices/invoice_print_pdf' , $data);
        // $pdf->setPaper('L');
        // $pdf->output();
        // $canvas = $pdf->getDomPDF()->getCanvas();
        // $height = $canvas->get_height();
        // $width = $canvas->get_width();
        // $canvas->set_opacity(.2,"Multiply");
        // $canvas->page_text($width/2.5, $height/2, 'PAID', null,70, array(0,0,0),2,2,-30);
        // $pdf->save($pdfpathforgenerate);
        // Invoice::where('invoice_id' , $invoice_id)->update(['pdf_invoice' => $unique,'updated_at'=>date('Y-m-d H:i:s')]);
        // $invoice = Invoice::where('invoice_id' , $invoice_id)->first();
        // $file = public_path('/invoices/').$invoice->pdf_invoice;
        //$this->send_email_invoice_paid($user->email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name,$file, 'invoice_print_email');
        //return redirect('admin/invoices/email/'.$status.'?start_date=&end_date=');
        return ["status" => true,"message" =>"Invoice status changed to paid successfully.",'url'=> url('admin/invoices/email/0?start_date=&end_date=')];

    }
    
    public function send_email_invoice_paid($email, $user_name,$invoice,$service_type,$settings,$user,$invoicesPack,$us_rate,$email_subject, $email_from,$logo,$company_name,$file,$view_name) {
        $subject = $email_subject;
        $semi_rand = md5(time());  
        $boundary = uniqid();
        $mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";  
        $headers = "MIME-Version: 1.0\r\n";
        //$headers .= "Content-Type: text/html; charset=UTF-8\r\n";
        $headers .= "From: Brown Box Company Limited <updates@brown-box.com>\n";
        $headers .= "\nMIME-Version: 1.0\n" . "Content-Type: multipart/mixed;\n" . " boundary=\"{$mime_boundary}\""; 
        // attachment
        $attachment = chunk_split(base64_encode(file_get_contents($file)));
        $message = '<!DOCTYPE html>
                        <html lang="en">
                        <head>
                            <title>Email</title>
                            <meta charset="utf-8">
                            <meta name="viewport" content="width=device-width, initial-scale=1">
                            <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
                            <style>
                                body {
                                    overflow-x: hidden;
                                }
                                @media (max-width:1280px) {
                                    .main_content ul {
                                        width: 60% !important;
                                    }
                                }
                                @media (max-width:1180px) {
                                    .account_info {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width:812px) {
                                    .email-bg {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width: 767.98px) {
                                    .main_content ul {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width: 600px) {
                                    .email-bg {
                                        width: 90% !important;
                                    }
                                }
                                @media (max-width:480px) {
                                    .main_content ul {
                                        width: 98% !important;
                                        padding: 6px !important;
                                        font-size: 14px;
                                    }
                                }
                                @media (max-width:380px) {
                                    .small_text {
                                        font-size: 16px !important;
                                    }
                                    .email_content p {
                                        font-size: 16px !important;
                                    }
                                    .main_content li {
                                        font-size: 14px !important;
                                    }
                                }
                                @media (max-width:320px) {
                                    .small_text {
                                        font-size: 14px !important;
                                    }
                                }
                            </style>
                        </head>
                        <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
                            <main>
                                <!----- EMAIL-SECTOION-START ------>
                                <section class="email-bg"
                                    style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                                    <div class="container">
                                        <header style="border-bottom: 1px solid #ccc;">
                                            <img class="logo" src="'.$logo.'" alt="logo" style=" width:20%;">
                                        </header>
                                        <div class="email_content" style="
                                        width: 100%;
                                    ">
                                            <div style="border-bottom: 1px solid #ccc;">
                                                <h4 style="font-size: 18px;margin-bottom: 0;color: #757575cc; ">BILL FROM:</h4>
                                                <h3 style="font-size: 26px; margin:0; padding-top: 5px;">'.$company_name.'</h3>
                                                <p style="font-size: 20px; margin: 0; padding-top: 5px;">'.$settings->local_address.'</p>
                                                <p style="font-size: 18px; margin: 0; padding: 6px 0;">Phone: '.$settings->phone.'</p>
                                            </div>
                                            <div style="border-bottom: 1px solid #ccc;">
                                                <h4 style="font-size: 18px;margin-bottom: 0;color: #757575cc;">BILL TO:</h4>
                                                <h3 style="font-size: 26px; margin:0;  padding-top: 5px;">'.$user->first_name.' '.$user->last_name.'</h3>
                                                <p style="font-size: 20px; margin: 0; padding-top: 5px;">'.$user->address_1.'</p>
                                                <p style="font-size: 20px; margin: 0; padding-top: 5px;">Account no: '.$user->mailbox.'</p>

                                                <p style="margin: 0; padding: 6px 0;">Email: <a href="mailto:'.$user->email.'">'.$user->email.'</a></p>
                                            </div>
                                            <div style="border-bottom: 1px solid #ccc;">
                                                <p style="font-size: 20px;margin-bottom: 0;color: #757575cc;">Invoice #: <span style="color: #000; font-weight: 600;">'.$invoice->invoice_no.'</span></p>

                                                <p style="font-size: 20px; margin: 0; padding: 5px 0; color: #757575cc;">Date #: <span style="color: #000; font-weight: 600;">'.date('d M, Y' , strtotime($invoice->created_at)).'</span></p>
                                            </div>
                                            <div class="main_content" style="border-bottom: 1px solid #ccc;">';
                                        $count = 0;
                                        $totalAmount = 0;
                                        $totalServiceFee = 0;
                                        if(count($invoicesPack) > 0){
                                            foreach($invoicesPack as $pack){
                                                $count1 = $count + 1;
                                                        $message .= '<ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                                #
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$count1.'</li>
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;vertical-align: text-bottom;">
                                                                Description
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$pack->package_description.' / '.$pack->package_weight.' lbs </li>
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                                Price
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.number_format(($pack->package_price + $pack->custom_fee + $pack->service_fee) * $us_rate ,2).' JMD</li>
                                                            <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                                Amount
                                                            </li>
                                                            <li style="display: inline-block; width: 68%; padding: 0 0 12px 0;">'.number_format(($pack->package_price + $pack->custom_fee + $pack->service_fee) * $us_rate ,2).' JMD</li>
                                                        </ul>';
                                                $count ++;
                                                $package_price = $pack->package_price * $us_rate;
                                                $service_fee = $pack->service_fee * $us_rate;
                                                $custom_fee = $pack->custom_fee * $us_rate;
                                                $totalAmount = $totalAmount + $package_price + $service_fee + $custom_fee;
                                                $totalServiceFee += $service_fee;
                                                
                                            }
                                        }
                                        
                                                
                                                $message .= '<ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                        #
                                                    </li>
                                                    <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">3</li>
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;vertical-align: text-bottom;">
                                                        Description
                                                    </li>
                                                    <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">GCT</li>
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                        Price
                                                    </li>';
                                                    if($invoice->gct == 0){
                                                        $gct_label = '0%';
                                                    }else{
                                                        $gct_label = '15%';
                                                    }
                                                    
                                        $message .= '<li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$gct_label.'</li>
                                                    <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                        Amount
                                                    </li>';
                                                    if($invoice->gct == 0){
                                                        $total_gct = 0  * $us_rate;
                                                        $gct = number_format(0  , 2).' JMD';
                                                    }else{
                                                        $total_gct = $totalServiceFee * 15 / 100;
                                                        $gct = number_format($totalServiceFee * 15 / 100  ,2).' JMD';
                                                    }
                                        $message .= '<li style="display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$gct.'</li>
                                                </ul>';
                                                    $message .= '

                                                <ul
                                                style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">


                                                <li
                                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                                    Sub- Total amount
                                                </li>
                                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0; ">'.number_format($totalAmount + $total_gct ,2).' JMD</li>
                                                <li
                                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                                    Discount:
                                                </li>
                                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0; ">'.number_format($invoice->discount_price ,2).' JMD</li>
                                                <li
                                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                                    Grand Total
                                                </li>
                                                <li style="display: inline-block; width: 68%; padding: 0 0 12px 0;">'.number_format(($totalAmount + $total_gct) - $invoice->discount_price ,2).' JMD</li>
                                            </ul>
                                            </div>
                                            <div>
                                                <h4 style="color: #636363;">Thank You for your business</h4>
                                                <h4 style="color: #636363;">Invoice powered by Brown-box Shipping Courier Ja</h4>
                                            </div>
                                        </div>

                                    </div>
                                    <footer>
                                        <h4 style="border-top: 1px solid #ccc; font-size: 13px; color: #8c8c8c;">Thanks for your support Enjoy
                                            your shopping experience. </h4>
                                        <p style="font-size: 13px; color: #8c8c8c;">Best Wishes</p>
                                        <p style="font-size: 13px; color: #8c8c8c;">Brown-box Shipping Client Services</p>
                                    </footer>
                                    </div>
                                </section>
                                <!----- EMAIL-SECTOION-END ------>
                            </main>
                        </body>
                        </html>';
            // message with attachment
            $message = "--".$boundary."\r\n";
            $message .= "Content-Type: text/plain; charset=UTF-8\r\n";
            $message .= "Content-Transfer-Encoding: base64\r\n\r\n";
            $message .= chunk_split(base64_encode($message));
            $message .= "--".$boundary."\r\n";
            $message .= "Content-Type: application/octet-stream; name=\"file.pdf\"\r\n";
            $message .= "Content-Transfer-Encoding: base64\r\n";
            $message .= "Content-Disposition: attachment; filename=\"file.pdf\"\r\n\r\n";
            $message .= $attachment."\r\n";
            $message .= "--".$boundary."--";            
            $user_email = $email;
           // $user_email = 'rizwangill132@gmail.com';
            mail($user_email,$subject,$message,$headers);
            //mail($user_email1,$subject,$message,$headers);
    }
    
    public static function getFreightTotal($invoice_id = ''){
        $package_price = DB::table('invoice_packages')->where('invoice_id' , $invoice_id)->where('status' , 1)->sum('package_price');
        $us_rate = DB::table('settings')->first()->us_rate;
        $package_price = $package_price * $us_rate;
        return $package_price;
    }
    
    public function addCreditNotePoints($order_id,$user_id,$amount){
        $memberWallet = new MemberPoint();
        $memberWallet->note_id = $order_id;
        $memberWallet->user_id = $user_id;
        $memberWallet->balance = $amount;
        $memberWallet->type = 1;
        $memberWallet->updated_at = date('Y-m-d H:i:s');
        $memberWallet->save();
    }
    
    public function addDebitNotePoints($order_id,$user_id,$amount){
        
        $memberWallet = new MemberPoint();
        $memberWallet->note_id = $order_id;
        $memberWallet->user_id = $user_id;
        $memberWallet->balance = $amount;
        $memberWallet->type = 2;
        $memberWallet->updated_at = date('Y-m-d H:i:s');
        $memberWallet->save();
    }
    
    public function addDebitNoteRefPoints($order_id,$user_id,$amount){
        
        $memberWallet = new MemberPoint();
        $memberWallet->note_id = $order_id;
        $memberWallet->user_id = $user_id;
        $memberWallet->balance = $amount;
        $memberWallet->type = 3;
        $memberWallet->updated_at = date('Y-m-d H:i:s');
        $memberWallet->save();
    }
    
    public function InvoiceStatus() {

        $invoices = Invoice::where('status' , 1)->get();
        if(count($invoices) > 0){
            foreach($invoices as $row){
                $invoicesPack = DB::table('invoice_packages')->where('invoice_id' , $row->invoice_id)->update([
                        'status' => 1
                    ]);;
            }
        }
        return 'Invoice status changed to paid successfully.';
    }

    public function ratesUploadCSV(Request $request){
        $data['title'] = 'Upload CSV';
        $data['class'] = 'csv';
        $data['table'] = 'Upload CSV';

        set_time_limit(1000);

        $file = URL::to('/').'/public/rates.csv';
        $handle = fopen($file, "r");
        $header = false;
        $csvLine = fgetcsv($handle);
        //dd($csvLine);
        while ($csvLine = fgetcsv($handle, 1000, ",")) {
            if ($header) {
                $header = true;
            } else {
               
                if($csvLine[0] != null){
                     
                     $weightsExp = explode(' lbs-' , $csvLine[0]);
                     //dd($weights);
                    $weight =  $weightsExp[0];
                    $products = DB::table('weights')->where('weight' , $weight)->first();
                     $price = $weightsExp[1];
                    if($products){
                       
                        DB::table('weights')->where('weight' , $weight)->update([
                            'weight' => $weight,
                            'price' => $price
                        ]);
                    }else{
                       
                        DB::table('weights')->insert([
                            'weight' => $weight,
                            'price' => $price
                        ]);
                    }
                }else{
                    
                }
               

             }
        }
          return 'Added Successfully';
    }


     public function uploadUserCSV(Request $request){
        $data['title'] = 'Upload CSV';
        $data['class'] = 'csv';
        $data['table'] = 'Upload CSV';
        $setting = DB::table('settings')->first();
        set_time_limit(1000);

        $file = URL::to('/').'/public/users/user_export.csv';
        $handle = fopen($file, "r");
        $header = false;
        $csvLine = fgetcsv($handle);
        //dd($csvLine);
        while ($csvLine = fgetcsv($handle, 1000, ",")) {
            if ($header) {
                $header = true;
            } else {
               // dd($csvLine);
                //$usersRes = User::orderby('user_id' , 'DESC')->first();
                //dd($usersRes);
                //return $usersRes->user_id;
                //$user_id_mail = $usersRes->user_id + 1;
                if(isset($csvLine[1])){
                    $id = $csvLine[1];
                }else{
                    $id = 0;
                }
                if($id){
                    if($id > 1000){
                        $mailBoxNo = $setting->pre_fix.'0';
                    }elseif($id > 100){
                        $mailBoxNo = $setting->pre_fix.'00';
                    }else{
                        $mailBoxNo = $setting->pre_fix.'000';
                    }
                }else{
                    $mailBoxNo = $setting->pre_fix.'0001';
                }
                
                 $mailbox = $mailBoxNo.$id;
                //return $first_name.' '.$last_name;
                if(isset($csvLine[9])){
                    $first_name = $csvLine[9];
                }else{
                    $first_name = '';
                }
                if(isset($csvLine[10])){
                   $last_name = $csvLine[10];
                }else{
                    $last_name = '';
                }
                if(isset($csvLine[5])){
                   $email = $csvLine[5];
                }else{
                    $email = '';
                }
                 if(isset($csvLine[3])){
                   $pass = $csvLine[3];
                }else{
                    $pass = '';
                }
                 if(isset($csvLine[7])){
                   $date = $csvLine[7];
                }else{
                    $date = '';
                }
                //return $csvLine[9];
                $users = DB::table('users')->where('mailbox' , $mailbox)->first();
                if($users){
                    DB::table('users')->where('mailbox' , $mailbox)->update([
                        'first_name' => $first_name,
                        'last_name' => $last_name,
                        //'email' => $csvLine[5],
                        //'phone' => $csvLine[4],
                    ]);
                    //return 'Updated Successfully';
                }else{

                    DB::table('users')->insert([
                        'mailbox' => $mailbox,
                        'first_name' => $first_name,
                        'last_name' => $last_name,
                        'email' => $email,
                        //'phone' => $csvLine[4],
                        'password' => $pass,
                        'created_at' => date('Y-m-d H:i:s', strtotime($date)),
                        'updated_at' => date('Y-m-d H:i:s', strtotime($date))
                    ]);
                    //return 'Added Successfully';
                }

            }
        }
        return 'Added Successfully';
    }
}
