<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\PackageStatus;
use App\Models\Weight;
use Session;
use Validator;
use Illuminate\Support\Facades\Hash;
use Yajra\DataTables\Facades\DataTables;
use Image;
use File;
use DB;

class WeightControllor extends Controller
{
	
    public function __construct() {
        $this->middleware('guest', ['except' => 'logout']);
    }
    
    public function view(){
        $data['title'] = 'Manage Weight';
        $data['class'] = 'settings';
        $data['table'] = 'Manage Weight';
        return view("admin.weight.list",$data);
    }

    public function listView(){
        return DataTables::of(Weight::query())
                ->addColumn('action', function($data){
                    //<a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  data-value='".$data."' id='".$data->id."'>Delete</a>
                    return "<a href='javascript:void(0)'  class='all_button btn  btn-sm btn-info edit_button' data-value='".$data."' id='".$data->id."'>Edit</a>";
                })->make(true);
    }
	
    public function save(){
        $insertData["weight"] = request()->weight;
        $insertData["price"] = request()->price;
        if(request()->id == 0){
            Weight::insert($insertData);
            return ["status" => true,"message" =>"Weight added successfully"];
        }else{
            Weight::where(["id"=>request()->id])->update($insertData);
            return ["status" => true,"message" =>"Weight updated successfully"];
        }
    }

    public function delete(){
        Role::where(["role_id"=>request()->id])->delete();
        return ["status" => true,"message" =>"Weight deleted successfully"];
    }
}
