@extends('admin.template')
@section('content')
<!-- Content Wrapper START -->
<div class="main-content">
    <div class="container-fluid">
        
        <div class="row">
            @include('common.errors')
            <div class="col-md-12">
                <div class="card">
                    
                    <div class="card-heading border bottom">
                        <h4 class="card-title">{{$table}}</h4>
                    </div>
                    <div class="card-block">
                        <div class="card-block">
                            <div class="row">
                                <div class="col-md-8 ml-auto mr-auto">
                                    <form role="form" id="form-validation" action="" method="post" enctype="multipart/form-data">
                                        {!! csrf_field() !!}
                                        <div class="form-group">
                                            <label for="exampleInputEmail1">Account no.</label>
                                            <div class="col-lg-12" id="mailbox_msg" style="padding-left: 0px;margin: 14px 0;">
                                                <select id="e1" style=" width: 400px;" name="mailbox">
                                                    <option value="">Select A Account no.</option>
                                                    @if($users)
                                                        @foreach($users as $row)
                                                            <option value="{{$row->mailbox}}" <?php if($package->mailbox == $row->mailbox){ ?> selected="" <?php } ?>>{{$row->first_name.' '.$row->last_name.' Account no: '.$row->mailbox}}</option>
                                                        @endforeach
                                                    @endif
                                                </select>
                                            </div>
                                        </div>
                                        <hr>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">Supplier</label>
                                                    <input type="text" name="courier" class="form-control" value="{{$package->courier}}" placeholder="Supplier" required="">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">supplier tracking number</label>
                                                    <input type="text" name="supplier_tracking_no" class="form-control" value="{{$package->supplier_tracking_no}}" placeholder="supplier tracking number" required="">
                                                </div>
                                            </div>
                                        </div>
                                        
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">Weight</label>
                                                    <input type="text" name="weight" class="form-control" value="{{$package->weight}}" placeholder="Weight" required="">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">Price</label>
                                                    <input type="text" name="price" class="form-control" value="{{$package->price}}" placeholder="Price" required="">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">Custom Fee</label>
                                                    <input type="text" name="custom_fee" class="form-control" value="{{$package->custom_fee}}" placeholder="Custom Fee" required="">
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">Select A Package Type</label>
                                                    <select class="selectize-group" name="package_type" id="package_type" required="" >
                                                        <option value="">Select A Package Type</option>
                                                        @if($types)
                                                            @foreach($types as $row)
                                                                <option value="{{$row->code.'-'.$row->type}}" <?php if($package->package_code == $row->code){ ?> selected="" <?php } ?>>{{$row->type}}</option>
                                                            @endforeach
                                                        @endif
                                                    </select>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    <label class="text-normal text-dark">Description</label>
                                                    <textarea class="form-control" name="item_description" rows="3" placeholder="Item Description">{{$package->item_description}}</textarea>
                                                </div>
                                            </div>
                                        </div>
                                        <button type="submit" class="btn btn-primary">Submit</button>
                                        <button type="button" class="btn btn-default" onclick="clearFields();">Clear</button>
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<!-- Content Wrapper END -->
<script>
    function clearFields(){
        $('#form-1-5').val('');
        $('#title').val('');
        
    }
    $('#role').on('change', function() {
        var id = this.value;
        if(id == '1'){
            $('#show_module').hide();
        }else{
            $('#show_module').show();
        }
    });
</script>
@endsection      
        
      