<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use Laravel\Passport\Http\Controllers\AccessTokenController;
use Laravel\Passport\Http\Controllers\AuthorizationController;
use Laravel\Passport\Http\Controllers\TransientTokenController;
use Laravel\Passport\Http\Controllers\ClientController;
use Laravel\Passport\Http\Controllers\PersonalAccessTokenController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

// Public API routes
Route::get('GetUsers', 'API\V1\ApiController@GetUsers');
Route::post('GetUsers', 'API\V1\ApiController@GetUsersNew');
Route::post('savePackage', 'API\V1\ApiController@savePackage');
Route::post('resendPackage', 'API\V1\ApiController@resendPackage');
Route::post('checkPackage', 'API\V1\ApiController@checkPackage');
Route::post('updatePackageStatus', 'API\V1\ApiController@updatePackageStatus');
Route::post('deletePackage', 'API\V1\ApiController@deletePackage');
Route::post('createPackageManifest', 'API\V1\ApiController@createPackageManifest');
Route::post('updatePackageManifest', 'API\V1\ApiController@updatePackageManifest');

// Passport routes for OAuth
Route::group(['middleware' => ['api']], function () {
    Route::post('oauth/token', [AccessTokenController::class, 'issueToken']);
    Route::post('oauth/authorize', [AuthorizationController::class, 'authorize']);
    Route::post('oauth/token/refresh', [TransientTokenController::class, 'refresh']);
    Route::get('oauth/clients', [ClientController::class, 'forUser']);
    Route::post('oauth/personal-access-tokens', [PersonalAccessTokenController::class, 'store']);
});

// Protected API routes (require authentication)
Route::middleware('auth:api')->group(function () {
    // Add any routes that require authentication here
    Route::get('protected-route', function () {
        return response()->json(['message' => 'You are authenticated!']);
    });
});
