<!DOCTYPE html>
    <html lang="en">
    <head>
        <title>Email</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
        <style>
            body {
                overflow-x: hidden;
            }
            @media (max-width:1280px) {
                .main_content ul {
                    width: 60% !important;
                }
            }
            @media (max-width:1180px) {
                .account_info {
                    width: 90% !important;
                }
            }
            @media (max-width:812px) {
                .email-bg {
                    width: 90% !important;
                }
            }
            @media (max-width: 767.98px) {
                .main_content ul {
                    width: 90% !important;
                }
            }
            @media (max-width: 600px) {
                .email-bg {
                    width: 90% !important;
                }
            }
            @media (max-width:480px) {
                .main_content ul {
                    width: 98% !important;
                    padding: 6px !important;
                    font-size: 14px;
                }
            }
            @media (max-width:380px) {
                .small_text {
                    font-size: 16px !important;
                }
                .email_content p {
                    font-size: 16px !important;
                }
                .main_content li {
                    font-size: 14px !important;
                }
            }
            @media (max-width:320px) {
                .small_text {
                    font-size: 14px !important;
                }
            }
        </style>
    </head>
    <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
        <main>
            <!----- EMAIL-SECTOION-START ------>
            <section class="email-bg"
                style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                <div class="container">
                    <header style="border-bottom: 1px solid #ccc;">
                        <img class="logo" src="<?php echo e($logo); ?>" alt="logo" style=" width:20%;">
                    </header>
                    <div class="email_content" style="
                    width: 100%;
                ">
                        <div style="border-bottom: 1px solid #ccc;">
                            <h4 style="font-size: 18px;margin-bottom: 0;color: #757575cc; ">BILL FROM:</h4>
                            <h3 style="font-size: 26px; margin:0; padding-top: 5px;"><?php echo e($settings->company_name); ?></h3>
                            <p style="font-size: 20px; margin: 0; padding-top: 5px;"><?php echo e($settings->local_address); ?></p>
                            <p style="font-size: 18px; margin: 0; padding: 6px 0;">Phone: <?php echo e($settings->phone); ?></p>
                        </div>
                        <div style="border-bottom: 1px solid #ccc;">
                            <h4 style="font-size: 18px;margin-bottom: 0;color: #757575cc;">BILL TO:</h4>
                            <h3 style="font-size: 26px; margin:0;  padding-top: 5px;"><?php echo e($user->first_name.' '.$user->last_name); ?></h3>
                            <p style="font-size: 20px; margin: 0; padding-top: 5px;"><?php echo e($user->address_1); ?></p>
                            <p style="font-size: 20px; margin: 0; padding-top: 5px;">Account no: <?php echo e($user->mailbox); ?></p>

                            <p style="margin: 0; padding: 6px 0;">Email: <a href="mailto:'.$user->email.'"><?php echo e($user->email); ?></a></p>
                        </div>
                        <div style="border-bottom: 1px solid #ccc;">
                            <p style="font-size: 20px;margin-bottom: 0;color: #757575cc;">Invoice #: <span style="color: #000; font-weight: 600;"><?php echo e($invoice->invoice_no); ?></span></p>

                            <p style="font-size: 20px; margin: 0; padding: 5px 0; color: #757575cc;">Date #: <span style="color: #000; font-weight: 600;"><?php echo e(date('d M, Y' , strtotime($invoice->created_at))); ?></span></p>
                        </div>
                        <div class="main_content" style="border-bottom: 1px solid #ccc;">
                    <?php
                        $count = 0;
                        $totalAmount = 0;
                        $totalServiceFee = 0;
                    ?>
                    <?php if(count($invoicesPack) > 0): ?>
                        <?php $__currentLoopData = $invoicesPack; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $pack): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                            <?php $count1 = $count + 1; ?>
                           <ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    #
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e($count1); ?></li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;vertical-align: text-bottom;">
                                    Description
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e($pack->package_description.' / '.$pack->package_weight); ?>lbs </li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    Custom Fee
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e(number_format($pack->custom_fee * $settings->us_rate ,2)); ?> JMD</li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    Service Fee
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e(number_format($pack->service_fee * $settings->us_rate ,2)); ?> JMD</li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    Freight
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e(number_format($pack->package_price * $settings->us_rate ,2)); ?> JMD</li>
                                <li style="display: inline-block;width: 32%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    Amount
                                </li>
                                <li style="display: inline-block; width: 66%; padding: 0 0 12px 0;"><?php echo e(number_format(($pack->package_price + $pack->custom_fee + $pack->service_fee) * $settings->us_rate ,2)); ?> JMD</li>
                            </ul>
                            <?php
                                $count ++;
                                $package_price = $pack->package_price * $usRate;
                                $service_fee = $pack->service_fee * $usRate;
                                $custom_fee = $pack->custom_fee * $usRate;
                                $totalAmount =  $totalAmount + $package_price + $service_fee + $custom_fee;
                                $totalServiceFee += $service_fee;
                            ?>
                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                        <?php endif; ?>


                            <ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    #
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e($count +1); ?></li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;vertical-align: text-bottom;">
                                    Description
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;">GCT</li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    GCT %
                                </li>
                                <?php
                                    if($invoice->gct == 0){
                                        $gct_label = '0%';
                                    }else{
                                        $gct_label = '15%';
                                    }
                                ?>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0;"><?php echo e($gct_label); ?></li>
                                <li style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                    GCT Amount
                                </li>
                                <?php
                                    if($invoice->gct == 0){
                                        $total_gct = 0  * $settings->us_rate;
                                        $gct = number_format(0  , 2).' JMD';
                                    }else{
                                        $total_gct = $totalServiceFee * 15 / 100;
                                        $gct = number_format($totalServiceFee * 15 / 100  ,2).' JMD';
                                    }
                                ?>
                                <li style="display: inline-block; width: 68%; padding: 0 0 12px 0;"><?php echo e($gct); ?></li>
                            </ul>
                            <?php //echo $total_gct;
                                $g_total = $totalAmount + $total_gct;                
                            ?>
                            <ul style="list-style: none;width: 40%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                <li
                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                    Sub- Total amount
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0; "><?php echo e(number_format($g_total ,2)); ?> JMD</li>
                                <li
                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                    Discount
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 10px 0; "><?php echo e(number_format($invoice->discount_price ,2)); ?> JMD</li>
                                <li
                                    style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#000;">
                                    Grand Total
                                </li>
                                <li style="display: inline-block; width: 68%; padding: 0 0 12px 0;"><?php echo e(number_format($g_total  - $invoice->discount_price ,2)); ?> JMD</li>
                                <!--<li style="display: inline-block; width: 68%; padding: 0 0 12px 0;"><a href="https://pay.lascobizja.com/btn/MTVLU1yGC3qs" target ="blank"><div class="" style="width:155px;"><div class="" style="display: table-cell;background: #8d3eb0;vertical-align: middle;color: #fff;border-right: 1px solid #fff;width:55px;padding: 1%;text-align:center;border-radius:12px 0px 0px 12px;"> <img src="https://merchant-portal.lascobizja.com/template/assets/images/lasco-favicon.png" style="width:90%;">  </div> <div class="" style="display: table-cell;background:#8d3eb0;vertical-align: middle;padding: 3px 5px;color: #fff;border-radius:0px 12px 12px 0px;"> <span id="" style="font-size: 14px;display: block;text-transform:capitalize;line-height: 10px;margin-top: 4px;">Pay Now</span> <span style="font-size: 10px;">Powered by Lasco</span> </div> </div></a></li>-->
                                
                            </ul>
                        </div>
                        <div>
                            <h4 style="color: #636363;">Thank You for your business</h4>
                            <h4 style="color: #636363;">Invoice powered by <?php echo e($settings->company_name); ?></h4>
                        </div>
                    </div>

                </div>
                <footer>
                    <h4 style="border-top: 1px solid #ccc; font-size: 13px; color: #8c8c8c;">Thanks for your support Enjoy
                        your shopping experience. </h4>
                    <p style="font-size: 13px; color: #8c8c8c;">Best Wishes</p>
                    <p style="font-size: 13px; color: #8c8c8c;"><?php echo e($settings->company_name); ?> Client Services</p>
                </footer>
                </div>
            </section>
            <!----- EMAIL-SECTOION-END ------>
        </main>
    </body>
    </html>
<?php /**PATH /home/uniquemedia/public_html/tracking/resources/views/admin/invoices/invoice_print_email.blade.php ENDPATH**/ ?>