<?php

namespace App\Exports;

use App\Dealer;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class DealersExport implements FromCollection, WithHeadings, ShouldAutoSize, WithEvents
{
    public function collection()
    {
        return Dealer::select('id','seller_name','contact_person','phone_1','phone_2','whatsapp_no','address','locality','city','machine_service','more_products','status','created_at')->get();
    }

    public function headings(): array
    {   
        return [
            '#',
            'Seller Name',
            'Contact Person',
            'Phone 1',
            'Phone 2',
            'Whatsapp no.',
            'Address',
            'Locality',
            'City',
            'Machine Service',
            'More Products',
            'Status',
            'Created at'
        ];
    }

    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $cellRange = 'A1:W1'; // All headers
                $event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(14);
            },
        ];
    }



}