<?php

namespace App\Exports;

use App\LeadCallNew;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;

class LeadsNewExport implements FromCollection, WithHeadings, ShouldAutoSize, WithEvents
{
    public function collection()
    {

        return LeadCallNew::select('id','order_id','assigned_to','order_total','order_status','caller_name','requirement_city','CallFrom','lending_url','signup_url','source_landing','medium_landing','campaign_landing','content_landing','term_landing','product_name','requirement_details','status','reason','last_update')->get();
    }
    public function headings(): array
    {
        return [
            'ID',
            'Order ID',
            'Assigned To',
            'Order Value',
            'Order Status',
            'Name',
            'City',
            'Phone',
            'Lending Url',
            'Signup Url',
            'Source Landing',
            'Medium Landing',
            'Campaign Landing',
            'Content Landing',
            'Term Landing',
            'Product',
            'Comment',
            'Status',
            'Status Detail',
            'Date'
        ];
    }

    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $cellRange = 'A1:W1'; // All headers
                $event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(14);
            },
        ];
    }



}
