<?php

namespace App\Exports;

use App\Order;
use Maatwebsite\Excel\Concerns\FromCollection;
use Maatwebsite\Excel\Concerns\WithHeadings;
use Maatwebsite\Excel\Concerns\WithEvents;
use Maatwebsite\Excel\Events\AfterSheet;
use Maatwebsite\Excel\Concerns\ShouldAutoSize;
use DB;

class OrdersExport implements FromCollection, WithHeadings, ShouldAutoSize, WithEvents
{
    public function collection()
    {
        return Order::select('orders.id','orders.order_id','ecom_tbl_customers.customer_name','orders.city','ecom_tbl_customers.phone','orders.total_price','orders.our_price','orders.payment_method','orders.order_status','orders.cancel_reason',DB::raw('DATE_FORMAT(orders.expected_delivery, "%Y-%m-%d") as expected_date'),DB::raw('DATE_FORMAT(orders.actual_delivery, "%Y-%m-%d") as actual_date'),'orders.delivery_delay','ecom_tbl_customers.url',DB::raw('DATE_FORMAT(orders.created_at, "%Y-%m-%d") as orde_date'),'orders.order_source','orders.order_detail')
                    ->join('ecom_tbl_customers','ecom_tbl_customers.id','=','orders.user_id')
                    ->orderby('orders.created_at' , 'desc')
                    ->get();
    }
    public function headings(): array
    {
        return [
            'ID',
            'Order ID',
            'Name',
            'City',
            'Phone',
            'Bill Amount',
            'Our Price',
            'Payment',
            'Status',
            'Comment',
            'Expected Date',
            'Delivery Date',
            'Delay',
            'Landing Page',
            'Order Date',
            'Source',
            'Order Detail'
        ];
    }

    public function registerEvents(): array
    {
        return [
            AfterSheet::class => function(AfterSheet $event) {
                $cellRange = 'A1:W1'; // All headers
                $event->sheet->getDelegate()->getStyle($cellRange)->getFont()->setSize(14);
            },
        ];
    }



}
