<?php
namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\GarbageCollection;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use App\Models\AuthUser;
use App\Models\Purchase;
use App\Models\Appointment;
use Session;
use Auth;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;
use Razorpay\Api\Api;

class PurchaseApiController extends Controller
{

    public $order_number;
    public function __construct()
    {
        $this->order_number = date("Ymd") . strtoupper(substr(uniqid(sha1(time())),0,4));

        //$this->middleware('auth')->except('thanks');
    }

    public function AddPurchase(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $purchase = new Purchase();
            $purchase->user_id = Auth::user()->user_id;
            $purchase->name = request()->name;
            $purchase->link = request()->link;
            $purchase->qty = request()->qty;
            $purchase->notes = request()->notes;
            $purchase->created_at = date('Y-m-d h:i:s');
            $purchase->updated_at = date('Y-m-d h:i:s');
            $purchase->save();
            return ['status' => true, 'message' => 'Purchase created successfully.', 'data' => $purchase];
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function GetPurchase(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $offset = request()->offset * 20;
            $purchase = Purchase::where('user_id' , Auth::user()->user_id)->skip($offset)->take(20)->get();
            if($purchase){
                return ['status' => true,  'message' => 'Purchase data found.','data' => $purchase];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => $purchase];
            }
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }

    public function EditPurchase(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $purchase = Purchase::where('id' , request()->id)->first();
            if($purchase){
                return ['status' => true,  'message' => 'Purchase data found.','data' => $purchase];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => null];
            }
            
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    public function UpdatePurchase(){
        try{
           $purchase = Purchase::where('id' , request()->id)->first();
            if($purchase){
                Purchase::where('id' , request()->id)->update(['name' => request()->name,'link' => request()->link,'qty' => request()->qty,'notes' => request()->notes]);
                $purchase = Purchase::where('id' , request()->id)->first();
                return ['status' => true,  'message' => 'Purchase updated successfully.','data' => $purchase];
            }else{
                return ['status' => false,  'message' => 'No data found.' , 'data' => null];
            }
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
}
