<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Validation\Rule;
use App\Models\User;
use App\Models\UserLanguage;
use App\Models\Booking;
use App\Models\UserAvailability;
use App\Models\AvailabilitySlots;
use App\Models\UserLogin;
use App\Models\Location;
use App\Models\Appointment;
use App\Models\Department;
use App\Models\Milongas;
use App\Models\Area;
use App\Models\SocialLogins;
use App\Models\Notification;
use App\Models\Outlet;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Str;
use Carbon\Carbon;
use Laravel\Passport\RefreshToken;
use Laravel\Passport\Token;
use URL;
use Auth;
use Mail;
use DB;
use App\Classes\CommonLibrary;
use commonHelper;
use Log;

class UserController extends Controller
{
    //
    
    public function GetMetraAppInformation(){
        try{
            $jsonrequest = json_decode(file_get_contents('php://input'), true);
            $setting = DB::table('settings')->select('site_name','base_url','app_logo','site_title','btn_color','text_color')->first();
            $setting->app_logo = url('/public/settings').'/'.$setting->app_logo;
            $data['setting'] = $setting;
            return ['status' => true, 'message' => 'Meta information data found.','data' => $data];
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }
    
    /*****User Registration Api****/
    public function registerUser(Request $request) {
        //$user_id = commonHelper::generateBarcodeNumber();

        /***********check email exists ***********/
        $jsonrequest = json_decode(file_get_contents('php://input'), true);
        $loginToken=Str::random(30);
        $email =  $jsonrequest['email'];
        if(User::where('email', '=', $email)->exists()){
            return ['status' => false, 'message' => 'Email already exist', 'data' => null];
        }
        $setting = DB::table('settings')->first();
        $usersRes = User::orderby('user_id' , 'DESC')->first();
        //dd($usersRes);
        //return $usersRes->user_id;
        $user_id_mail = $usersRes->user_id + 1;
        if($usersRes){
            if($usersRes->user_id > 1000){
                $mailBoxNo = $setting->pre_fix.'0';
            }elseif($usersRes->user_id > 100){
                $mailBoxNo = $setting->pre_fix.'00';
            }else{
                $mailBoxNo = $setting->pre_fix.'000';
            }
        }else{
            $mailBoxNo = $setting->pre_fix.'0001';
        }
        $mailbox = $mailBoxNo.$user_id_mail;
        $users = new User();
        $users->mailbox = $mailbox;
        $users->first_name = $request->first_name;
        $users->outlet_id = $request->outlet_id;
        $users->last_name = $request->last_name;
        $users->user_name = $request->first_name.' '.$request->last_name;
        $users->email = $request->email;
        $users->password = Hash::make($request->password);
        $users->dob = 01;
        $users->address_1 = $request->address_1;
        $users->address_2 = $request->address_2;
        $users->city = $request->city;
        $users->state = $request->state;
        $users->country = $request->country;
        $users->phone = $request->phone;
        $users->mobile = $request->mobile;
        $users->user_type = $request->user_type;
        $users->trn = $request->trn;
        $users->tcc_issue_date = $request->tcc_issue_date;
        $users->tcc_expiry_date = $request->tcc_expiry_date;
        $users->Business_trn = $request->Business_trn;
        $users->created_at = date('Y-m-d h:i:s');
        $users->updated_at = date('Y-m-d h:i:s');
        $users->save();
        $userLoginData=new UserLogin();
        $userLoginData->user_id = $users->user_id;
        $userLoginData->device_type = $request->device_type;
        $userLoginData->device_token = $request->device_token;
        $userLoginData->login_token= $loginToken;
        $userLoginData->app_version = $request->app_version;
        $userLoginData->time_zone = $request->time_zone;
        $userLoginData->save();
        $user_id = $users->user_id;
        //User::where('user_id' , $user_id)->update(['mailbox'=>'OPC-00'.$user_id]);
        $userRes = User::where('user_id' , $user_id)->first();
        if($userRes){
            $mailboxRes = $userRes->mailbox;
            $outlet = Outlet::where('outlet_id',$request->outlet_id)->first();
            if($outlet){
                $short_name = $outlet->short_name;
            }else{
                $short_name = '';
            }
            $malRes = explode('-',$mailboxRes);
            $mailbox = $malRes[0].'-'.$short_name.'-'.$malRes[1];
        }

        
        $link = URL::to('/');
        $email_subject = 'User Registration';
        $user_name = $request->first_name.' '.$request->last_name;
        //$address = $request->address_1.','.$request->city.','.$request->state.','.$request->country.','.$request->postal_code;
        //$address = $user_name.' '.$mailBoxNo.$user_id.' '.$setting->package_shipping_address_1;
        $address1 = $user_name;
        $address2 = $setting->package_shipping_address_1;
        $address3 = $mailbox;
        $address4 = $setting->city;
        $address5 = $setting->state;
        $address6 = $setting->zip;
        $email_from = $setting->from_email;
        $logo = URL::to('/') . '/settings/'.$setting->site_logo;
        $company_name = $setting->company_name;
        $this->send_email_register($request->email, $user_name,$request->password,$mailbox,$setting->phone,$address1,$address2,$address3,$address4,$address5,$address6,$email_subject, $email_from, $link,$logo,$company_name, 'register_email');
        
        /***********Create Token and return User data***********/

        $user_res=User::where('user_id',$user_id)->first();
        $user_res->accessToken = $user_res->createToken('Register Access Token')->accessToken;
        $user_res->loginToken=$loginToken;
        if($user_res->image != ''){
            $user_res->image = url('/public/users/').'/'.$user_res->image;
        }else{
            $user_res->image = url('/public/dummy-user-small.png');
        }
        return [ 'status' => true, 'message' => 'User register successfully', 'data' => $user_res];
            
    }
    
    public function send_email_register($email, $user_name,$password,$mailbox,$phone,$address1,$address2,$address3,$address4,$address5,$address6, $email_subject, $email_from, $link,$logo,$company_name,$view_name) {
        $subject = $email_subject;
        $headers = "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
       $headers .= "From: Brown Box Company Limited <updates@brown-box.com>\n";
        $message = '<!DOCTYPE html>
                        <html lang="en">
                        <head>
                            <title>Email</title>
                            <meta charset="utf-8">
                            <meta name="viewport" content="width=device-width, initial-scale=1">
                            <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
                            <style>
                                body{
                                    overflow-x: hidden;
                                }
                                @media (max-width:1180px) {
                                    .account_info {
                            width: 90% !important;
                        }  
                                }
                        
                                @media (max-width: 767.98px) {
                                   
                                }
                                @media (max-width: 600px) {
                                   .email-bg{
                                       width: 90%  !important;
                                   }
                                }
                            @media (max-width:380px){
                                .small_text{
                                    font-size: 16px  !important;
                                }  
                                .email_content p {
                                    font-size: 16px !important;
                                }
                            }
                            @media (max-width:380px){
                                .small_text{
                                    font-size: 14px  !important;
                                }  
                                .account_info span {
                                    margin: 0 0 0 60px !important;
                                }
                            }
                            </style>
                        </head>
                        <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
                            <main>
                                <!----- EMAIL-SECTOION-START ------>
                                <section class="email-bg" style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                                    <div class="container">
                                        <header style="border-bottom: 1px solid #ccc;">
                                            <img class="logo" src="'.$logo.'" alt="logo" style=" width:20%;">
                                        </header>
                                        <div class="email_content" style="
                                        width: 100%;
                                    ">
                                            <h4 style="font-size: 24px; margin-bottom: 0;">Dear '.$user_name.'</h4>
                                            <p style="font-size: 20px;">We would like to thank you for joining the '.$company_name.' family. We are looking forward to creating a great business relationship while giving you the best logistics service experience possible.</p>
                                             <a href="'.$link.'">'.$link.'</a>
                                            <p style="font-size: 20px;">Please see your account details below</p>
                                            <p style="font-size: 20px;">Please login and upload your invoice by visiting below site  at the following address</p>
                                            <a href="'.$link.'/admin/dashboard">'.$link.'/admin/dashboard</a>
                                           <div class="account_info" style="  width: 30%;
                                           border: 1px solid #cccc;
                                           padding: 0 8px;">
                                               <p ><b>Account no.</b> <span style="font-size: 14px;margin: 0 0 0 80px;float: right;">'.$mailbox.'</span></p>
                                               <p><b>Username </b> <span style="font-size: 14px;margin: 0 0 0 80px;float: right;"><a href="mailto:'.$email.'">'.$email.'</a></span></p>
                                           </div>
                                            <p style="font-size: 20px;">Please follow the format below when placing your order.</p>
                                            <h4>Shipping Address:</h4>     
                                            <p><b>Name:</b><span>'.$address1.'</span></p>
                                            <p><b>Address Line 1:</b><span>'.$address2.'</span></p> 
                                            <p><b>Address Line 2:</b><span>'.$address3.'</span></p> 
                                            <p><b>City:</b><span>'.$address4.'</span></p>   
                                            <p><b>State:</b><span>'.$address5.'</span></p>    
                                            <p><b>Zip:</b><span>'.$address6.'</span></p>              
                                        </div>
                                        <footer>
                                            <h4 style="font-size: 14px;border-top: 1px solid #ccc; font-size: 13px; color: #8c8c8c;">Thank you for your support and we hope you Enjoy your shopping experience. </h4>
                                            <p style="font-size: 13px; color: #8c8c8c;">Best Wishes</p>
                                            <p style="font-size: 13px; color: #8c8c8c;">'.$company_name.' Client Services</p>
                                        </footer>
                                    </div>
                                </section>
                                <!----- EMAIL-SECTOION-END ------>
                        
                            </main>
                        </body>
                        </html>';
            $user_email = $email;
            mail($user_email,$subject,$message,$headers);
    }

    function checkSocial($social_type,$social_id) {
        return User::whereSocialType($social_type)
                    ->whereSocialId($social_id)
                    ->exists();
    }



    public function loginUser(Request $request) {
        $imageUrl = url('users/').'/';
        //$user = User::with(['availability','language_speak'])->where('email', $request->email)->first();
        $user = User::where('email', $request->email)->where('user_access',1)->first();
        //$user =User::with(['location','getDepartment'])->select('user_id','is_profile_updated','name', 'email' , 'phone','image','age','address','lati', 'longi','user_type' ,'social_type','experience','description','location_id','department_id')->where('email', $request->email)->first();
        if ($user!=null) {
            $loginToken=Str::random(30);;
            if (Hash::check($request->password, $user->password) || Hash::check($request->password, $user->temp_password)) {
                $user = User::where('email', $request->email)->first();
                $userLoginData=new UserLogin();
                $userLoginData->user_id = $user->user_id;
                $userLoginData->device_type = $request->device_type;
                $userLoginData->device_token = $request->device_token;
                $userLoginData->login_token=$loginToken;
                $userLoginData->app_version = $request->app_version;
                $userLoginData->time_zone = $request->time_zone;
                $userLoginData->save();
                $user->accessToken = $user->createToken('Login Acccess Token')->accessToken;
                $user->loginToken=$loginToken;
                if($user->image != ''){
                    $user->image = url('/public/users/').'/'.$user->image;
                }else{
                    $user->image = url('/public/dummy-user-small.png');
                }
                return [ 'status' => true, 'message' => 'User logedIn successfully','data' => $user];
            } else {
                return ['status' => false,  'message' => 'Password mismatch' ,'data' => null];
            }
        } else {
            return ['status' => false, 'message' => 'Please check your email or phone number again.This email doesn\'t exist in our database.','data' => null];
        }
    }


    /*****LougOut Api***/
    public function logout(Request $request){

        if (Auth::user())
        {
            UserLogin::where('login_token',$request->loginToken)->delete();
            $accessToken = Auth::user()->token();
            $user_access = Auth::user()->user_access;
            $token= $request->user()->tokens->find($accessToken);
            $token->revoke();
            $response=array();

            return ['status' => true,  'message' => 'Successfully logged out','data' => null];
        } else {
            return ['status' => false, 'message' => 'Already Logged OUt','data' => null];
        }


    }
    
    public function DeleteUser() {
        try{
            $user_id = Auth::user()->user_id;
            $users = User::where('user_id' , $user_id)->first();
            if($users){
                DB::table('packages')->where('mailbox' , $users->mailbox )->delete();
                //DB::table('package_requests')->where('mailbox' , $users->mailbox )->delete();
                $invoice = DB::table('invoices')->where('mailbox_no' , $users->mailbox )->get();
                if(count($invoice) > 0){
                    foreach($invoice as $row){
                        DB::table('invoice_packages')->where('invoice_id' , $row->invoice_id )->delete();
                    }
                }
                
                $invoice = DB::table('invoices')->where('mailbox_no' , $users->mailbox )->delete();
                $delete = User::where('user_id' , $user_id)->delete();
                return ['status' => true, 'message' => 'Your account has been deleted.','data' => null];
            }else{
                return ['status' => false, 'message' => 'No user found.','data' => null];
            }
            
        
        }catch(\Exception $e){
            return ['status' => false, 'user_access' => 0, 'message' => $e->getMessage()];
        }
    }


    /*****Forgot Password Api***/
    public function forgotPassword(Request $request){

        $jsonrequest = json_decode(file_get_contents('php://input'), true);
        $email =  $jsonrequest['email'];

        $user = User::firstWhere('email', $email);
        if($user) {
            // generate OTP
            //$otp_number = random_int(1000, 9999);
            //User::where('email', $email)->update(['otp'=> $otp_number]);


            $user_name = $user->first_name;
            $pin = base64_encode($jsonrequest['email']);
            $link = URL::to('/') . '/user/reset_password/' . $pin;
            //$logo = URL::to('/') . '/settings/'.$settings->site_logo;
            $email_from = 'alert@remedeor.com';
            // Mail::send('email.forgetPassword', ['user_name' => $user_name,'link'=>$link,'email'=>$email], function($message) use($email){
            //     $message->to($email);
            //     $message->subject('Reset Password');
            // });
            // $subject = 'Password Reset Request';
            // $headers = "From:noreply@tangoapp.ar";
            // $headers .= "MIME-Version: 1.0\r\n";
            // $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
            // $message = '
            // <html>
            //     <head>
            //         <title>Forgotten Password</title>
            //     </head>
            //     <body>
            //         <div style="max-width:500px;margin:0px auto;font-family:arial;">
            //             <div style="width:100%;float:left;display:table;border-bottom:1px solid #ddd;padding:10px;">
            //                 <img src="" width="150" style="display:block;">
            //             </div>
            //             <div style="font-size:17px;font-family:arial;color:#555;display:table;width:100%;padding:10px;margin-top:15px;min-height:200px;">
            //                 <p>Hi '.$user_name.',</p>
            //                 <p>We received a request to reset your TangoApp password. Click the button below.</p>
            //                 <br>
            //                 <p>
            //                 <a href="'.$link.'" style="background: #000; color: #fff !important;text-decoration:none;padding:10px 20px 10px 20px;">Set New Password</a>
            //                 </p>
            //             </div>
            //             <div style="font-size:17px;font-family:arial;color:#555;display:table;width:100%;padding:10px;margin-top:15px;border-bottom:1px solid #ddd;">
            //                 <p><b>Didn\'t request this change?</b><br>
            //                 If you didn\'t request a new password... Ignore this mail.</p>
            //             </div>
            //             <p style="font-size:10px;color:#999;font-family:arial">
            //                 This message was sent to '.$email.' at your request.<br>
            //                 The TangoApp Team!.
            //             </p>

            //         </div>
            //     </body>
            // </html>';
            // mail('deepbansal168@gmail.com',$subject,$message,$headers);

            return ['status' => true, 'message' => 'Email send successfully','data' => $email];
        } else {
            return ['status' => false,  'message' => "Email Does't Exists",'data' => null];
        }
    }


    /*****Verify Otp Api***/
    public function GetMetaInformation(Request $request){

        $jsonrequest = json_decode(file_get_contents('php://input'), true);
        $email =  $jsonrequest['email'];
        // collect  mobile number
        //$email = $request->email;
        $otp = $request->otp;
        // check if account exists
        $user = User::firstWhere('email', $email);
        if($user) {
            // generate OTP
            if($user->otp==$otp){
                return ['status' => true, 'user_access' => $user->user_access, 'email' => $email, 'otp' => $otp, 'message' => 'Otp Matched successfully'];
            } else {
                return ['status' => false, 'user_access' => 0, 'email' => $email, 'otp' => $otp, 'message' => "Otp does't match"];
            }
        } else {
            return ['status' => false, 'user_access' => 0, 'email' => $email, 'otp' => $otp, 'message' => "Email Does't Exists"];
        }
    }


    public function changePassword(Request $request){

        // collect  mobile number
        $email = $request->email;
        $new_pass = $request->new_pass;

        // check if account exists
        $user = User::firstWhere('email', $email);
        if ($user){

            User::where('email', $email)->update(['password' => Hash::make($new_pass)]);
            return ['status' => true, 'message' => 'Password Updated successfully','data' => $email];
        } else {
            return ['status' => false,  'message' => 'User Not Exists','data' => null];
        }
    }


    public function updatePassword(Request $request){

        // collect  mobile number
        $email = Auth::user()->email;
        $old_pass = $request->old_pass;
        $new_pass = $request->new_pass;

        // check if account exists
        $user = User::firstWhere('email', $email);
        if (Hash::check($request->old_pass, $user->password)) {

            User::where('email', $email)->update(['password' => Hash::make($new_pass)]);
            return ['status' => true, 'message' => 'Password Updated successfully','data' => $email];
        } else {
            return ['status' => false,  'message' => 'Wrong Old password','data' => null];
        }
    }


    public function getProfile(){
        $imageUrl = url('users/').'/';
        if (Auth::check()){
            $user = User::where('user_id', Auth::user()->user_id)->first();
            if($user->image != ''){
                $user->image = url('/public/users/').'/'.$user->image;
            }else{
                $user->image = url('/public/dummy-user-small.png');
            }
            // unset($user->created_at);
            // unset($user->updated_at);
            // unset($user->social_type);
            // unset($user->otp);
            // unset($user->email_verified_at);
            return ['status' => true, 'message' => 'User profile data', 'data' => $user];
        } else {
            return ['status' => false, 'message' => 'User not found', 'data' => null];
        }
    }


    public function editProfile(Request $request) {
        $imageUrl = url('users/').'/';
        /***********check email exists ***********/
        $jsonrequest = json_decode(file_get_contents('php://input'), true);
        //$email =  $jsonrequest['email'];

            $loginToken=Str::random(30);;

            if($request->email != null){
                $emailCheck=User::firstWhere('email',$request->email);
                if($emailCheck!=null){
                    return ['status' => false, 'message' => 'This email is already taken. Please try with another email. ', 'data' => null];
                }else{
                    User::where('user_id',Auth::user()->id)->update(['email'=>$request->email]);
                }
            }
            $image_name = User::where('user_id',Auth::user()->user_id)->first()->image;
            if ($request->hasFile('user_image')) {
                $image_name = '';
                $admin_img = User::where('user_id',Auth::user()->user_id)->first();
                if($admin_img){
                    $avater = $admin_img->image;
                    @unlink(base_path() . '/public/users/' . $avater);
                }

                $imageTempName = $request->file('user_image')->getPathname();
                $venue_img_extension = $request->user_image->extension();
                $imageName = uniqid() . '.' . $venue_img_extension;
                $path = base_path() . '/public/users/';
                $request->file('user_image')->move($path, $imageName);
                $image = $imageName;
            } else {
                $image = '';
                $admin_img = User::where('user_id',Auth::user()->user_id)->first();
                if($admin_img){
                    $image = $admin_img->image;
                }
            }
            /*******************Update User *************/
            $user = User::find(Auth::user()->user_id);
            $user->first_name = $request->first_name;
            $user->last_name = $request->last_name;
            $user->user_name = $request->first_name.' '.$request->last_name;
            $user->user_type = $request->user_type;
            $user->outlet_id = $request->outlet_id;
            $user->phone = $request->phone;
            $user->trn = $request->trn;
            $user->tcc_issue_date = $request->tcc_issue_date;
            $user->tcc_expiry_date = $request->tcc_expiry_date;
            $user->Business_trn = $request->Business_trn;
            $user->address_1 = $request->address_1;
            $user->address_2 = $request->address_2;
            $user->city = $request->city;
            $user->state = $request->state;
            $user->country = $request->country;
            $user->image = $image;
            $user->save();
            $user = User::where('user_id', Auth::user()->user_id)->first();
            if($user->image != ''){
                $user->image = url('/public/users/').'/'.$user->image;
            }else{
                $user->image = url('/public/dummy-user-small.png');
            }
            return ['status' => true, 'message' => 'User updated successfully', 'data' => $user];
    }

    public function updateProfileImage(Request $request) {

        /*******************Update User *************/
        try{
            $user = User::find(Auth::user()->user_id);
            $user->user_image = $request->user_image;
            $user->save();
            return ['status' => true, 'user_access' => 1, 'message' => 'Profile Image updated successfully'];
        }catch(Expection $e){
            return ['status' => false, 'user_access' => 1, 'message' => $e];
        }

    }

    public function deleteAccount(){
        if (Auth::check()){
            $user = User::where('user_id', Auth::user()->user_id)->update(['user_access' => 0]);
            return ['status' => true, 'user_access' => 0,  'message' => 'User account has been deleted successfully.', 'user_data' => $user];
        } else {
            return ['status' => false,  'user_access' => Auth::user()->user_access,  'message' => 'User not found', 'user_data' => null];
        }
    }

    public function getOutlets(){
        try{
            $patientArray = [];
            $outlets = Outlet::select('outlet_id','outlet_name')->get();
            return ['status' => true, 'message' => 'Outlets list found.','data' => $outlets];
        }catch(\Exception $e){
            return ['status' => false,  'message' => $e->getMessage(),'data' => null];
        }
    }
    
    public function getAreas(){
        try{
            $patientArray = [];
            $areas = Area::get();
            $days = DB::table('days_selected')->join('days' , 'days.id','=','days_selected.day_id')->get();
            $dataArr['areas'] = $areas;
            $dataArr['days'] = $days;
            return ['status' => true, 'message' => 'Areas list found.','data' => $dataArr];
        }catch(\Exception $e){
            return ['status' => false,  'message' => $e->getMessage(),'data' => null];
        }
    }
    
    public function getDays(){
        try{
            $patientArray = [];
            $days = DB::table('days_selected')->join('days' , 'days.id','=','days_selected.day_id')->get();
            return ['status' => true, 'message' => 'Days list found.','data' => $days];
        }catch(\Exception $e){
            return ['status' => false,  'message' => $e->getMessage(),'data' => null];
        }
    }


    function getNotifications(Request $request){
        try{
                $offset = $request->offset + 20;
                $notifications= Notification::where('notifications.reciever_user_id',Auth::user()->user_id)
                                ->skip($request->offset)->take(20)
                                ->orderBy('notifications.created_at','DESC')
                                ->get();
                //Notifications::where('user_id',Auth::user()->user_id)->where('status',0)->update(['status'=>1]);
                $user_access = Auth::user()->user_access;
                return ['status' => true, 'user_access' => $user_access, 'message' => 'Notification List','offset'=>$offset, 'notification_list' => $notifications];

        }catch(Expection $e){
                return ['status' => false, 'user_access' => 1, 'message' => $e];
        }
    }

}
