<?php
namespace App\Http\Controllers\Api\V1;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use phpDocumentor\Reflection\Types\Self_;
use Illuminate\Support\Facades\Hash;
use App\Models\UserLoginData;
use App\Models\User;
use App\Models\Package;
use App\Models\PackageStatus;
use App\Models\Setting;
use App\Models\ManifestInfo;
use App\Models\Manifest;
use App\Models\ManifestPackage;
use GuzzleHttp\Exception\GuzzleException;
use GuzzleHttp\Client;
use Session;
use DB;
use Mail;
use URL;
use Illuminate\Support\Facades\Log;

class ApiController extends Controller
{
    
    public  function __construct()
    {

    }

    public function GetUsers(){
        try{
            $users = User::select('user_id','mailbox','email','first_name','last_name','phone')->where('role_id' , 0)->orderBy('first_name' , 'ASC')->get();
            //return count($trims);
            $usersArray = [];
            if(count($users) > 0){
                return response()->json(['status'=>"success","message"=>'Users data found.','data' => $users],200);
            }else{
                return response()->json(['status'=>"success","message"=>'No data found.','data' => []],200);
            }
        }catch(\Exception $e){
            return response()->json(['status'=>"failed","message"=>$e->getMessage(),"user_access" => 1],200);
        }
    }
    
    public function GetUsersNew(){
        try{
            $limit = 5000;
            $offset = request()->offset + $limit;
            $users = User::select('mailbox','email','first_name','last_name')->where('role_id' , 0)->orderBy('first_name' , 'ASC')->skip(request()->offset)->take($limit)->get();
            //return count($trims);
            $usersArray = [];
            if(count($users) > 0){
                return response()->json(['status'=>"success","message"=>'Users data found.',"offset"=>$offset,'data' => $users],200);
            }else{
                return response()->json(['status'=>"success","message"=>'No data found.',"offset"=>$offset,'data' => []],200);
            }
        }catch(\Exception $e){
            return response()->json(['status'=>"failed","message"=>$e->getMessage(),"user_access" => 1],200);
        }
    }
    
    public function savePackage(Request $request){
        try{
            $packagesCheck = DB::table('packages')->where('supplier_tracking_no',$request->supplier_tracking_no)->where('status','!=',9)->first();
            if($packagesCheck){
                return ['status'=>false,"message"=>'Supplier tracking no. already exist, try with another one'];
            }
            $TrackingCheck = DB::table('packages')->where('tracking_no',$request->tracking_no)->first();
            if($TrackingCheck){
                return ['status'=>false,"message"=>'Tracking no. already exist, try with another one'];
            }
            $usersRes = User::where('mailbox' , $request->mailbox)->first();
            $user_name = $usersRes->first_name.' '.$usersRes->last_name;
            $packages = new Package();
            $packages->tracking_no = $request->tracking_no;
            $packages->mailbox = $request->mailbox;
            $packages->outlet_id = $usersRes->outlet_id;
            $packages->user_name = $user_name;
            $packages->courier = $request->courier;
            $packages->supplier_tracking_no = $request->supplier_tracking_no;
            $packages->package_type = $request->package_type;
            $packages->package_code = $request->package_type;
            $packages->weight = $request->weight;
            $packages->manifest_no = $request->manifest_no;
            $packages->price = $request->price;
            $packages->status_name = 'Arrived in Miami';
            $packages->item_description = $request->item_description;
            $packages->created_at = date('Y-m-d h:i:s');
            $packages->updated_at = date('Y-m-d h:i:s');
            $packages->save();
            
            
            
            $link = URL::to('/') . '/admin/dashboard';
            $settings = DB::table('settings')->first();
            $email_subject = 'Brand New UPDATE from '.$settings->company_name;
            $settings = DB::table('settings')->first();
            if($settings){
                $email_from = $settings->from_email;
            }
            $status = 'Arrived in Miami';
            $settings = DB::table('settings')->first();
            $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
            $company_name = $settings->company_name;
            $this->send_email_packeg($usersRes->email, $user_name,$request->tracking_no,$request->supplier_tracking_no,$request->mailbox,$request->courier,$request->item_description,$request->weight,$status,$email_subject, $email_from,$logo,$company_name, 'create_packege');
            return ["status" => true,"message"=>"Package has been created successfully."];
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    public function checkPackage(Request $request){
        try{
            $packagesCheck = DB::table('packages')->where('supplier_tracking_no',$request->supplier_tracking_no)->where('status','!=',9)->first();
            if($packagesCheck){
                return ['status'=>false,"message"=>'Supplier tracking no. already exist, try with another one'];
            }
            $TrackingCheck = DB::table('packages')->where('tracking_no',$request->tracking_no)->first();
            if($TrackingCheck){
                return ['status'=>false,"message"=>'Tracking no. already exist, try with another one'];
            }
            return ["status" => true,"message"=>"Package has been created successfully."];
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    public function deletePackage(Request $request){
        try{
            $packagesCheck = DB::table('packages')->where('tracking_no',$request->tracking_no)->first();
            if($packagesCheck){
                DB::table('packages')->where('tracking_no',$request->tracking_no)->delete();
                return ['status'=>true,"message"=>'Package has been deleted successfully.'];
            }else{
                return ["status" => false,"message"=>"Package not found."];
            }
            
            
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    public function updatePackageStatus(Request $request){
        try{
            $package_ids = explode(',' ,$request->package_ids);
            //dd($package_ids);
            if(count($package_ids) > 0){
                foreach($package_ids as $key => $val){
                    DB::table('packages')->where('tracking_no', $val)->update(['status_name' => $request->status_name , 'status' => $request->status]);
                    $packages = DB::table('packages')->where('tracking_no', $val)->first();
                    if($packages){
                         $usersRes = User::where('mailbox' , $packages->mailbox)->first();
                        //dd($usersRes);
                        $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                        $link = URL::to('/') . '/admin/dashboard';
                        $settings = DB::table('settings')->first();
                        $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                        $settings = DB::table('settings')->first();
                        if($settings){
                            $email_from = $settings->from_email;
                        }
                        $name = PackageStatus::where('id' , $packages->status)->first()->name;
                        $status = $name;
                        $settings = DB::table('settings')->first();
                        $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
                        $company_name = $settings->company_name;
                        $this->send_email_packeg_update($usersRes->email, $user_name,$packages->tracking_no,$packages->supplier_tracking_no,$packages->mailbox,$packages->courier,$packages->item_description,$packages->weight,$status,$email_subject, $email_from,$logo,$company_name, 'update_packege');
                    }
                }
                return ["status" => true,"message"=>"Package status has been updated successfully."];
            }else{
                return ['status'=>false,"message"=>'Package not found.'];
            }
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    public function updatePackageUser(Request $request){
        try{
            $packagesCheck = DB::table('packages')->where('tracking_no',$request->tracking_no)->first();
            if($packagesCheck){
                $user = User::where('mailbox' , $request->mailbox)->first();
                DB::table('packages')->where('tracking_no',$request->tracking_no)->update(['mailbox' => $request->mailbox , 'user_name' => $user->first_name.' '.$user->last_name]);
                return ['status'=>true,"message"=>'Package userinfo has been updated successfully.'];
            }else{
                return ["status" => false,"message"=>"Package not found."];
            }
        }catch(\Exception $e){
            return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
        }
    }
    
    public function createPackageManifest(Request $request){
        //try{
            $package_ids = explode(',' ,$request->package_ids);
            //dd($package_ids);
            if(count($package_ids) > 0){
                $fileName = '';
                $manifest = new Manifest();
                $manifest->master_air_billing_no = $request->master_air_billing_no;
                $manifest->file_pdf = $fileName;
                $manifest->created_at = date('Y-m-d h:i:s');
                $manifest->updated_at = date('Y-m-d h:i:s');
                $manifest->save();
                $manifest_id = $manifest->id;
                foreach($package_ids as $key => $val){
                    
                    $packages = DB::table('packages')->where('tracking_no', $val)->first();
                    //return $packages->packeg_id;
                    $manifArray = [];
                    $manifArray['manifest_id'] = $manifest_id;
                    $manifArray['packeges_id'] = $packages->packeg_id;
                    Package::where('tracking_no', $val)->update(['is_added_manifest' => 1]);
                    if($val){
                        DB::table('manifest_packeges')->insert($manifArray);
                    }
                }
                return ["status" => true,"message"=>"Package manifest has been created successfully."];
            }else{
                return ['status'=>false,"message"=>'Package not found.'];
            }
        //}catch(\Exception $e){
            //return ['status'=>false,"message"=>$e->getMessage(),"user_access"=>1];
       // }
    }
    
    
    
    public function firebase($device_token,$message) {
	//echo '<pre>';print_r($message);exit;
        // Message should contain key and value. It should be an array like =====  message=>'Hi test'
        $url = 'https://fcm.googleapis.com/fcm/send';
		
        $fields = array(
            'to' => $device_token,
            'content_available' => true,
	    'mutable_content' => true,
            'data' => $message,
	    'notification' =>  $message
        );
		//echo json_encode($fields);exit;
        // Authentication..... Identification for project on firebase

        $header = array(
            'Authorization:key =AAAAasYy5JQ:APA91bFfw0DZHXZIhb5or73hsMokgehBkyMJRx_NKo59DVwQiPerNERyiYQHyJXL8Vv39E4W5UHm3OOu0JUZ9vvya5BOOv_IWL0kQFYpjPDaF6isKqvu8x83TtYlgwVchuzEdNLw6WPH',
            'Content-Type: application/json'
        );
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);
	//echo '<pre>'; print_r($result);exit;
        if ($result === false) {
            die('Curl Failed: ' . curl_error($ch));
        }
        
        curl_close($ch);
        return $result;
    }

    function distance($lat1, $lon1, $lat2, $lon2, $unit) {

        $theta = $lon1 - $lon2;
        $dist = sin(deg2rad($lat1)) * sin(deg2rad($lat2)) +  cos(deg2rad($lat1)) * cos(deg2rad($lat2)) * cos(deg2rad($theta));
        $dist = acos($dist);
        $dist = rad2deg($dist);
        $miles = $dist * 60 * 1.1515;
        $unit = strtoupper($unit);
        if ($unit == "K") {
            return ($miles * 1.609344);
        } else if ($unit == "N") {
            return ($miles * 0.8684);
        } else {
            return $miles;
        }
    }   
    
    function getdate($second_time){
        $string = "";
        $seconds = time()- $second_time;
        //$days = date('d-M-Y' , strtotime($second_time));
        $year = intval(intval($seconds) / (365 * 24 * 60 * 60));
        $momth = intval(intval($seconds) / (30 * 24 * 60 * 60));
        $weeks = intval(intval($seconds) / (7 * 24 * 60 * 60));
        $days = intval(intval($seconds) / (3600*24));
        $hours = (intval($seconds) / 3600) % 24;
        $minutes = (intval($seconds) / 60) % 60;
        $seconds = (intval($seconds)) % 60;
        //echo $weeks.'======'.$days.'===='. $hours .'====' . $minutes. '=====' . $seconds;exit;
        if($year > 0){
            return  $string .= "$year Year ago";
        }
        if($momth > 0){
            return  $string .= "$momth Month ago";
        }
        if($weeks > 0){
            return  $string .= "$weeks weeks ago";
        }
        if($hours > 24 && $hours < 48){
                return $string .= "Yesterday";
        }
        if($hours > 1 && $hours < 24){
                return $string .= "Today";
        }
        if($days > 0){
                return  $string .= "$days days ago";
        }
        if($hours > 0){
                return $string .= "$hours hours ago";
        }
        if($minutes > 0){
                return $string .= "$minutes minutes ago";
        }
        if ($seconds < 59){
                return $string .= "Just now";
        }
    }
    
    public function send_email_packeg($email, $user_name,$tracking_no,$supplier_tracking_no,$mailbox,$courier,$item_description,$weight, $status,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $settings = DB::table('settings')->first();
        $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
        $company_name = $settings->company_name;
        $res['userName'] = $user_name;
        $res['tracking_no'] = $tracking_no;
        $res['mailbox'] = $mailbox;
        $res['courier'] = $courier;
        $res['item_description'] = $item_description;
        $res['weight'] = $weight;
        $res['supplier_tracking_no'] = $supplier_tracking_no;
        $res['status'] = $status;
        $res['logo_url'] = $logo;
        $res['company_name'] = $company_name;
        //dd($res);
        Mail::send('email/'.$view_name , $res, function ($message) use ($email_from, $email, $user_name, $email_subject,$company_name) {
            $message->from($email_from, $name = $company_name);
            $message->to($email, $user_name)->subject($email_subject);
            //$message->to('rizwangill132@gmail.com', $user_name)->subject($email_subject);
            //$message->to('shopvmjbb@gmail.com', $user_name)->subject($email_subject);
        });
    }
    
    public function send_email_packeg_update($email, $user_name,$tracking_no,$supplier_tracking_no,$mailbox,$courier,$item_description,$weight, $status,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $settings = DB::table('settings')->first();
        $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
        $company_name = $settings->company_name;
        $res['userName'] = $user_name;
        $res['tracking_no'] = $tracking_no;
        $res['mailbox'] = $mailbox;
        $res['courier'] = $courier;
        $res['item_description'] = $item_description;
        $res['weight'] = $weight;
        $res['supplier_tracking_no'] = $supplier_tracking_no;
        $res['status'] = $status;
        $res['logo_url'] = $logo;
        $res['company_name'] = $company_name;
        //dd($res);
        Mail::send('email/'.$view_name , $res, function ($message) use ($email_from, $email, $user_name, $email_subject,$company_name) {
            $message->from($email_from, $name = $company_name);
            $message->to($email, $user_name)->subject($email_subject);
            //$message->to('rizwangill132@gmail.com', $user_name)->subject($email_subject);
            //$message->to('shopvmjbb@gmail.com', $user_name)->subject($email_subject);
        });
    }
	
}