<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Admin;
use Session;
use Validator;
use App\Models\User;
use App\Models\Product;
use App\Models\Category;
use App\Models\Setting;
use App\Models\Order;
use App\Models\BankInfo;
use App\Models\Contact;
use App\Models\Newsletter;
use App\Models\Transaction;

use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Carbon;
use Yajra\DataTables\Facades\DataTables;
use App\Models\Former;
use URL;
use Mail;
use Image;
use File;
use DB;
use commonHelper;

class DashboardControllor extends Controller
{

    public function __construct() {
        $this->middleware('guest', ['except' => 'logout']);
    }

    public function dashboard(Request $request) {
        $data['title'] = 'Dashboard';
        $data['class'] = 'dashboard';
        $total = 0;
        $data['setting'] = DB::table('settings')->first();
        $data['outstanding_package'] = DB::table('packages')->where('packages.status' , 1)->count();
        $data['in_transit'] = DB::table('packages')->where('packages.status' , 2)->count();
        $data['outstanding_invoice'] = DB::table('invoices')->where('invoices.status' , 0)->count();
        $outstanding_balance = DB::table('invoices')->where('invoices.status' , 0)->get();
        $invoiceImount = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"),DB::raw("SUM(invoices.discount_price) as discount_price"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , 0)
                            ->where('invoice_packages.status' , 0)
                            ->first();
                $invoiceImountGct = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , 0)
                            ->where('invoice_packages.status' , 0)
                            ->where('invoices.gct' , 1)
                            ->first(); 
        $us_rate = DB::table('settings')->first()->us_rate;
        if($invoiceImount){
            if($invoiceImount->pk_price != ''){
                if($invoiceImountGct){
                    $ser_fee = $invoiceImountGct->ser_fee * $us_rate;
                    $gctAmount = $ser_fee * 15 / 100;
                }else{
                    $gctAmount = 0;
                }
                $totalInv = ($invoiceImount->pk_price + $invoiceImount->cus_fee + $invoiceImount->ser_fee) * $us_rate;
                $subTotal = $totalInv - $invoiceImount->discount_price;
                $total = $total + $subTotal + $gctAmount;
            }
        }
        $data['outstanding_balance'] = number_format($total,2).' JMD';
        $data['wherehouse'] = DB::table('packages')->where('packages.status' , 3)->count();
        return view('admin/dashboard/dashboard' , $data);
    }

    public function listViewReady(Request $request){
        $is_temprary_logs = 0;
        $columns = array(
                        0 =>'manifest_no',
                        1 =>'supplier_tracking_no',
                        2=> 'courier',
                        3=> 'item_description',
                        4=> 'first_name',
                        5=> 'name',
                        6=> 'created_at'
                    );
        $totalData = DB::table('packages')->where('is_temprary_logs' , $is_temprary_logs)
                            ->where('packages.status' ,  1)
                            ->count();

        $totalFiltered = $totalData;

        $limit = $request->input('length');
        $start = $request->input('start');
        $order = $columns[$request->input('order.0.column')];
        $dir = $request->input('order.0.dir');

        if(empty($request->input('search.value')))
        {
            $posts = DB::table('packages')->select('packages.packeg_id','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                        //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                        //->join('package_status', 'package_status.id', '=', 'packages.status')
                        ->where('packages.status' ,  1)
                        ->offset($start)
                        ->limit($limit)
                        ->orderBy('packages.created_at','DESC')
                        ->get();
        }else {
            $search = $request->input('search.value');
            $posts =  DB::table('packages')->select('packages.packeg_id','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                        //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                        //->join('package_status', 'package_status.id', '=', 'packages.status')
                        ->where('packages.is_temprary_logs' , $is_temprary_logs)
                        ->where('packages.status' ,  1)
                        ->where('packages.user_name', 'LIKE',"%{$search}%")
                        ->orWhere('packages.manifest_no','LIKE',"%{$search}%")
                        ->orWhere('packages.supplier_tracking_no','LIKE',"%{$search}%")
                        ->orWhere('packages.status_name','LIKE',"%{$search}%")
                        ->offset($start)
                        ->limit($limit)
                        ->orderBy('packages.created_at','DESC')
                        ->get();
            $totalFiltered = DB::table('packages')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                //->join('package_status', 'package_status.id', '=', 'packages.status')
                                //->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('packages.is_temprary_logs' , $is_temprary_logs)
                                ->where('packages.status' ,  1)
                                ->where('packages.user_name', 'LIKE',"%{$search}%")
                                ->orWhere('packages.manifest_no','LIKE',"%{$search}%")
                                ->orWhere('packages.supplier_tracking_no','LIKE',"%{$search}%")
                                ->orWhere('packages.status_name','LIKE',"%{$search}%")
                                ->count();
                                //return $totalFiltered;
        }

        $data = array();
        if(!empty($posts))
        {
            foreach ($posts as $post)
            {
                $nestedData['manifest_no'] = $post->manifest_no;
                $nestedData['supplier_tracking_no'] = $post->supplier_tracking_no;
                $nestedData['courier'] = $post->courier;
                $nestedData['item_description'] = substr(strip_tags($post->item_description),0,50)."...";
                $nestedData['first_name'] = $post->user_name;
                $nestedData['name'] = $post->status_name;
                $nestedData['created_at'] = date('j M Y h:i a',strtotime($post->created_at));
                $data[] = $nestedData;
            }
        }
        //dd($data);
        $json_data = array(
                        "draw"            => intval($request->input('draw')),
                        "recordsTotal"    => intval($totalData),
                        "recordsFiltered" => intval($totalFiltered),
                        "data"            => $data
                    );
        echo json_encode($json_data);
    }

    public function listViewRecent(){
        $query = DB::table('packages')
                    ->select('packages.*','users.first_name','users.last_name','package_status.name')
                    ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                    ->join('package_status', 'package_status.id', '=', 'packages.status')
                    ->where('packages.status' ,'!=' , 1);
        return DataTables::of($query)->make(true);
    }

    public function profile(Request $request) {
        $data['title'] = 'Manages Profile';
        $data['class'] = 'dashboard';
        $data['table'] = 'Update Profile';
        $user_id = Session::get('user_id');
        if ($request->isMethod('get')) {
            $data['admins'] = User::where('user_id', $user_id)->first();
            return view('admin/dashboard/create' , $data);
        }else{
            if ($request->hasFile('image')) {
                $image_name = '';
                $admin_img = User::where('user_id', $user_id)->first();
                if($admin_img){
                    $avater = $admin_img->image;
                    @unlink(base_path() . '/users/' . $avater);
                }

                $imageTempName = $request->file('image')->getPathname();
                $venue_img_extension = $request->image->extension();
                $imageName = uniqid() . '.' . $venue_img_extension;
                $path = base_path() . '/public/users/';
                $request->file('image')->move($path, $imageName);
                $image = $imageName;
            } else {
                $image = '';
                $admin_img = User::where('user_id', $user_id)->first();
                if($admin_img){
                    $image = $admin_img->image;
                }
            }
            User::where('user_id', $user_id)
                    ->update([
                            'first_name' => $request->first_name,
                            'last_name' => $request->last_name,
                            'image' => $image
                        ]);
            Session::put('admin_name', $request->first_name);
            Session::put('avater', $image);
            Session::flash('success_msg', 'Profile has been updated successfully.');
            return redirect('admin/profile');
        }
    }

    public function settings(Request $request) {
        $data['title'] = 'Manages Settings';
        $data['class'] = 'settings';
        $data['table'] = 'Manages Settings';
        $user_id = Session::get('user_id');
        if ($request->isMethod('get')) {
                $data['setting'] = Setting::first();
                return view('admin/settings/edit' , $data);
        }else{
            if ($request->hasFile('site_logo')) {
                $image_name = '';
                $sitelogo = Setting::first();
                if($sitelogo){
                    $site_logo = $sitelogo->site_logo;
                    @unlink(base_path() . '/public/settings/' . $site_logo);
                }

                $imageTempName = $request->file('site_logo')->getPathname();
                $venue_img_extension = $request->site_logo->extension();
                $imageName = uniqid() . '.' . $venue_img_extension;
                $path = base_path() . '/public/settings/';
                $request->file('site_logo')->move($path, $imageName);
                $image = $imageName;
            } else {
                $sitelogo = Setting::first();
                if($sitelogo){
                    $image = $sitelogo->site_logo;
                }
            }
             if ($request->hasFile('app_logo')) {
                $image_name1 = '';
                $sitelogo = Setting::first();
                if($sitelogo){
                    $site_logo = $sitelogo->app_logo;
                    @unlink(base_path() . '/public/settings/' . $site_logo);
                }

                $imageTempName = $request->file('app_logo')->getPathname();
                $venue_img_extension = $request->app_logo->extension();
                $imageName1 = uniqid() . '.' . $venue_img_extension;
                $path = base_path() . '/public/settings/';
                $request->file('app_logo')->move($path, $imageName1);
                $image2 = $imageName1;
            } else {
                $sitelogo = Setting::first();
                if($sitelogo){
                    $image2 = $sitelogo->app_logo;
                }
            }

            Setting::where('id', 1)
                ->update([
                    'site_name' => $request->site_name,
                    'site_title' => $request->site_title,
                    'site_email' => $request->site_email,
                    'from_email' => $request->from_email,
                    'phone' => $request->phone,
                    'site_footer_text' => $request->site_footer_text,
                    'us_rate' => $request->us_rate,
                    'package_shipping_address_1' => $request->package_shipping_address_1,
                    'package_shipping_address_2' => $request->package_shipping_address_2,
                    'city' => $request->city,
                    'state' => $request->state,
                    'zip' => $request->zip,
                    'country' => $request->country,
                    'local_address' => $request->local_address,
                    'sea_shipping_address_1' => $request->sea_shipping_address_1,
                    'sea_shipping_address_2' => $request->sea_shipping_address_2,
                    'sea_city' => $request->sea_city,
                    'sea_state' => $request->sea_state,
                    'sea_zip' => $request->sea_zip,
                    'sea_country' => $request->sea_country,
                    'sea_local_address' => $request->sea_local_address,
                    'reward_amount' => $request->reward_amount,
                    'reward_use_duration' => $request->reward_use_duration,
                    'reward_packages' => $request->reward_packages,
                    'reward_weight' => $request->reward_weight,
                    
                    'referral_amount' => $request->referral_amount,
                    'reffral_use_duration' => $request->reffral_use_duration,
                    'reffral_packages' => $request->reffral_packages,
                    'reffral_weight' => $request->reffral_weight,

                    'site_logo' => $image,
                    'app_logo' => $image2
                ]);
            Session::flash('success_msg', 'Setting has been updated successfully.');
            return redirect('admin/settings');
        }
    }

    public function changePassword(Request $request) {
        $data['title'] = 'Change Password';
        $data['class'] = 'users';
        $data['table'] = 'Change Password';
        $user_id = Session::get('user_id');
        if ($request->isMethod('get')) {
            //$data['email'] = $id;
            return view('admin/users/change_password', $data);
        }else{
            $validator = Validator::make($request->all(), [
                'new_password' => 'required|same:confirm_password',
                'confirm_password' => 'required',
            ]);
            if ($validator->fails()) {
                return redirect('admin/change/password')
                        ->withInput()
                        ->withErrors($validator);
            }else{
                $users = User::where('user_id', $user_id)->first();
                if($users){
                    $user_password = $users->password;
                    if(Hash::check($request->old_password, $user_password)){
                        $password = $request->input("new_password");
                        User::where('user_id', $user_id)->update(['password' => Hash::make($password)]);
                        Session::flash('error_msg', 'Your password was reset successfully. You may now log in with new password.');
                        $request->session()->flush();
                        return redirect('admin/change/password');
                    }else{
                        Session::flash('error_msg', 'Your current password does not matched');
                        return redirect('admin/change/password');
                    }
                }else{
                    Session::flash('error_msg', 'User does not exist in our database.');
                    return redirect('admin/change/password');
                }
            }
        }
    }

    public function sendEmail(Request $request){
        $data['title'] = 'Send Email';
        $data['class'] = 'email';
        $data['table'] = 'Send Email';
        if ($request->isMethod('get')) {
            $data['users'] = User::where('role_id' , 0)->orderby('first_name','ASC')->get();
            return view('admin/send_emails/send_email' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                                'subject' => 'required',
                                'description' => 'required'
                            ]);
            if ($validator->fails()) {
                    return redirect('send/email')
                                    ->withInput()
                                    ->withErrors($validator);
            }else{
                $settings = DB::table('settings')->first();
                if($settings){
                    $email_from = $settings->from_email;
                }else{
                    $email_from = 'onepluscourierja@gmail.com';
                }
                $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
                $company_name = $settings->company_name;
                //return $email_from;
                //return $logo = URL::to('/') . '/admin/images/logo.png';
                $obj['email_from'] = $email_from;
                $obj['subject'] = $request->subject;
                $obj['decription'] = $request->description;
                $customer_id = $request->user_id;
                $is_user = $request->is_user;
                if($is_user == 'All'){
                    $users = User::get();
                }else{
                    $users = User::whereIn('user_id' , $customer_id)->get();
                }
                
                $obj['users'] = $users;
                //if(count($users) > 1){
                    //NewUserRegisterEmail::dispatch($obj);
                    //->delay(now()->addMinutes(1))
                //}
                if(count($users) > 0){
                    foreach($users as $row){
                        $this->send_email_shop($row->email, $row->first_name, $request->subject, $email_from, $obj,$logo,$company_name,'send_email');
                    }
                }
                
                Session::flash('success_msg', 'Send email to users successfully'); 
                return redirect('send/email');
            }
        }
    }
    
    public function send_email_shop($email, $user_name, $email_subject, $email_from, $link,$logo,$company_name,$view_name) {
        $res['name'] = $user_name;
        $res['company_name'] = $company_name;
        $res['subject'] = $link['subject'];
        $res['decription'] = $link['decription'];
        $res['logo_url'] = $logo;
        Mail::send('email/'.$view_name , $res, function ($message) use ($email_from, $email, $user_name, $email_subject,$company_name) {
            $message->from($email_from, $company_name);
            $message->to($email, $user_name)->subject($email_subject);
            $message->to('rizwangill132@gmail.com', $user_name)->subject($email_subject);
        });
    }

    public function unpaidInvoice(){
        $outstanding_balance = DB::table('invoices')->select('invoice_id')->where('invoices.status' , 0)->get();
        //dd($outstanding_balance);
        if(count($outstanding_balance) > 0){
            foreach($outstanding_balance as $row){
                $totalInv = commonHelper::getInvoiceOutstanding($row->invoice_id);
                DB::table('invoice_packages')->where('invoice_id' , $row->invoice_id)->update(['status' => 0]);
            }
        }
        return 'invoice updated';
    }

    public function updateUserName(){
        $allUsers = DB::table('users')->select('mailbox','first_name','last_name')->limit(500)->where('is_update' , 0)->get();
        //dd($allUsers);
        if(count($allUsers) > 0){
            foreach($allUsers as $row){
                $user_name = $row->first_name .' '.$row->last_name;
                DB::table('packages')->where('mailbox' , $row->mailbox)->update(['user_name' => $user_name]);
                DB::table('users')->where('mailbox' , $row->mailbox)->update(['is_update' => 1]);
            }
        }
        return 'User name updated';
    }

    public function updateInvoiceName(){
        $allUsers = DB::table('users')->select('mailbox','first_name','last_name')->limit(500)->where('is_update' , 1)->get();
        //dd($allUsers);
        if(count($allUsers) > 0){
            foreach($allUsers as $row){
                $user_name = $row->first_name .' '.$row->last_name;
                DB::table('invoices')->where('mailbox_no' , $row->mailbox)->update(['user_name' => $user_name]);
                DB::table('users')->where('mailbox' , $row->mailbox)->update(['is_update' => 3]);
            }
        }
        return 'User name updated';
    }

    public function updatePackageStatusName(){
        $allStatus = DB::table('package_status')->select('id','name')->get();
        //dd($allStatus);
        if(count($allStatus) > 0){
            foreach($allStatus as $row){
                DB::table('packages')->where('status' , $row->id)->update(['status_name' => $row->name]);
            }
        }
        return 'Package status updated';
    }
    
    public function updateInvoiceStatus(){
        $allUsers = DB::table('invoices')->select('invoice_id' , 'created_at')->where('email_sent' , 1)->where('status' , 1)->orderby('created_at' , 'DESC')->get();
        //dd($allUsers);
        if(count($allUsers) > 0){
            foreach($allUsers as $row){
                //return $row->created_at;
                DB::table('invoice_packages')->where('invoice_id' , $row->invoice_id)->update(['status' => 1]);
                //DB::table('users')->where('mailbox' , $row->mailbox)->update(['is_update' => 3]);
            }
        }
        return 'User name updated';
    }
    
    public function updatePackageStatus(){
        $allPackages = DB::table('packages')->select('packeg_id','created_at')->where('status' ,'!=', 12)->whereDate('created_at' ,'<=', '2022-02-28')->orderby('created_at' , 'DESC')->get();
        //dd($allUsers);
        if(count($allPackages) > 0){
            foreach($allPackages as $row){
                //return $row->created_at;
                DB::table('packages')->where('packeg_id' , $row->packeg_id)->update(['status' => 12,'status_name' => 'DELIVERED']);
                //DB::table('users')->where('mailbox' , $row->mailbox)->update(['is_update' => 3]);
            }
        }
        return 'User name updated';
    }
}
