<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Discount;
use Session;
use Validator;
use Illuminate\Support\Facades\Hash;
use Image;
use File;
use DB;

class DiscountController extends Controller
{
	
	public function __construct() {
        $this->middleware('guest', ['except' => 'logout']);
    }
	
	public function index(){
		$data['title'] = 'Manage Discounts';
		$data['class'] = 'Discounts';
		$data['table'] = 'Manage Discounts';
		$data['discount'] = Discount::get();
		return view('admin/discount/index' , $data);
	}
	
    public function create(Request $request){
        $data['title'] = 'Add Discounts';
        $data['class'] = 'Discounts';
        $data['table'] = 'Add Discounts';
        if ($request->isMethod('get')) {
                return view('admin/discount/create' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                            'title' => 'required',
                            'discount' => 'required',
                        ]);
            if ($validator->fails()) {
                    return redirect('admin/discount/add')
                                    ->withInput()
                                    ->withErrors($validator);
            }else{

                $discount = new Discount();
                $discount->title = $request->title;
                $discount->discount = $request->discount;
                $discount->created_at = date('Y-m-d h:i:s');
                $discount->updated_at = date('Y-m-d h:i:s');
                $discount->save();
                Session::flash('success_msg', 'Discount has been added successfully'); 
                return redirect('admin/discounts');
            }
        }
    }
	
    public function edit(Request $request , $id = ''){
        $data['title'] = 'Edit Discount';
        $data['class'] = 'Discount';
        $data['table'] = 'Edit Discount';
        if ($request->isMethod('get')) {
                $data['discount'] = Discount::where('id' , $id)->first();
                return view('admin/discount/edit' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                            'title' => 'required',
                            'discount' => 'required',
                        ]);
            if ($validator->fails()) {
                return redirect('admin/discount/edit/'.$id)
                            ->withInput()
                            ->withErrors($validator);
            }else{
                Discount::where('id', $id)
                        ->update([
                            'title' => $request->title,
                            'discount' => $request->discount,
                        ]);
                Session::flash('success_msg', 'discount has been updated successfully.'); 
                return redirect('admin/discounts');
            }
        }
    }
	
    public function delete($id = '') {
        $delete = discount::where('id' , $id)->delete();
        Session::flash('success_msg', 'discount has been deleted successfully.'); 
        return redirect('admin/discounts');
    }
	
}
