<?php
namespace App\Http\Controllers\Admin;

use Session;
use Validator;
use DB;
use PDF;
use URL;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Response;

use App\Http\Controllers\Controller;
use App\Classes\CommonLibrary;
use App\Models\PackageType;
use App\Models\User;
use App\Models\Package;
use App\Models\PackageStatus;
use App\Models\Invoice;
use App\Models\ManifestInfo;
use App\Models\Manifest;
use App\Models\ManifestPackage;
use App\Models\HSCode;
use Yajra\DataTables\Facades\DataTables;
use commonHelper;

class PackegsControllor extends Controller
{

    public function __construct() {
        $this->middleware('guest', ['except' => 'logout']);
    }

    
    public function view($type = ''){
        if($type == 'logs'){
            $data['title'] = 'Manage Package Log';
            $data['class'] = 'package';
            $data['table'] = 'Manage Package Log';
        }else{
            $data['title'] = 'Manage Pre Alerts Package Log';
            $data['class'] = 'package';
            $data['table'] = 'Manage Pre Alerts Package Log';
        }
        $data['type'] = $type;
        return view("admin.packages.list",$data);
    }

    public function listView(Request $request,$type = '')
    {
        if($type == 'logs'){
            $is_temprary_logs = 0;
            $columns = array(
                            0 =>'manifest_no',
                            1 =>'supplier_tracking_no',
                            2=> 'courier',
                            3=> 'weight',
                            4=> 'item_description',
                            5=> 'first_name',
                            6=> 'name',
                            7=> 'outlet_name',
                            8=> 'created_at',
                            9=> 'action'
                        );
            $totalData = DB::table('packages')
                                //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                //->join('package_status', 'package_status.id', '=', 'packages.status')
                                //->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('is_temprary_logs' , $is_temprary_logs)
                                //->where('packages.status' , '!=' , 1)
                                ->where('packages.status' , '!=' , 9)
                                //->where('packages.status' , '!=' , 12)
                                ->count();

            $totalFiltered = $totalData;

            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');

            if(empty($request->input('search.value')))
            {
                $posts = DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.status','packages.created_at')
                            //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            //->join('package_status', 'package_status.id', '=', 'packages.status')
                            //->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('is_temprary_logs' , $is_temprary_logs)
                            //->where('packages.status' , '!=' , 1)
                            ->where('packages.status' , '!=' , 9)
                            //->where('packages.status' , '!=' , 12)
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy('packages.created_at','DESC')
                            ->get();
            }else {
                $paramsArr = [];
                $search = $request->input('search.value');
                if($search != ''){
                    $paramsArr['packages.user_name'] = $search;
                    //$paramsArr['users.last_name'] = $search;
                    $paramsArr['packages.manifest_no'] = $search;
                    $paramsArr['packages.supplier_tracking_no'] = $search;
                    $paramsArr['packages.status_name'] = $search;
                    //$paramsArr['outlets.outlet_name'] = $search;
                }

                $posts =  DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.status','packages.created_at')
                            //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            //->join('package_status', 'package_status.id', '=', 'packages.status')
                            //->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.is_temprary_logs' , $is_temprary_logs)
                            //->where('packages.status' , '!=' , 1)
                            ->where('packages.status' , '!=' , 9)
                            //->where('packages.status' , '!=' , 12)
                            ->where(function($q) use ($paramsArr)
                            {
                                foreach($paramsArr as $key => $value)
                                {
                                    if($key == 'packages.user_name'){
                                        $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.manifest_no'){
                                        $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.supplier_tracking_no'){
                                        $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.status_name'){
                                        $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                    }
                                    // elseif($key == 'outlets.outlet_name'){
                                    //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                    // }
                                }
                            })
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy('packages.created_at','DESC')
                            ->get();
                $totalFiltered = DB::table('packages')
                                    //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                    //->join('package_status', 'package_status.id', '=', 'packages.status')
                                    //->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                    ->where('packages.is_temprary_logs' , $is_temprary_logs)
                                    //->where('packages.status' , '!=' , 1)
                                    ->where('packages.status' , '!=' , 9)
                                    //->where('packages.status' , '!=' , 12)
                                    ->where(function($q) use ($paramsArr)
                                    {
                                        foreach($paramsArr as $key => $value)
                                        {
                                            if($key == 'packages.user_name'){
                                                $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.manifest_no'){
                                                $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.supplier_tracking_no'){
                                                $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.status_name'){
                                                $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                            }
                                            // elseif($key == 'outlets.outlet_name'){
                                            //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                            // }
                                        }
                                    })
                                    ->count();
                                    //return $totalFiltered;
                        //dd($posts);
            }

            $data = array();
            if(!empty($posts))
            {
                foreach ($posts as $post)
                {
                    $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $post->tracking_no)->first();
                    $btn = '';
                    if($post->invoice != ''){
                        $btn = "<a href='".url('/')."/invoices/".$post->invoice."' class='btn btn-warning' title='Customer invoice' download><i class='fa fa-download'></i> Customer invoice </a>";
                    }
                    if($invoicesPack == null){
                        $btn .= "<a href='".url('/')."/admin/package/invoice/add/".$post->tracking_no."' class='btn btn-warning' target = '_blank' title='Create invoice'><i class='fa fa-plus'></i> Create invoice </a><a href='".url('/')."/admin/package/edit/".$post->tracking_no."'  class='all_button btn  btn-sm btn-info'  id='".$post->tracking_no."'>Edit</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$post->packeg_id."'>Delete</a>";
                    }else{
                        $btn .= "<a href='".url('/')."/admin/package/edit/".$post->tracking_no."'  class='all_button btn  btn-sm btn-info'  id='".$post->tracking_no."'>Edit</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$post->packeg_id."'>Delete</a>";
                    }
                    //$btn .= "<a href='".url('/')."/admin/package/edit/".$post->tracking_no."'  class='all_button btn  btn-sm btn-info'  id='".$post->tracking_no."'>Edit</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$post->packeg_id."'>Delete</a>";
                    $outlet_name = commonHelper::getOutletName($post->mailbox);
                    $nestedData['manifest_no'] = $post->manifest_no;
                    $nestedData['supplier_tracking_no'] = $post->supplier_tracking_no;
                    $nestedData['courier'] = $post->courier;
                    $nestedData['weight'] = $post->weight;
                    $nestedData['item_description'] = substr(strip_tags($post->item_description),0,50)."...";
                    $nestedData['first_name'] = $post->user_name;
                    $nestedData['name'] = $post->status_name;
                    $nestedData['outlet_name'] = $outlet_name;
                    $nestedData['created_at'] = date('j M Y h:i a',strtotime($post->created_at));
                    $nestedData['action'] = $btn;
                    $data[] = $nestedData;
                }
            }
            $json_data = array(
                            "draw"            => intval($request->input('draw')),
                            "recordsTotal"    => intval($totalData),
                            "recordsFiltered" => intval($totalFiltered),
                            "data"            => $data
                        );
            echo json_encode($json_data);
        }else{
            $is_temprary_logs = 1;
            $columns = array(
                            0 =>'manifest_no',
                            1 =>'supplier_tracking_no',
                            2=> 'courier',
                            3=> 'weight',
                            4=> 'item_description',
                            5=> 'first_name',
                            6=> 'name',
                            7=> 'outlet_name',
                            8=> 'created_at',
                            9=> 'action'
                        );
            $totalData = DB::table('packages')
                                //->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                //->join('package_status', 'package_status.id', '=', 'packages.status')
                                //->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('is_temprary_logs' , $is_temprary_logs)
                                ->where('packages.status' ,  9)
                                ->count();

            $totalFiltered = $totalData;

            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');

            if(empty($request->input('search.value')))
            {
                $posts = DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.status' ,  9)
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get();
            }else {
                $paramsArr = [];
                $search = $request->input('search.value');
                if($search != ''){
                    $paramsArr['packages.user_name'] = $search;
                    //$paramsArr['users.last_name'] = $search;
                    $paramsArr['packages.manifest_no'] = $search;
                    $paramsArr['packages.supplier_tracking_no'] = $search;
                    $paramsArr['packages.status_name'] = $search;
                    //$paramsArr['outlets.outlet_name'] = $search;
                }
                $posts =  DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.is_temprary_logs' , $is_temprary_logs)
                            ->where('packages.status' ,  9)
                            ->where(function($q) use ($paramsArr)
                            {
                                foreach($paramsArr as $key => $value)
                                {
                                    if($key == 'packages.user_name'){
                                        $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.manifest_no'){
                                        $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.supplier_tracking_no'){
                                        $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.status_name'){
                                        $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                    }
                                    // elseif($key == 'outlets.outlet_name'){
                                    //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                    // }
                                }
                            })
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy($order,$dir)
                            ->get();
                $totalFiltered = DB::table('packages')
                                    // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                    // ->join('package_status', 'package_status.id', '=', 'packages.status')
                                    // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                    ->where('packages.is_temprary_logs' , $is_temprary_logs)
                                    ->where('packages.status' ,  9)
                                    ->where(function($q) use ($paramsArr)
                                    {
                                        foreach($paramsArr as $key => $value)
                                        {
                                            if($key == 'packages.user_name'){
                                                $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.manifest_no'){
                                                $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.supplier_tracking_no'){
                                                $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.status_name'){
                                                $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                            }
                                        }
                                    })
                                    ->count();
                                    //return $totalFiltered;
            }

            $data = array();
            if(!empty($posts))
            {
                foreach ($posts as $post)
                {
                    $btn = '';
                    if($post->invoice != ''){
                        $btn = "<a href='".url('/')."/public/invoices/".$post->invoice."' class='btn btn-warning' title='Customer invoice' download target= '_blank'><i class='fa fa-download'></i> Customer invoice </a>";
                    }
                    $btn .= "<a href='".url('/')."/admin/package/edit/".$post->tracking_no."'  class='all_button btn  btn-sm btn-info'  id='".$post->tracking_no."'>Edit</a><a href='javascript:void(0)' class='all_button btn btn-sm btn-danger delete_btn'  id='".$post->packeg_id."'>Delete</a>";
                    $outlet_name = commonHelper::getOutletName($post->mailbox);
                    $nestedData['manifest_no'] = $post->manifest_no;
                    $nestedData['supplier_tracking_no'] = $post->supplier_tracking_no;
                    $nestedData['courier'] = $post->courier;
                    $nestedData['weight'] = $post->weight;
                    $nestedData['item_description'] = substr(strip_tags($post->item_description),0,50)."...";
                    $nestedData['first_name'] = $post->user_name;
                    $nestedData['name'] = $post->status_name;
                    $nestedData['outlet_name'] = $outlet_name;
                    $nestedData['created_at'] = date('j M Y h:i a',strtotime($post->created_at));
                    $nestedData['action'] = $btn;
                    $data[] = $nestedData;
                }
            }
            $json_data = array(
                            "draw"            => intval($request->input('draw')),
                            "recordsTotal"    => intval($totalData),
                            "recordsFiltered" => intval($totalFiltered),
                            "data"            => $data
                        );
            echo json_encode($json_data);
        }

    }

    public function viewStatus($type = ''){
        if($type == 'update'){
            $data['title'] = 'Manage Package Log';
            $data['class'] = 'package';
            $data['table'] = 'Manage Package Log';
        }else{
            $data['title'] = 'Manage Last Package Log';
            $data['class'] = 'package';
            $data['table'] = 'Manage Last Package Log';
        }
        $data['type'] = $type;
        $data['packeg_status'] = PackageStatus::where('id','!=' , 1)->get();
        return view("admin.packages.listStatus",$data);
    }

    public function listViewStatus(Request $request,$type = '')
    {
        if($type == 'update'){
            $is_temprary_logs = 0;
            $columns = array(
                            0 => 'check_status',
                            1 =>'manifest_no',
                            2 =>'supplier_tracking_no',
                            3=> 'courier',
                            4=> 'item_description',
                            5=> 'first_name',
                            6=> 'outlet_name',
                            7=> 'created_at',
                            8=> 'name'
                        );
            $totalData = DB::table('packages')
                                // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                // ->join('package_status', 'package_status.id', '=', 'packages.status')
                                // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('is_temprary_logs' , $is_temprary_logs)
                                ->where('packages.status' , '!=' , 7)
                                ->where('packages.status' , '!=' , 1)
                                ->where('packages.status' , '!=' , 12)
                                ->where('packages.status' ,'!=' , 9)
                                ->count();

            $totalFiltered = $totalData;

            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');

            if(empty($request->input('search.value')))
            {
                $posts = DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.status' , '!=' , 7)
                            ->where('packages.status' , '!=' , 1)
                            ->where('packages.status' , '!=' , 12)
                            ->where('packages.status' ,'!=' , 9)
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy('packages.created_at','DESC')
                            ->get();
            }else {
                $paramsArr = [];
                $search = $request->input('search.value');
                if($search != ''){
                    $paramsArr['packages.user_name'] = $search;
                    //$paramsArr['users.last_name'] = $search;
                    $paramsArr['packages.manifest_no'] = $search;
                    $paramsArr['packages.supplier_tracking_no'] = $search;
                    $paramsArr['packages.status_name'] = $search;
                    //$paramsArr['outlets.outlet_name'] = $search;
                }
                $posts =  DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.is_temprary_logs' , $is_temprary_logs)
                            ->where('packages.status' , '!=' , 7)
                            ->where('packages.status' , '!=' , 1)
                            ->where('packages.status' , '!=' , 12)
                            ->where('packages.status' ,'!=' , 9)
                            ->where(function($q) use ($paramsArr)
                            {
                                foreach($paramsArr as $key => $value)
                                {
                                    if($key == 'packages.user_name'){
                                        $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.manifest_no'){
                                        $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.supplier_tracking_no'){
                                        $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.status_name'){
                                        $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                    }
                                    // elseif($key == 'outlets.outlet_name'){
                                    //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                    // }
                                }
                            })
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy('packages.created_at','DESC')
                            ->get();
                $totalFiltered = DB::table('packages')
                                    // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                    // ->join('package_status', 'package_status.id', '=', 'packages.status')
                                    // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                    ->where('packages.is_temprary_logs' , $is_temprary_logs)
                                    ->where('packages.status' , '!=' , 7)
                                    ->where('packages.status' , '!=' , 1)
                                    ->where('packages.status' , '!=' , 12)
                                    ->where('packages.status' ,'!=' , 9)
                                    ->where(function($q) use ($paramsArr)
                                    {
                                        foreach($paramsArr as $key => $value)
                                        {
                                            if($key == 'packages.user_name'){
                                                $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.manifest_no'){
                                                $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.supplier_tracking_no'){
                                                $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.status_name'){
                                                $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                            }
                                            // elseif($key == 'outlets.outlet_name'){
                                            //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                            // }
                                        }
                                    })
                                    ->count();
                                    //return $totalFiltered;
            }

            $data = array();
            if(!empty($posts))
            {
                foreach ($posts as $post)
                {
                    $outlet_name = commonHelper::getOutletName($post->mailbox);
                    $btn = '<input name="check_status[]" type="checkbox" value="'.$post->packeg_id.'"><input type="hidden" name="invoice_no[]" value="'.$post->packeg_id.'">';
                    $nestedData['check_status'] = $btn;
                    $nestedData['manifest_no'] = $post->manifest_no;
                    $nestedData['supplier_tracking_no'] = $post->supplier_tracking_no;
                    $nestedData['courier'] = $post->courier;
                    $nestedData['weight'] = $post->weight;
                    $nestedData['item_description'] = substr(strip_tags($post->item_description),0,50)."...";
                    $nestedData['first_name'] = $post->user_name;
                    $nestedData['outlet_name'] = $outlet_name;
                    $nestedData['created_at'] = date('j M Y h:i a',strtotime($post->created_at));
                    $nestedData['name'] = $post->status_name;
                    $data[] = $nestedData;
                }
            }
            //dd($data);
            $json_data = array(
                            "draw"            => intval($request->input('draw')),
                            "recordsTotal"    => intval($totalData),
                            "recordsFiltered" => intval($totalFiltered),
                            "data"            => $data
                        );
            echo json_encode($json_data);
        }else{
            $is_temprary_logs = 0;
            $columns = array(
                            0 => 'check_status',
                            1 =>'manifest_no',
                            2 =>'supplier_tracking_no',
                            3=> 'courier',
                            4=> 'item_description',
                            5=> 'first_name',
                            6=> 'outlet_name',
                            7=> 'created_at',
                            8=> 'name'
                        );
            $totalData = DB::table('packages')
                                // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                // ->join('package_status', 'package_status.id', '=', 'packages.status')
                                // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('is_temprary_logs' , $is_temprary_logs)
                                ->where('packages.status' , '!=' , 7)
                                ->where('packages.status' , '!=' , 1)
                                ->where('packages.status' , '!=' , 12)
                                ->where('packages.status' ,'!=' , 9)
                                ->count();

            $totalFiltered = $totalData;

            $limit = $request->input('length');
            $start = $request->input('start');
            $order = $columns[$request->input('order.0.column')];
            $dir = $request->input('order.0.dir');

            if(empty($request->input('search.value')))
            {
                $posts = DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.status' , '!=' , 7)
                            ->where('packages.status' , '!=' , 1)
                            ->where('packages.status' , '!=' , 12)
                            ->where('packages.status' ,'!=' , 9)
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy('packages.created_at','DESC')
                            ->get();
            }else {
                $paramsArr = [];
                $search = $request->input('search.value');
                if($search != ''){
                    $paramsArr['packages.user_name'] = $search;
                    //$paramsArr['users.last_name'] = $search;
                    $paramsArr['packages.manifest_no'] = $search;
                    $paramsArr['packages.supplier_tracking_no'] = $search;
                    $paramsArr['packages.status_name'] = $search;
                    //$paramsArr['outlets.outlet_name'] = $search;
                }
                $posts =  DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.created_at')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('packages.is_temprary_logs' , $is_temprary_logs)
                            ->where('packages.status' , '!=' , 7)
                            ->where('packages.status' , '!=' , 1)
                            ->where('packages.status' , '!=' , 12)
                            ->where('packages.status' ,'!=' , 9)
                            ->where(function($q) use ($paramsArr)
                            {
                                foreach($paramsArr as $key => $value)
                                {
                                    if($key == 'users.user_name'){
                                        $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.manifest_no'){
                                        $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.supplier_tracking_no'){
                                        $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                    }elseif($key == 'packages.status_name'){
                                        $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                    }
                                    // elseif($key == 'outlets.outlet_name'){
                                    //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                    // }
                                }
                            })
                            ->offset($start)
                            ->limit($limit)
                            ->orderBy('packages.created_at','DESC')
                            ->get();
                $totalFiltered = DB::table('packages')
                                    // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                    // ->join('package_status', 'package_status.id', '=', 'packages.status')
                                    // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                    ->where('packages.is_temprary_logs' , $is_temprary_logs)
                                    ->where('packages.status' , '!=' , 7)
                                    ->where('packages.status' , '!=' , 1)
                                    ->where('packages.status' , '!=' , 12)
                                    ->where('packages.status' ,'!=' , 9)
                                    ->where(function($q) use ($paramsArr)
                                    {
                                        foreach($paramsArr as $key => $value)
                                        {
                                            if($key == 'packages.user_name'){
                                                $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.manifest_no'){
                                                $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.supplier_tracking_no'){
                                                $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                            }elseif($key == 'packages.status_name'){
                                                $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                            }
                                            // elseif($key == 'outlets.outlet_name'){
                                            //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                            // }
                                        }
                                    })
                                    ->count();
                                    //return $totalFiltered;
            }

            $data = array();
            if(!empty($posts))
            {
                foreach ($posts as $post)
                {
                    $outlet_name = commonHelper::getOutletName($post->mailbox);
                    $btn = '<input name="check_status[]" type="checkbox" value="'.$post->packeg_id.'"><input type="hidden" name="invoice_no[]" value="'.$post->packeg_id.'">';
                    $nestedData['check_status'] = $btn;
                    $nestedData['manifest_no'] = $post->manifest_no;
                    $nestedData['supplier_tracking_no'] = $post->supplier_tracking_no;
                    $nestedData['courier'] = $post->courier;
                    $nestedData['weight'] = $post->weight;
                    $nestedData['item_description'] = substr(strip_tags($post->item_description),0,50)."...";
                    $nestedData['first_name'] = $post->user_name;
                    $nestedData['outlet_name'] = $outlet_name;
                    $nestedData['created_at'] = date('j M Y h:i a',strtotime($post->created_at));
                    $nestedData['name'] = $post->status_name;
                    $data[] = $nestedData;
                }
            }
            //dd($data);
            $json_data = array(
                            "draw"            => intval($request->input('draw')),
                            "recordsTotal"    => intval($totalData),
                            "recordsFiltered" => intval($totalFiltered),
                            "data"            => $data
                        );
            echo json_encode($json_data);
        }
    }

    public function viewCategory(Request $request,$type = ''){
        if($type == '1'){
            $data['title'] = 'Manage Package Ready For Pickup';
            $data['class'] = 'package';
            $data['table'] = 'Manage Package Ready For Pickup';
        }else{
            $data['title'] = 'Manage Package Delivered';
            $data['class'] = 'package';
            $data['table'] = 'Manage Package Delivered';
        }
        $data['type'] = $type;
        $data['packeg_status'] = PackageStatus::get();
        return view("admin.packages.listCategory",$data);
    }

    public function listViewCategory(Request $request,$type = '')
    {
        $is_temprary_logs = 0;
        $columns = array(
                        0 =>'manifest_no',
                        1 =>'supplier_tracking_no',
                        2=> 'courier',
                        3=> 'weight',
                        4=> 'item_description',
                        5=> 'first_name',
                        6=> 'name',
                        7=> 'outlet_name',
                        8=> 'created_at'
                    );
        $totalData = DB::table('packages')
                            // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                            // ->join('package_status', 'package_status.id', '=', 'packages.status')
                            // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                            ->where('is_temprary_logs' , $is_temprary_logs)
                            ->where('packages.status' ,  $type)
                            ->count();

        $totalFiltered = $totalData;

        $limit = $request->input('length');
        $start = $request->input('start');
        $order = $columns[$request->input('order.0.column')];
        $dir = $request->input('order.0.dir');

        if(empty($request->input('search.value')))
        {
            $posts = DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.updated_at')
                        // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                        // ->join('package_status', 'package_status.id', '=', 'packages.status')
                        // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                        ->where('packages.status' ,  $type)
                        ->offset($start)
                        ->limit($limit)
                        ->orderBy('packages.created_at','DESC')
                        ->get();
        }else {
            $paramsArr = [];
            $search = $request->input('search.value');
            if($search != ''){
                $paramsArr['packages.user_name'] = $search;
                //$paramsArr['users.last_name'] = $search;
                $paramsArr['packages.manifest_no'] = $search;
                $paramsArr['packages.supplier_tracking_no'] = $search;
                $paramsArr['packages.status_name'] = $search;
                //$paramsArr['outlets.outlet_name'] = $search;
            }
            $posts =  DB::table('packages')->select('packages.packeg_id','packages.mailbox','packages.supplier_tracking_no','packages.tracking_no','packages.invoice','packages.manifest_no','packages.courier','packages.weight','packages.item_description','packages.user_name','packages.status_name','packages.updated_at')
                        // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                        // ->join('package_status', 'package_status.id', '=', 'packages.status')
                        // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                        ->where('packages.is_temprary_logs' , $is_temprary_logs)
                        ->where('packages.status' ,  $type)
                        ->where(function($q) use ($paramsArr)
                        {
                            foreach($paramsArr as $key => $value)
                            {
                                if($key == 'packages.user_name'){
                                    $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                }elseif($key == 'packages.manifest_no'){
                                    $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                }elseif($key == 'packages.supplier_tracking_no'){
                                    $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                }elseif($key == 'packages.status_name'){
                                    $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                }
                                // elseif($key == 'outlets.outlet_name'){
                                //     $q->orWhere('outlets.outlet_name', 'LIKE',"%{$value}%");
                                // }
                            }
                        })
                        ->offset($start)
                        ->limit($limit)
                        ->orderBy('packages.created_at','DESC')
                        ->get();
            $totalFiltered = DB::table('packages')
                                // ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                // ->join('package_status', 'package_status.id', '=', 'packages.status')
                                // ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('packages.is_temprary_logs' , $is_temprary_logs)
                                ->where('packages.status' ,  $type)
                                ->where(function($q) use ($paramsArr)
                                {
                                    foreach($paramsArr as $key => $value)
                                    {
                                        if($key == 'packages.user_name'){
                                            $q->orWhere('packages.user_name', 'LIKE',"%{$value}%");
                                        }elseif($key == 'packages.manifest_no'){
                                            $q->orWhere('packages.manifest_no', 'LIKE',"%{$value}%");
                                        }elseif($key == 'packages.supplier_tracking_no'){
                                            $q->orWhere('packages.supplier_tracking_no', 'LIKE',"%{$value}%");
                                        }elseif($key == 'packages.status_name'){
                                            $q->orWhere('packages.status_name', 'LIKE',"%{$value}%");
                                        }
                                    }
                                })
                                ->count();
                                //return $totalFiltered;
        }

        $data = array();
        if(!empty($posts))
        {
            foreach ($posts as $post)
            {
                $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $post->tracking_no)->first();
                $btn1 = '';
                if($invoicesPack == null){
                    $btn1 .= "<a href='".url('/')."/admin/package/invoice/add/".$post->tracking_no."' class='btn btn-warning' target = '_blank' title='Create invoice'><i class='fa fa-plus'></i> Create invoice </a>";
                }
                $outlet_name = commonHelper::getOutletName($post->mailbox);
                $packageInvoice = commonHelper::getPackageAmount($post->tracking_no);
                $btn = '<input name="check_status[]" type="checkbox" value="'.$post->packeg_id.'"><input type="hidden" name="invoice_no[]" value="'.$post->packeg_id.'">';
                $nestedData['check_status'] = $btn;
                $nestedData['manifest_no'] = $post->manifest_no;
                $nestedData['supplier_tracking_no'] = $post->supplier_tracking_no;
                $nestedData['courier'] = $post->courier;
                $nestedData['weight'] = $post->weight;
                $nestedData['item_description'] = substr(strip_tags($post->item_description),0,50)."...";
                $nestedData['first_name'] = $post->user_name;
                $nestedData['name'] = $post->status_name;
                $nestedData['outlet_name'] = $outlet_name;
                $nestedData['amount_paid'] = $packageInvoice;
                $nestedData['updated_at'] = date('j M Y h:i a',strtotime($post->updated_at));
                $nestedData['action'] = $btn1;
                $data[] = $nestedData;
            }
        }
        //dd($data);
        $json_data = array(
                        "draw"            => intval($request->input('draw')),
                        "recordsTotal"    => intval($totalData),
                        "recordsFiltered" => intval($totalFiltered),
                        "data"            => $data
                    );
        echo json_encode($json_data);
    }


    public function latestPackeges(){
        $data['title'] = 'Manage Last Package Log';
        $data['class'] = 'package';
        $data['table'] = 'Manage Last Package Log';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $data['packeg_status'] = PackageStatus::get();
        $data['packages'] = DB::table('packages')
                                ->select('packages.*','users.first_name','users.last_name','users.location','package_status.name')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                ->join('package_status', 'package_status.id', '=', 'packages.status')
                                ->where('packages.status' , '=' , 7)
                                ->get();
        return view('admin/packages/last1' , $data);
    }

    public function userPackeges($status = ''){
        $data['title'] = 'Manage Package Log';
        $data['class'] = 'account';
        $data['table'] = 'Manage Package Log';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $mailbox = Session::get('mailbox');

        $data['packages'] = DB::table('packages')
                                ->select('packages.*','users.first_name','users.last_name','users.location','package_status.name')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                ->join('package_status', 'package_status.id', '=', 'packages.status')
                                ->where('packages.mailbox' , $mailbox)
                                ->get();
        return view('admin/packages/user_pack' , $data);
    }

    public function update(){
        $data['title'] = 'Manage Package Log';
        $data['class'] = 'package';
        $data['table'] = 'Manage Package Log';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $data['packeg_status'] = PackageStatus::get();
        $data['packages'] = DB::table('packages')
                                ->select('packages.*','users.first_name','users.location','package_status.name','outlets.outlet_name')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                ->join('package_status', 'package_status.id', '=', 'packages.status')
                                ->join('outlets', 'outlets.outlet_id', '=', 'users.outlet_id','left')
                                ->where('packages.status' , '!=' , 7)
                                ->get();
        return view('admin/packages/update' , $data);
    }

    public function create(Request $request){
        $data['title'] = 'Add Package Log';
        $data['class'] = 'package';
        $data['table'] = 'Add Package Log';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            $data['types'] = PackageType::get();
            $data['users'] = User::where('role_id' , 0)->get();
            //dd($data['users']);
            return view('admin/packages/create' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                                'mailbox' => 'required',
                                'courier' => 'required',
                                'weight' => 'required',
                                'supplier_tracking_no' => 'required|unique:packages|max:255'
                            ]);
            if ($validator->fails()) {
                    return redirect('admin/packege/add')
                            ->withInput()
                            ->withErrors($validator);
            }else{
                //$package_type = explode('-' , $request->package_type);
                $tracking_no = $this->generate_password(13);
                $packages = DB::table('packages')->orderBy('manifest_no','DESC')->first();
                $user_name = commonHelper::getUserName($request->mailbox);
                // //dd($packages);
                // if($packages){
                //     $manifest_no = $packages->manifest_no + 1;
                // }else{
                //     $manifest_no = '10000';
                // }
                //return $manifest_no;
                $manifest_no = '100'.substr(str_shuffle('123456789123456789123456789321654987'),0,4);
                $packages = new Package();
                $packages->tracking_no = $tracking_no;
                $packages->mailbox = $request->mailbox;
                $packages->user_name = $user_name;
                $packages->courier = $request->courier;
                $packages->supplier_tracking_no = $request->supplier_tracking_no;
                //$packages->package_type = $package_type[1];
                //$packages->package_code = $package_type[0];
                $packages->weight = $request->weight;
                $packages->manifest_no = $manifest_no;
                $packages->price = $request->price;
                $packages->item_description = $request->item_description;
                $packages->status_name = 'Arrived in Miami Warehouse';
                $packages->created_at = date('Y-m-d h:i:s');
                $packages->updated_at = date('Y-m-d h:i:s');
                $packages->save();
                $usersRes = User::where('mailbox' , $request->mailbox)->first();
                $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                $link = URL::to('/') . '/admin/dashboard';
                $settings = DB::table('settings')->first();
                $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                $settings = DB::table('settings')->first();
                if($settings){
                    $email_from = $settings->from_email;
                }
                $status = 'Arrived in Miami';
                $settings = DB::table('settings')->first();
                $logo = URL::to('/') . '/public/settings/'.$settings->site_logo;
                $company_name = $settings->company_name;
                $this->send_email_packeg($usersRes->email, $user_name,$tracking_no,$request->supplier_tracking_no,$request->mailbox,$request->courier,$request->item_description,$request->weight,$status,$email_subject, $email_from,$logo,$company_name, 'create_packege');
                Session::flash('success_msg', 'Package has been added successfully');
                return redirect('admin/packeges/logs');
            }
        }
    }

    public function import(Request $request){
        $data['title'] = 'Import Package Log';
        $data['class'] = 'package';
        $data['table'] = 'Import Package Log';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            $data['uploaded'] = [];
            $data['packages'] = [];
            return view('admin/packages/import' , $data);
        }else{
            try{
                set_time_limit(1000);
                if ($request->hasFile('input_file')) {
                   // return 'hhh';
                    $image = $request->file('input_file');
                    $name = time().'.'.$image->getClientOriginalExtension();
                    $destinationPath = public_path('/users');
                    $image->move($destinationPath, $name);
                    $file = URL::to('/').'/public/users/'.$name;
                    $handle = fopen($file, "r");
                    $header = true;
                    $packageArray = [];
                    $packageUploadArray = [];
                    $count = 0;
                    while ($csvLine = fgetcsv($handle, 1000, ",")) {
                        //echo count($csvLine);exit;
                        if ($header) {
                            $header = false;
                        } else {
                            //echo '<pre>'; print_r($csvLine);exit;
                            $nameArr = explode(' ' , $csvLine[4]);
                            $last_name1 = $nameArr[0];
                            if(isset($nameArr[1])){
                                $valueUp = ucfirst(strtolower($nameArr[1]));
                                $valueLower = ucfirst(strtolower($last_name1));
                                $users = DB::table('users')->where('first_name' , $valueLower)->where('last_name' , $valueUp)->first();
                                //dd($users);
                            }else{
                                $users = '';
                            }
                            //dd($users);
                            //return trim($csvLine[1]);
                            if($users){
                                $package = DB::table('packages')->where('manifest_no' ,trim($csvLine[1]) )->first();
                                //dd($package);
                                if($package == null){
                                    $count = $count + 1;
                                    $mailbox = $users->mailbox;
                                    $tracking_no = $this->generate_password(13);
                                    $user_name = commonHelper::getUserName($mailbox);
                                    DB::table('packages')->insert([
                                        'mailbox' => $mailbox,
                                        'tracking_no' => $tracking_no,
                                        'user_name' => $user_name,
                                        'courier' => $csvLine[5],
                                        'price' => 0,
                                        'package_type' => 'ANDROID BOX',
                                        'date_received' => date('Y-m-d'),
                                        'manifest_no' => $csvLine[1],
                                        'weight' => $csvLine[6],
                                        'status_name' => 'Arrived in Miami Warehouse',
                                        'supplier_tracking_no' => $csvLine[7],
                                        'item_description' => $csvLine[3],
                                        'created_at' => date('Y-m-d h:i:s'),
                                        'updated_at' => date('Y-m-d h:i:s'),
                                    ]);
                                    $usersRes = User::where('mailbox' , $mailbox)->first();
                                    $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                                    $link = URL::to('/') . '/admin/dashboard';
                                    $settings = DB::table('settings')->first();
                                    $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                                    $settings = DB::table('settings')->first();
                                    if($settings){
                                        $email_from = $settings->administrator_email;
                                    }else{
                                        $email_from = 'onepluscourierja@gmail.com';
                                    }
                                    //$status = 'Arrived in Miami';
                                    //$this->send_email_packeg($usersRes->email, $user_name,$tracking_no,$csvLine[7],$mailbox,$csvLine[5],'',$csvLine[6],$csvLine[0],$email_subject, $email_from, 'create_packege');
                                    $row['status'] = $csvLine[0];
                                    $row['name'] = $csvLine[4];
                                    $row['user_name'] = $csvLine[4];
                                    $row['courier'] = $csvLine[5];
                                    $row['merchant'] = $csvLine[3];
                                    $row['date_received'] = date('Y-m-d');
                                    $row['manifest_no'] = $csvLine[1];
                                    $row['weight'] = $csvLine[6];
                                    $row['supplier_tracking_no'] = $csvLine[7];
                                    $row['item_description'] = $csvLine[3];
                                    $packageUploadArray[] = $row;
                                }else{
                                    $row['name'] = $csvLine[0];
                                    $row['user_name'] = $csvLine[4];
                                    $row['courier'] = $csvLine[5];
                                    $row['date_received'] = date('Y-m-d');
                                    $row['manifest_no'] = $csvLine[1];
                                    $row['weight'] = $csvLine[6];
                                    $row['supplier_tracking_no'] = $csvLine[7];
                                    $row['item_description'] = $csvLine[3];
                                    $packageArray[] = $row;
                                }
    
                            }else{
                                $row['name'] = $csvLine[0];
                                $row['user_name'] = $csvLine[4];
                                $row['courier'] = $csvLine[5];
                                $row['date_received'] = date('Y-m-d');
                                $row['manifest_no'] = $csvLine[1];
                                $row['weight'] = $csvLine[6];
                                $row['supplier_tracking_no'] = $csvLine[7];
                                $row['item_description'] = $csvLine[3];
                                $packageArray[] = $row;
                            }
                        }
                    }
                    //dd($packageUploadArray);
                    $data['uploaded'] = $count;
                    $data['packages'] = $packageArray;
                    $data['uploaded'] = $packageUploadArray;
                    //echo '<pre>';print_r($packageArray);exit;
                    Session::flash('success_msg', 'Package has been imported successfully');
                    return view('admin/packages/import' , $data);
    
                }else{
                   // return 'bbb';
                    $data['packages'] = [];
                    $data['uploaded'] = [];
                    Session::flash('success_msg', 'Please select a packages file.');
                    return view('admin/packages/import' , $data);
                }
            }catch(\Exception $e){
                $data['packages'] = [];
                $data['uploaded'] = [];
                Session::flash('success_msg', 'Something is wrong in your file,Please recheck your file format or extra spacing.');
                return view('admin/packages/import' , $data);
            }

        }
        
    }

    public function edit(Request $request , $tracking_no = ''){
        $data['title'] = 'Manage Package Log';
        $data['class'] = 'package';
        $data['table'] = 'Update Package Log';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            $data['types'] = PackageType::get();
            $data['users'] = User::where('role_id' , 0)->get();
            $data['package'] = Package::where('tracking_no' , $tracking_no)->first();
            return view('admin/packages/edit' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                                'courier' => 'required',
                                'weight' => 'required',
                                'item_description' => 'required'
                            ]);
            if ($validator->fails()) {
                return redirect('admin/package/edit/'.$tracking_no)
                                ->withInput()
                                ->withErrors($validator);
            }else{
                $package_type = explode('-' , $request->package_type);
                $user_name = commonHelper::getUserName($request->mailbox);
                Package::where('tracking_no' , $tracking_no)
                        ->update([
                            'mailbox' => $request->mailbox,
                                'courier' => $request->courier,
                                'user_name' => $user_name,
                                'package_type' => $package_type[1],
                                'package_code' => $package_type[0],
                                'weight' => $request->weight,
                                'price' => $request->price,
                                'item_description' => $request->item_description
                            ]);

                Session::flash('success_msg', 'Package has been updated successfully.');
                return redirect('admin/packeges/logs');
            }
        }

    }


    public function viewMenifest(){
        $data['title'] = 'Create Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Create Manifest';
        return view("admin.packages.createMani",$data);
    }

    public function listViewMenifest()
    {

            $data = DB::table('packages')
                        ->select('packages.*','users.first_name','users.last_name','users.location','package_status.name')
                        ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                        ->join('package_status', 'package_status.id', '=', 'packages.status')
                        ->where('packages.is_added_manifest' ,  0)
                        ->where('packages.is_temprary_logs' ,  0);
        return DataTables::of($data)
                 ->editColumn('check_status', function ($data) {
                    return '<input name="check_status[]" type="checkbox" value="'.$data->packeg_id.'"><input type="hidden" name="invoice_no[]" value="'.$data->packeg_id.'">';
                })
                ->rawColumns(['check_status' => 'check_status','action' => 'action'])
                ->make(true);
    }

    public function createMani(Request $request){
        $data['title'] = 'Create Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Create Manifest';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');

            $packeg_id = $request->packeg_id;
            //echo $request->status;exit;
            //dd($packeg_id);
            $check_status = $request->check_status;
            //dd($check_status);exit;
            for($i = 0; $i<count($check_status); $i++){
                $pack_id = $check_status[$i];
//                Package::where('packeg_id', $pack_id)
//                          ->update([
//                            'status' => 7
//                        ]);
                //exit;
                $packages = Package::where('packeg_id', $pack_id)->first();
                //dd($packages);
                $usersRes = User::where('mailbox' , $packages->mailbox)->first();
                $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                $link = URL::to('/') . '/admin/dashboard';
                $settings = DB::table('settings')->first();
                $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                $settings = DB::table('settings')->first();
                if($settings){
                    $email_from = $settings->from_email;
                }else{
                    $email_from = 'info@rsbshipping.com';
                }
                $name = PackageStatus::where('id' , $packages->status)->first()->name;
                $status = $name;
                //$this->send_email_packeg($usersRes->email, $user_name,$packages->tracking_no,$packages->mailbox,$packages->courier,$packages->item_description,$packages->weight,$status,$email_subject, $email_from, 'update_packege');
            }

            $package_id_Arr = [];
            for($i = 0; $i<count($check_status); $i++){
                $pack_id = $check_status[$i];
                $package_id_Arr[] = $pack_id;
            }

            $data['packages'] = DB::table('packages')
                                    ->select('packages.*','users.first_name','users.last_name')
                                    ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                    ->whereIn('packages.packeg_id', $package_id_Arr)
                                    ->orderby('packages.created_at' , 'desc')
                                    ->get();
            $data['manifest_info'] = ManifestInfo::first();

            //dd($package_id_Arr);
            $data['packeg_id'] = implode(',' , $package_id_Arr);
            return view('admin/packages/minifist' , $data);

    }

    public function exportExcel($id = ''){
        $data['title'] = 'Manage Manifest';
        $data['class'] = 'manifest';
        $data['table'] = 'Manage Manifest';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $data['manifest'] = Manifest::get();
        $data['manifest'] = DB::table('manifest_packeges')
                                ->select('packages.*','users.first_name','users.last_name')
                                ->join('packages', 'packages.packeg_id', '=', 'manifest_packeges.packeges_id')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                ->where('manifest_packeges.manifest_id' , $id)
                                ->get();
        return view('admin/packages/export_manifest' , $data);
    }

    public function manifest(){
        $data['title'] = 'Manage Manifest';
        $data['class'] = 'manifest';
        $data['table'] = 'Manage Manifest';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $data['manifest'] = Manifest::get();
        return view('admin/packages/list_manifest' , $data);
    }



    public function updateStatus(Request $request){
        $data['title'] = 'Create Package Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Create Package Manifest';
        $packeg_id = $request->packeg_id;
        $check_status = $request->check_status;
        if($check_status != null){
            for($i = 0; $i<count($check_status); $i++){
                $pack_id = $check_status[$i];
                $status_name = PackageStatus::where('id' , $request->status)->first()->name;
                Package::where('packeg_id', $pack_id)
                          ->update([
                            'status' => $request->status,
                            'status_name' => $status_name
                        ]);
                //exit;
                $packages = Package::where('packeg_id', $pack_id)->first();
                $usersRes = User::where('mailbox' , $packages->mailbox)->first();
                //dd($usersRes);
                $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                $link = URL::to('/') . '/admin/dashboard';
                $settings = DB::table('settings')->first();
                $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                $settings = DB::table('settings')->first();
                if($settings){
                    $email_from = $settings->from_email;
                }
                $name = PackageStatus::where('id' , $packages->status)->first()->name;
                $status = $name;
                if (filter_var($usersRes->email, FILTER_VALIDATE_EMAIL)) {
                    $settings = DB::table('settings')->first();
                    $logo = URL::to('/') . '/publicsettings/'.$settings->site_logo;
                    $company_name = $settings->company_name;
                    $this->send_email_packeg_update($usersRes->email, $user_name,$packages->tracking_no,$packages->supplier_tracking_no,$packages->mailbox,$packages->courier,$packages->item_description,$packages->weight,$status,$email_subject, $email_from,$logo,$company_name, 'update_packege');
                }
            }
        }else{
            Session::flash('success_msg', 'Please select package first.');
            return redirect('admin/status/packeges/update');
        }

        if($request->status == 7 || $request->isMethod('get')){
            $package_id_Arr = [];
            for($i = 0; $i<count($check_status); $i++){
                $pack_id = $check_status[$i];
                $package_id_Arr[] = $pack_id;
            }
            $data['packages'] = Package::whereIn('packeg_id', $package_id_Arr)->get();
            $data['manifest_info'] = ManifestInfo::first();

            //dd($package_id_Arr);
            $data['packeg_id'] = implode(',' , $package_id_Arr);
            return view('admin/packages/minifist' , $data);
        }else{
            if($request->status == 12){
                Session::flash('success_msg', 'Package status has been updated successfully.');
                return redirect('admin/category/packages/12');
            }else{
                Session::flash('success_msg', 'Package status has been updated successfully.');
                return redirect('admin/status/packeges/update');
            }

        }

    }

    public function addPackage(Request $request , $pack_id = ''){
        $data['title'] = 'Create Package Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Create Package Manifest';

        Package::where('packeg_id', $pack_id)
                      ->update([
                        'is_temprary_logs' => 0
                    ]);
        return redirect('admin/packeges/prealerts');
    }

    public function updateDiliveryOption(Request $request){
        $data['title'] = 'Create Package Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Create Package Manifest';


        Package::where('tracking_no', $request->tracking_no)
                      ->update([
                        'delivery' => $request->delivery,
                        'dilivery_description' => $request->description
                    ]);
        return redirect('user/invoice/upload/'.$request->tracking_no);
    }

    public function createManifest(Request $request){

        $data['title'] = 'Create Package Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Create Package Manifest';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        $validator = Validator::make($request->all(), [
                        'cargo_company' => 'required',
                        'custom_office_code' => 'required',
                        //'voyage_number' => 'required',
                        'date_of_departure' => 'required',
                        'shipping_agent_code' => 'required',
                        'exporter_name' => 'required',
                        'loading_port' => 'required',
                        'exporter_address' => 'required',
                        'master_air_billing_no' => 'required',
                        //'carrier_code' => 'required'
                    ]);
        if ($validator->fails()) {
                return redirect('admin/manifest/create')
                        ->withInput()
                        ->withErrors($validator);
        }else{
            $manifestInfo = ManifestInfo::first();
            if($manifestInfo){
                ManifestInfo::where('id' , 1)
                        ->update([
                            'cargo_company' => $request->cargo_company,
                            'custom_office_code' => $request->custom_office_code,
                            'voyage_number' => $request->voyage_number,
                            'date_of_departure' => $request->date_of_departure,
                            'shipping_agent_code' => $request->shipping_agent_code,
                            'exporter_name' => $request->exporter_name,
                            'loading_port' => $request->loading_port,
                            'exporter_address' => $request->exporter_address,
                            'master_air_billing_no' => $request->master_air_billing_no,
                            'carrier_code' => $request->carrier_code
                        ]);
                $data['outlet_name'] = 'Test Pdf';
                view('pdfinvoice' , $data);
                $fileName = time().'_manifest.pdf';
                $pathPDF = base_path() . '/public/pdf/'.$fileName;
                $baseURL = URL::to('/');
                //$expUrl = explode('/index.php' , $baseURL);
                $url = $baseURL . '/public/pdf/'.$fileName;
                $pdf = PDF::loadView('pdfinvoice' , $data)->save($pathPDF);
                $manifest = new Manifest();
                $manifest->file_pdf = $fileName;
                $manifest->created_at = date('Y-m-d h:i:s');
                $manifest->updated_at = date('Y-m-d h:i:s');
                $manifest->save();
                $manifest_id = $manifest->id;
                $packege_ids = explode(',' ,$request->packege_ids);
                for($i = 0; $i<count($packege_ids); $i++){
                    $manifArray = [];
                    $manifArray['manifest_id'] = $manifest_id;
                    $manifArray['packeges_id'] = $packege_ids[$i];
                    Package::where('packeg_id', $packege_ids[$i])->update(['is_added_manifest' => 1]);
                    if($packege_ids[$i]){
                        DB::table('manifest_packeges')->insert($manifArray);
                    }
                }
                return redirect('admin/package/manifest');
            }else{
                $manInfo = new ManifestInfo();
                $manInfo->cargo_company = $request->cargo_company;
                $manInfo->custom_office_code = $request->custom_office_code;
                $manInfo->date_of_departure = $request->date_of_departure;
                $manInfo->voyage_number = $request->voyage_number;
                $manInfo->shipping_agent_code = $request->shipping_agent_code;
                $manInfo->exporter_name = $request->exporter_name;
                $manInfo->loading_port = $request->loading_port;
                $manInfo->exporter_address = $request->exporter_address;
                $manInfo->master_air_billing_no = $request->master_air_billing_no;
                $manInfo->carrier_code = $request->carrier_code;
                $manInfo->created_at = date('Y-m-d h:i:s');
                $manInfo->updated_at = date('Y-m-d h:i:s');
                $manInfo->save();
                $data['outlet_name'] = 'Test Pdf';
                view('pdfinvoice' , $data);
                $fileName = time().'_manifest.pdf';
                $pathPDF = base_path() . '/public/pdf/'.$fileName;
                $baseURL = URL::to('/');
                //$expUrl = explode('/index.php' , $baseURL);
                $url = $baseURL . '/public/pdf/'.$fileName;
                $pdf = PDF::loadView('pdfinvoice' , $data)->save($pathPDF);
                $manifest = new Manifest();
                $manifest->file_pdf = $fileName;
                $manifest->created_at = date('Y-m-d h:i:s');
                $manifest->updated_at = date('Y-m-d h:i:s');
                $manifest->save();
                $manifest_id = $manifest->id;
                $packege_ids = explode(',' ,$request->packege_ids);
                for($i = 0; $i<count($packege_ids); $i++){
                    $manifArray = [];
                    $manifArray['manifest_id'] = $manifest_id;
                    $manifArray['packeges_id'] = $packege_ids[$i];
                    Package::where('packeg_id', $packege_ids[$i])->update(['is_added_manifest' => 1]);
                    if($packege_ids[$i]){
                        DB::table('manifest_packeges')->insert($manifArray);
                    }
                }

                Session::flash('success_msg', 'Package has been added successfully');
                return redirect('admin/package/manifest');
            }

        }
    }

    public function editManifest(Request $request , $id = ''){
        $data['title'] = 'Update Package Manifest';
        $data['class'] = 'package';
        $data['table'] = 'Update Package Manifest';
        $role_id= Session::get('role_id');
        $user_id= Session::get('user_id');
        $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
        if ($request->isMethod('get')) {
            $data['manifest_info'] = ManifestInfo::first();
            $data['packages'] = DB::table('manifest_packeges')
                                ->select('packages.*','users.first_name','users.last_name')
                                ->join('packages', 'packages.packeg_id', '=', 'manifest_packeges.packeges_id')
                                ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                                ->where('manifest_packeges.manifest_id' , $id)
                                ->get();
            $data['manifest_id'] = $id;
            return view('admin/packages/minifist_edit' , $data);
        }else{
            $validator = Validator::make($request->all(), [
                                'cargo_company' => 'required',
                                //'custom_office_code' => 'required',
                                //'voyage_number' => 'required',
                                'date_of_departure' => 'required',
                                'shipping_agent_code' => 'required',
                                'exporter_name' => 'required',
                                'loading_port' => 'required',
                                'exporter_address' => 'required',
                                'master_air_billing_no' => 'required',
                                //'carrier_code' => 'required'
                            ]);
            if ($validator->fails()) {
                return redirect('admin/manifest/edit/'.$id)
                                ->withInput()
                                ->withErrors($validator);
            }else{
                //echo 'dddddd';exit;
                ManifestInfo::where('id' , 1)
                        ->update([
                            'cargo_company' => $request->cargo_company,
                            'custom_office_code' => $request->custom_office_code,
                            'voyage_number' => $request->voyage_number,
                            'date_of_departure' => $request->date_of_departure,
                            'shipping_agent_code' => $request->shipping_agent_code,
                            'exporter_name' => $request->exporter_name,
                            'loading_port' => $request->loading_port,
                            'exporter_address' => $request->exporter_address,
                            'master_air_billing_no' => $request->master_air_billing_no,
                            'carrier_code' => $request->carrier_code
                        ]);
//                $data['outlet_name'] = 'Test Pdf';
//                view('pdfinvoice' , $data);
//                $fileName = time().'_manifest.pdf';
//                $pathPDF = base_path() . '/public/pdf/'.$fileName;
//                $baseURL = URL::to('/');
//                //$expUrl = explode('/index.php' , $baseURL);
//                $url = $baseURL . '/public/pdf/'.$fileName;
//                $pdf = PDF::loadView('pdfinvoice' , $data)->save($pathPDF);
//                $manifest = new Manifest();
//                $manifest->file_pdf = $fileName;
//                $manifest->created_at = date('Y-m-d h:i:s');
//                $manifest->updated_at = date('Y-m-d h:i:s');
//                $manifest->save();
                $manifest_id = $id;
                $packege_ids = $request->packege_id;
                if($packege_ids){
                    $delete = DB::table('manifest_packeges')->where('manifest_id' , $id)->delete();
                    for($i = 0; $i<count($packege_ids); $i++){
                        $manifArray = [];
                        $manifArray['manifest_id'] = $manifest_id;
                        $manifArray['packeges_id'] = $packege_ids[$i];
                        if($packege_ids[$i]){
                            DB::table('manifest_packeges')->insert($manifArray);
                        }
                    }
                }

                Session::flash('success_msg', 'Manifest has been updated successfully.');
                return redirect('admin/package/manifest');
            }
        }

    }

    public function exportManifest( Request $request , $id = '' ){
       

        $data[ 'title' ] = 'Export Package Manifest';
        $data[ 'class' ] = 'package';
        $data[ 'table' ] = 'Export Package Manifest';
        $role_id = Session::get( 'role_id' );
        $user_id = Session::get( 'user_id' );
        $data[ 'getModues' ] = DB::table( 'role_modules' )->where( 'user_id', '=', $user_id )->where( 'role_id', '=', $role_id )->first();

        $data[ 'manifest_info' ] = ManifestInfo::first();
        $data[ 'packages' ] = ManifestPackage::where( 'manifest_id', $id )
                                ->with( 'info', 'package', 'package.client' )
                                ->get();
        //dd( $data[ 'packages' ] ); exit();

        $content = response()->view( 'admin/packages/minifist_export',$data );
        return response($content)
            ->header('Content-type', 'text/plain')
            ->header('Content-Disposition', 'attachment; filename="manifest.txt"');
    }

    public function deleteManifest($packeges_id = '') {
	$manifest_id = DB::table('manifest_packeges')->where('packeges_id' , $packeges_id)->first()->manifest_id;
        $delete = DB::table('manifest_packeges')->where('packeges_id' , $packeges_id)->delete();
        Session::flash('del_msg', 'Packege has been deleted from Manifest successfully.');
        return redirect('admin/manifest/edit/'.$manifest_id);
    }

    public function printInvoice($invoice_id = ''){

		$data['title'] = 'Manage Invoices';
		$data['class'] = 'invoices';
		$data['table'] = 'Manage Invoices';
		$user_id = Session::get('user_id');
		$data['users'] = User::where('user_id' , $user_id)->first();
		$invoice = Invoice::where('invoice_id' , $invoice_id)->first();
		$client_id = $invoice->client_id;
		$currency_id = $invoice->currency_id;
		$client = Client::where('client_id' , $client_id)->first();
		$data['client'] = $client;
		$country_id = $client->country_id;
		$state_id = $client->state_id;
		$city_id = $client->city_id;
		$data['countries'] = Country::where('id' , $country_id)->first();
		$data['states'] = State::where('id' , $state_id)->first();
		$data['cities'] = City::where('id' , $city_id)->first();
		$data['invoice'] = $invoice;
		if($invoice->tex_type == 1){
			$tex = $invoice->SGST_tex + $invoice->CGST_tex;
			$total_tex = $invoice->total_amount * $tex / 100;
			$amount = $invoice->total_amount + $total_tex;
			$data['amountInWord'] = $this->getAmountInWords($amount);
		}else{
			$tex = $invoice->IGST_tex;
			$total_tex = $invoice->total_amount * $tex / 100;
			$amount = $invoice->total_amount + $total_tex;
			$data['amountInWord'] = $this->getAmountInWords($amount);
		}
		$data['currencies'] = Currency::where('currency_id' ,$currency_id)->first();
		//return view('pdfinvoice' , $data);
		$pdf = PDF::loadView('pdfinvoice' , $data);
		return $pdf->download(time().'_invoice.pdf');
	}

    public function getAmountInWords($amount){
		$number = $amount;
		$no = round($number);
		$point = round($number - $no, 2) * 100;
		$hundred = null;
		$digits_1 = strlen($no);
		$i = 0;
		$str = array();
		$words = array('0' => '', '1' => 'one', '2' => 'two',
				'3' => 'three', '4' => 'four', '5' => 'five', '6' => 'six',
				'7' => 'seven', '8' => 'eight', '9' => 'nine',
				'10' => 'ten', '11' => 'eleven', '12' => 'twelve',
				'13' => 'thirteen', '14' => 'fourteen',
				'15' => 'fifteen', '16' => 'sixteen', '17' => 'seventeen',
				'18' => 'eighteen', '19' =>'nineteen', '20' => 'twenty',
				'30' => 'thirty', '40' => 'forty', '50' => 'fifty',
				'60' => 'sixty', '70' => 'seventy',
				'80' => 'eighty', '90' => 'ninety');
		$digits = array('', 'hundred', 'thousand', 'lakh', 'crore');
		while ($i < $digits_1) {
			$divider = ($i == 2) ? 10 : 100;
			$number = floor($no % $divider);
			$no = floor($no / $divider);
			$i += ($divider == 10) ? 1 : 2;
			if ($number) {
			$plural = (($counter = count($str)) && $number > 9) ? 's' : null;
			$hundred = ($counter == 1 && $str[0]) ? ' and ' : null;
			$str [] = ($number < 21) ? $words[$number] .
			" " . $digits[$counter] . $plural . " " . $hundred
			:
			$words[floor($number / 10) * 10]
			. " " . $words[$number % 10] . " "
			. $digits[$counter] . $plural . " " . $hundred;
			} else $str[] = null;
		}
		$str = array_reverse($str);
		$result = implode('', $str);
		$points = ($point) ?
		"." . $words[$point / 10] . " " .
		$words[$point = $point % 10] : '';
		return  $result . "Rupees";
	}

    function generate_password($length) {
        $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        return substr(str_shuffle($chars), 0, $length);
    }

    public function add(Request $request){
            $data['title'] = 'Add Pre-Alert';
            $data['class'] = 'account';
            $data['table'] = 'Add Pre-Alert';
            $role_id= Session::get('role_id');
            $user_id = Session::get('user_id');
            $mailbox = User::where('user_id' , $user_id)->first()->mailbox;
            $data['getModues'] = DB::table('role_modules')->where('user_id', '=', $user_id)->where('role_id', '=', $role_id)->first();
            if ($request->isMethod('get')) {
                $data['mailbox'] = $mailbox;
                 $data['types'] = PackageType::get();
                $data['users'] = User::where('role_id' , 0)->get();
                return view('admin/packages/addpackage' , $data);
            }else{
                $validator = Validator::make($request->all(), [
                                    'mailbox' => 'required',
                                    'courier' => 'required',
                                    'weight' => 'required',
                                    'supplier_tracking_no' => 'required|unique:packages|max:255'
                                ]);
                if ($validator->fails()) {
                        return redirect('user/packege/add')
                                ->withInput()
                                ->withErrors($validator);
                }else{
                    $name = '';
                    if ($request->hasFile('input_img')) {
                        $image = $request->file('input_img');
                        $name = time().'.'.$image->getClientOriginalExtension();
                        $destinationPath = public_path('/invoices');
                        $image->move($destinationPath, $name);
                    }
                    $package_type = explode('-' , $request->package_type);
                    $tracking_no = $this->generate_password(13);
                    $packages = DB::table('packages')->orderBy('manifest_no','DESC')->first();

                    if($packages){
                        $manifest_no = $packages->manifest_no + 1;
                    }else{
                        $manifest_no = '10000';
                    }
                    $packages = new Package();
                    $packages->tracking_no = $tracking_no;
                    $packages->nick_name = $request->nick_name;
                    $packages->merchant = $request->merchant;
                    //$packages->permotion_code = $request->permotion_code;
                    //$packages->EEI = $request->EEI;

                    $packages->mailbox = $request->mailbox;
                    $packages->courier = $request->courier;
                    $packages->supplier_tracking_no = $request->supplier_tracking_no;
                    $packages->package_type = $package_type[1];
                    $packages->package_code = $package_type[0];
                    $packages->weight = $request->weight;
                    $packages->price = $request->price;
                    $packages->custom_fee = $request->custom_fee;
                    $packages->manifest_no = $manifest_no;
                    $packages->invoice = $name;
                    $packages->is_temprary_logs = 1;
                    $packages->status = 9;
                    $packages->item_description = $request->item_description;
                    $packages->created_at = date('Y-m-d h:i:s');
                    $packages->updated_at = date('Y-m-d h:i:s');
                    $packages->save();
                    $usersRes = User::where('mailbox' , $request->mailbox)->first();
                    $user_name = $usersRes->first_name.' '.$usersRes->last_name;
                    $link = URL::to('/') . '/admin/dashboard';
                    $settings = DB::table('settings')->first();
                    $email_subject = 'Brand New UPDATE from '.$settings->company_name;
                    $settings = DB::table('settings')->first();
                    if($settings){
                        $email_from = $settings->from_email;
                    }
                    $status = 'Arrived in Miami';
                    $this->send_email_packeg($usersRes->email, $user_name,$tracking_no,$request->supplier_tracking_no,$request->mailbox,$request->courier,$request->item_description,$request->weight,$status,$email_subject, $email_from, 'create_packege');
                    Session::flash('success_msg', 'Package has been added successfully');
                    return redirect('user/packeges/current');
                }
            }
	}

     public function send_email_packeg($email, $user_name, $tracking_no, $supplier_tracking_no, $mailbox, $courier, $item_description, $weight, $status, $email_subject, $email_from, $logo, $company_name, $view_name) {
    $settings = DB::table('settings')->first();
    $logo = URL::to('/') . '/public/settings/' . $settings->site_logo;
    $company_name = $settings->company_name;
    
    $res['userName'] = $user_name;
    $res['tracking_no'] = $tracking_no;
    $res['mailbox'] = $mailbox;
    $res['courier'] = $courier;
    $res['item_description'] = $item_description;
    $res['weight'] = $weight;
    $res['supplier_tracking_no'] = $supplier_tracking_no;
    $res['status'] = $status;
    $res['logo_url'] = $logo;
    $res['company_name'] = $company_name;

    try {
        Mail::send('email/' . $view_name, $res, function ($message) use ($email_from, $email, $user_name, $email_subject, $company_name) {
            $message->from($email_from, $company_name);
            $message->to($email, $user_name)->subject($email_subject);
        });

    } catch (\Exception $e) {
        \Log::error('Package email sending failed: ' . $e->getMessage()); // Log error but continue execution
    }
}

    
   public function send_email_packeg_update($email, $user_name, $tracking_no, $supplier_tracking_no, $mailbox, $courier, $item_description, $weight, $status, $email_subject, $email_from, $logo, $company_name, $view_name) {
    $settings = DB::table('settings')->first();
    $logo = URL::to('/') . '/public/settings/' . $settings->site_logo;
    $company_name = $settings->company_name;
    
    $res['userName'] = $user_name;
    $res['tracking_no'] = $tracking_no;
    $res['mailbox'] = $mailbox;
    $res['courier'] = $courier;
    $res['item_description'] = $item_description;
    $res['weight'] = $weight;
    $res['supplier_tracking_no'] = $supplier_tracking_no;
    $res['status'] = $status;
    $res['logo_url'] = $logo;
    $res['company_name'] = $company_name;

    try {
        Mail::send('email/' . $view_name, $res, function ($message) use ($email_from, $email, $user_name, $email_subject, $company_name) {
            $message->from($email_from, $company_name);
            $message->to($email, $user_name)->subject($email_subject);
        });

    } catch (\Exception $e) {
        \Log::error('Package update email sending failed: ' . $e->getMessage()); // Log error but continue execution
    }
}


    public function send_email_packegold($email, $user_name,$tracking_no,$supplier_tracking_no,$mailbox,$courier,$item_description,$weight, $status,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $subject = $email_subject;
        $headers = "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
        $message = '<!DOCTYPE html>
                        <html lang="en">
                        <head>
                            <title>Email</title>
                            <meta charset="utf-8">
                            <meta name="viewport" content="width=device-width, initial-scale=1">
                            <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
                            <style>
                                body{
                                    overflow-x: hidden;
                                }
                                @media (max-width:1180px) {

                                }

                                @media (max-width: 767.98px) {

                                }
                                @media (max-width:812px) {
                            .email-bg{
                                       width: 90%  !important;
                                   }
                        }
                        .main_content ul {
                            width: 80% !important;
                        }
                                @media (max-width: 600px) {
                                    .main_content ul {
                            width: 96% !important;
                        }
                                   .email-bg{
                                       width: 90%  !important;
                                       padding: 10px !important;
                                   }
                                }
                                     @media (max-width:480px){
                                    .main_content ul {
                            width: 98% !important;
                            padding: 6px !important;
                            font-size: 14px;
                        }
                        .email_content p {
                            font-size: 16px !important;
                        }
                        .email-bg{
                                       width: 93%  !important;
                                       padding: 10px !important;
                                   }
                                     }
                                @media (max-width:380px){
                                  .small_text{
                                      font-size: 16px  !important;
                                  }
                                  .email_content p {
                            font-size: 16px !important;
                        }
                        .big_head {
                            font-size: 13px !important;
                            width: 25% !important;
                        }
                                }
                                @media (max-width:380px){
                                  .small_text{
                                      font-size: 12px  !important;
                                  }
                                }
                            </style>

                        </head>

                        <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
                            <main>
                                <!----- EMAIL-SECTOION-START ------>
                                <section class="email-bg"
                                    style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                                    <div class="container">
                                        <header style="border-bottom: 1px solid #ccc;">
                                            <img class="logo" src="'.$logo.'" alt="logo" style=" width:20%;">
                                        </header>
                                        <div class="email_content" style="
                                        width: 100%;
                                    ">
                                            <h4 style="font-size: 24px;margin-bottom:0;">Brand New UPDATE from '.$company_name.'</h4>
                                            <p style="font-size: 20px;">Dear '.$user_name.',</p>
                                            <p style="font-size: 20px;">We have received the following package at our Miami warehouse. your
                                                package details are listed below</p>

                                                <div class="main_content" style="border-bottom: 1px solid #ccc;">
                                                    <ul style="list-style: none;width: 50%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                        <li class="big_head"style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373; vertical-align: middle;">
                                                            Supplier Tracking #
                                                        </li>
                                                        <li class="small_text" style="display: inline-block; width: 68%; padding: 0 0 10px 0; vertical-align: middle;">'.$supplier_tracking_no.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;">
                                                            Account no
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$mailbox.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Supplier
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$courier.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Weight
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$weight.' lbs</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Description
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$item_description.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Status
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$status.'</li>
                                                    </ul>
                                                </div>
                                            <p style="font-size: 20px;">You will be notified of your charges as soon as your package arrives in
                                                Jamaica.</p>
                                            <p style="font-size: 20px;">To ensure smooth process kindly update a copy of the invoice(s) of your
                                                purchas(s) provided by the selier</p>
                                            <p style="font-size: 20px;">This procedire will avoid any delays at Customs, upon arrival of your
                                                package.</p>

                                        </div>
                                        <footer style="font-size: 14px; border-top: 1px solid #ccc;">
                                            <h4 style=" font-size: 13px;color: #8c8c8c;">Thanks for your support Enjoy your shopping experience.
                                            </h4>
                                            <p style=" font-size: 13px;color: #8c8c8c;">Best Wishes</p>
                                            <p style=" font-size: 13px;color: #8c8c8c;">'.$company_name.' Client Services</p>
                                        </footer>
                                    </div>
                                </section>
                                <!----- EMAIL-SECTOION-END ------>

                            </main>
                        </body>
                        </html>';
            $user_email = $email;
            //$user_email = 'rizwan@decodershub.com';
            mail($user_email,$subject,$message,$headers);
    }

    public function send_email_packeg_updateold($email, $user_name,$tracking_no,$supplier_tracking_no,$mailbox,$courier,$item_description,$weight, $status,$email_subject, $email_from,$logo,$company_name,$view_name) {
        $subject = $email_subject;
        $headers = "MIME-Version: 1.0\r\n";
        $headers .= "Content-Type: text/html; charset=UTF-8\r\n";
        $message = '<!DOCTYPE html>
                        <html lang="en">
                        <head>
                            <title>Email</title>
                            <meta charset="utf-8">
                            <meta name="viewport" content="width=device-width, initial-scale=1">
                            <link href="https://fonts.googleapis.com/css2?family=Lato:wght@400;700;900&display=swap" rel="stylesheet">
                            <style>
                                body{
                                    overflow-x: hidden;
                                }
                                @media (max-width:1180px) {

                                }

                                @media (max-width: 767.98px) {

                                }
                                @media (max-width:812px) {
                            .email-bg{
                                       width: 90%  !important;
                                   }
                        }
                        .main_content ul {
                            width: 80% !important;
                        }
                                @media (max-width: 600px) {
                                    .main_content ul {
                            width: 96% !important;
                        }
                                   .email-bg{
                                       width: 90%  !important;
                                       padding: 10px !important;
                                   }
                                }
                                     @media (max-width:480px){
                                    .main_content ul {
                            width: 98% !important;
                            padding: 6px !important;
                            font-size: 14px;
                        }
                        .email_content p {
                            font-size: 16px !important;
                        }
                        .email-bg{
                                       width: 93%  !important;
                                       padding: 10px !important;
                                   }
                                     }
                                @media (max-width:380px){
                                  .small_text{
                                      font-size: 16px  !important;
                                  }
                                  .email_content p {
                            font-size: 16px !important;
                        }
                        .big_head {
                            font-size: 13px !important;
                            width: 25% !important;
                        }
                                }
                                @media (max-width:380px){
                                  .small_text{
                                      font-size: 12px  !important;
                                  }
                                }
                            </style>

                        </head>

                        <body style="background-color: #f1f1f1; font-family: "Lato", sans-serif; overflow-x: hidden; margin: 0;">
                            <main>
                                <!----- EMAIL-SECTOION-START ------>
                                <section class="email-bg"
                                    style=" width: 60%;margin: 60px auto;box-shadow: 0 2px 8px hsl(0deg 0% 0% / 16%);background: #fff;padding: 20px;">
                                    <div class="container">
                                        <header style="border-bottom: 1px solid #ccc;">
                                            <img class="logo" src="'.$logo.'" alt="logo" style=" width:20%;">
                                        </header>
                                        <div class="email_content" style="
                                        width: 100%;
                                    ">
                                            <h4 style="font-size: 24px;margin-bottom:0;">Brand New UPDATE from '.$company_name.'</h4>
                                            <p style="font-size: 20px;">Dear '.$user_name.',</p>
                                            <p style="font-size: 20px;">Please see your package details listed below:</p>

                                                <div class="main_content" style="border-bottom: 1px solid #ccc;">
                                                    <ul style="list-style: none;width: 50%;box-shadow: 0 0 3px rgb(0 0 0 / 16%);padding: 10px;border-radius: 6px;">
                                                        <li class="big_head"style="display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373; vertical-align: middle;">
                                                            Supplier Tracking #
                                                        </li>
                                                        <li class="small_text" style="display: inline-block; width: 68%; padding: 0 0 10px 0; vertical-align: middle;">'.$supplier_tracking_no.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px;color:#737373;">
                                                            Account no
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$mailbox.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Supplier
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 10px 0;">'.$courier.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Weight
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$weight.' lbs</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Description
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;">'.$item_description.'</li>
                                                        <li class="big_head" style="vertical-align: middle; display: inline-block;width: 30%;padding: 0 0 12px 0;font-weight: 800;font-size: 16px; color:#737373;">
                                                            Status
                                                        </li>
                                                        <li style="vertical-align: middle; display: inline-block; width: 68%; padding: 0 0 12px 0;font-size: 22px;font-weight: 800;">'.$status.'</li>
                                                    </ul>
                                                </div>

                                        </div>
                                        <footer style="font-size: 14px; border-top: 1px solid #ccc;">
                                            <h4 style=" font-size: 13px;color: #8c8c8c;">Thanks for your support Enjoy your shopping experience.
                                            </h4>
                                            <p style=" font-size: 13px;color: #8c8c8c;">Best Wishes</p>
                                            <p style=" font-size: 13px;color: #8c8c8c;">'.$company_name.' Client Services</p>
                                        </footer>
                                    </div>
                                </section>
                                <!----- EMAIL-SECTOION-END ------>

                            </main>
                        </body>
                        </html>';
            $user_email = $email;
            //$user_email = 'rizwangill132@gmail.com';
            mail($user_email,$subject,$message,$headers);
    }

    public function packeges($id = ''){
        //return $id;
        $packeges = Package::where('mailbox' , $id)->where('packages.status' , '!=' , 9)->where('packages.status' , '!=' , 12)->get();
        //dd($packeges);
        if(count($packeges) > 0){
            $packagesArr = [];
            foreach($packeges as $row){
                $invoices = DB::table('invoice_packages')->where('tracking_no' , $row->tracking_no)->first();
                //dd($invoices);
                if($invoices == null){
                    $data['packagesInv'] = '';
                    $packagesArr[] = $row;
                }
            }
            if(count($packagesArr) > 0){
                $data['packagesInv'] = '';
                $data['packeges'] = $packagesArr;
                //dd($data['packeges']);
                return view('admin/packages/ajaxpackeage' , $data);
            }else{
                return 'failed';
            }
        }else{
            return 'failed';
        }
    }

    public function weight($id = ''){

        $packages = Package::where('tracking_no' , $id)->first();
        //dd($packages);
        $weight = ceil($packages->weight);
        if($weight > 100){
            $weightRes = DB::table('weights')->where('weight' , 100)->first();
            if($weightRes){
                $price = $weightRes->price;
            }
        }else{
            if($weight < 1){
                $weightRes = DB::table('weights')->where('weight' , 1)->first();
                if($weightRes){
                    $price = $weightRes->price;
                }
            }else{
                $weightRes = DB::table('weights')->where('weight' , $weight)->first();
                if($weightRes){
                    $price = $weightRes->price;
                }
            }
            
        }

        //$data['package'] = $packages;
        //$price = DB::table('weights')->where('weight' , $packages->weight)->first()->price;
        DB::table('invice_temp')->insert(['mailbox' => $packages->mailbox,'tracking_no' => $packages->tracking_no,'price' => $price,'weight' => $packages->weight,'description' => $packages->item_description]);
        $data['packagesInv'] = DB::table('invice_temp')->where('mailbox' , $packages->mailbox)->get();
        //dd($data['package']);
        $packegesInvice = Package::where('mailbox' , $packages->mailbox)->where('packages.status' , '!=' , 9)->where('packages.status' , '!=' , 12)->get();
        if(count($packegesInvice) > 0){
            $packagesArr = [];
            foreach($packegesInvice as $row){
                $invoices = DB::table('invice_temp')->where('tracking_no' , $row->tracking_no)->first();
                if($invoices == null){
                    $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $row->tracking_no)->first();
                    if($invoicesPack == null){
                        $packagesArr[] = $row;
                    }
                }
            }
            if(count($packagesArr) > 0){
                $data['packeges'] = $packagesArr;
            }else{
                $data['packeges'] = $packagesArr;
            }
        }
        return view('admin/packages/ajaxpackeage' , $data);
    }

    public function weightEdit($id = '',$inv_id = ''){

        $packages = Package::where('tracking_no' , $id)->first();
        //dd($packages);
        $weight = $packages->weight;
         if($weight > 100){
            $weightRes = DB::table('weights')->where('weight' , 100)->first();
            if($weightRes){
                $price = $weightRes->price;
            }
        }else{
            if($weight < 1){
                $weightRes = DB::table('weights')->where('weight' , 1)->first();
                if($weightRes){
                    $price = $weightRes->price;
                }
            }else{
                $weightRes = DB::table('weights')->where('weight' , $weight)->first();
                if($weightRes){
                    $price = $weightRes->price;
                }
            }
            
        }

        //$data['package'] = $packages;
        //$price = DB::table('weights')->where('weight' , $packages->weight)->first()->price;
        DB::table('invice_temp')->insert(['mailbox' => $packages->mailbox,'tracking_no' => $packages->tracking_no,'price' => $price,'weight' => $packages->weight,'description' => $packages->item_description]);
        $data['packagesInv'] = DB::table('invice_temp')->where('mailbox' , $packages->mailbox)->get();
        //dd($data['package']);
        $packegesInvice = Package::where('mailbox' , $packages->mailbox)->where('packages.status' , '!=' , 9)->where('packages.status' , '!=' , 12)->get();
        if(count($packegesInvice) > 0){
            $packagesArr = [];
            foreach($packegesInvice as $row){
                $invoices = DB::table('invice_temp')->where('tracking_no' , $row->tracking_no)->first();
                if($invoices == null){
                    $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $row->tracking_no)->first();
                    if($invoicesPack == null){
                        $packagesArr[] = $row;
                    }
                }
            }
            if(count($packagesArr) > 0){
                $data['packeges'] = $packagesArr;
            }else{
                $data['packeges'] = $packagesArr;
            }
            $data['invoice_packages'] = DB::table('invoice_packages')->where('invoice_id' , $inv_id)->get();
            $invoice = Invoice::where('invoice_id' , $inv_id)->first();
            $data['invoice'] = $invoice;
            $data['service_type'] = DB::table('service_type')->where('invoice_id' , $inv_id)->get();
            $data['invoice_id'] = $inv_id;
        }
        return view('admin/packages/ajaxEditpackeage' , $data);
    }

    public function deletePackage($id = ''){

        $packages = Package::where('tracking_no' , $id)->first();
        //$data['package'] = $packages;
        $weight = round($packages->weight);
        DB::table('invice_temp')->where('tracking_no' , $id)->delete();
        $data['packagesInv'] = DB::table('invice_temp')->where('mailbox' , $packages->mailbox)->get();
        //dd($data['package']);
        $packegesInvice = Package::where('mailbox' , $packages->mailbox)->where('packages.status' , '!=' , 9)->where('packages.status' , '!=' , 12)->get();
        if(count($packegesInvice) > 0){
            $packagesArr = [];
            foreach($packegesInvice as $row){

                $invoices = DB::table('invice_temp')->where('tracking_no' , $row->tracking_no)->first();
                if($invoices == null){
                    $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $row->tracking_no)->first();
                    if($invoicesPack == null){
                        $packagesArr[] = $row;
                    }
                }
            }
            if(count($packagesArr) > 0){
                $data['packeges'] = $packagesArr;
            }else{
                $data['packeges'] = $packagesArr;
            }
        }

        return view('admin/packages/ajaxpackeage' , $data);
    }

    public function deletePackageEdit($id = '',$invID = ''){
        $packages = Package::where('tracking_no' , $id)->first();
        $weight = round($packages->weight);
        if($weight > 100){
            $weightRes = DB::table('weights')->where('weight' , 100)->first();
            if($weightRes){
                $price = $weightRes->price;
            }
        }else{
            if($weight < 1){
                $weightRes = DB::table('weights')->where('weight' , 1)->first();
                if($weightRes){
                    $price = $weightRes->price;
                }
            }else{
                $weightRes = DB::table('weights')->where('weight' , $weight)->first();
                if($weightRes){
                    $price = $weightRes->price;
                }
            }
            
        }
        DB::table('invice_temp')->where('tracking_no' , $id)->delete();
        $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $id)->delete();
        //$price = DB::table('weights')->where('weight' , $packages->weight)->first()->price;
        //DB::table('invice_temp')->insert(['mailbox' => $packages->mailbox,'tracking_no' => $packages->tracking_no,'price' => $price,'weight' => $packages->weight,'description' => $packages->item_description]);
        $data['packagesInv'] = DB::table('invice_temp')->where('mailbox' , $packages->mailbox)->get();
        //dd($data['package']);
        $packegesInvice = Package::where('mailbox' , $packages->mailbox)->where('packages.status' , '!=' , 9)->where('packages.status' , '!=' , 12)->get();
        if(count($packegesInvice) > 0){
            $packagesArr = [];
            foreach($packegesInvice as $row){

                $invoices = DB::table('invice_temp')->where('tracking_no' , $row->tracking_no)->first();
                if($invoices == null){
                    $invoicesPack = DB::table('invoice_packages')->where('tracking_no' , $row->tracking_no)->first();

                    if($invoicesPack == null){
                        $packagesArr[] = $row;
                    }
                }
            }
            if(count($packagesArr) > 0){
                $data['packeges'] = $packagesArr;
            }else{
                $data['packeges'] = $packagesArr;
            }
        }
        $invoice = Invoice::where('invoice_id' , $invID)->first();
        $data['invoice'] = $invoice;
        $data['invoice_packages'] = DB::table('invoice_packages')->where('invoice_id' , $invID)->get();
        $data['invoice_id'] = $invID;
        $data['service_type'] = DB::table('service_type')->where('invoice_id' , $invID)->get();
        return view('admin/packages/ajaxEditpackeage' , $data);
    }

    public function delete() {
        $packeges_id = request()->id;
        $tracking_no = Package::where('packeg_id' , $packeges_id)->first()->tracking_no;
	    //$invoices = DB::table('invoices')->where('tracking_no' , $tracking_no)->delete();
        $delete = DB::table('manifest_packeges')->where('packeges_id' , $packeges_id)->delete();
        Package::where('packeg_id' , $packeges_id)->delete();
        return ["status" => true,"message" =>"Package deleted successfully"];
    }

    /**
     * Get package type codes (HS 6 digit)
     *
     * @return \Illuminate\Http\Response
     */
    public function types()
    {
        $s = isset( $_GET[ 'q' ] )? $_GET[ 'q' ] : null;
        $results = HSCode::orderBy( 'description' )
            ->orWhere( 'description', 'like', '%' . $s . '%' )
            ->get();
        foreach ( $results as $result )
            $data[ 'items' ][] = [ 'id' => $result->code, 'text' => $result->description ];
        return response()->json( $data, 200 );
    }
}
