<?php

namespace App\Http\Controllers\Users;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Admin;
use Session;
use Validator;
use App\Models\User;
use Illuminate\Support\Facades\Hash;
use Image;
use File;
use DB;
use Yajra\DataTables\Facades\DataTables;
use commonHelper;

class DashboardControllor extends Controller
{

    public function __construct() {
        $this->middleware('guest', ['except' => 'logout']);
    }

    public function dashboard(Request $request) {
        $id = Session::get('site_user_id');
        $mailbox = Session::get('mailbox');
        $data['title'] = 'Dashboard';
        $data['class'] = 'dashboard';
        $invoiceTotal = 0;
        $data['setting'] = DB::table('settings')->first();
        $data['outstanding_package'] = DB::table('packages')->where('packages.status' , 1)->where('packages.mailbox' , $mailbox)->count();
        $data['in_transit'] = DB::table('packages')->where('packages.status' , 15)->count();
        $data['outstanding_invoice'] = DB::table('invoices')->where('invoices.mailbox_no' , $mailbox)->where('invoices.status' , 0)->count();
        $package_weight = DB::table('transactions')->where('mailbox' , $mailbox)->sum('weight');
        $data['package_weight'] = $package_weight;
        $packages = DB::table('transactions')->where('mailbox' , $mailbox)->first();
        //dd($packages);
        if($packages){
            if($packages->package_ids != null){
                $package_count = json_decode($packages->package_ids,true);
                $data['package_count'] = count($package_count);
            }else{
                if($package_weight > 0){
                    $data['package_count'] = 1;
                }else{
                    $data['package_count'] = 0;
                }
            }
            
        }else{
            if($package_weight > 0){
                $data['package_count'] = 1;
            }else{
                $data['package_count'] = 0;
            }
            
        }
        
        // $outstanding_balance = DB::table('invoices')->where('invoices.mailbox_no' , $mailbox)->where('invoices.status' , 0)->get();
        // //dd($outstanding_balance);
        // if(count($outstanding_balance) > 0){
        //     foreach($outstanding_balance as $row){
        //         $totalInv = commonHelper::getInvoiceOutstanding($row->invoice_id);
        //         $invoiceTotal = $invoiceTotal + $totalInv;
        //     }
        // }
        $invoiceImount = DB::table('invoices')
                            ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                            ->select(DB::raw("SUM(invoice_packages.package_price) as pk_price"),DB::raw("SUM(invoice_packages.custom_fee) as cus_fee"),DB::raw("SUM(invoice_packages.service_fee) as ser_fee"),DB::raw("SUM(invoices.discount_price) as discount_price"))
                            ->where('invoices.email_sent' , 1)
                            ->where('invoices.invoice_type' , 1)
                            ->where('invoices.status' , 0)
                            ->where('invoice_packages.status' , 0)
                            ->where('invoices.mailbox_no' , $mailbox)
                            ->first();
                            //dd($invoiceImount);
        $invoiceImountGct = DB::table('invoices')
                    ->join('invoice_packages' , 'invoice_packages.invoice_id' ,'=','invoices.invoice_id')
                    ->select(DB::raw("SUM(invoice_packages.service_fee) as ser_fee"))
                    ->where('invoices.email_sent' , 1)
                    ->where('invoices.invoice_type' , 1)
                    ->where('invoices.status' , 0)
                    ->where('invoice_packages.status' , 0)
                    ->where('invoices.mailbox_no' , $mailbox)
                    ->where('invoices.gct' , 1)
                    ->first();
                    //dd($invoiceImountGct);
        $total = 0;            
        $us_rate = DB::table('settings')->first()->us_rate;
        if($invoiceImount){
            if($invoiceImount->pk_price != ''){
                if($invoiceImountGct){
                    $ser_fee = $invoiceImountGct->ser_fee * $us_rate;
                    $gctAmount = $ser_fee * 15 / 100;
                }else{
                    $gctAmount = 0;
                }
                $totalInv = ($invoiceImount->pk_price + $invoiceImount->cus_fee + $invoiceImount->ser_fee) * $us_rate;
                $subTotal = $totalInv - $invoiceImount->discount_price;
                $total = $total + $subTotal + $gctAmount;
            }
        }            
        $data['outstanding_balance'] = number_format($total,2).' JMD';
        $data['wherehouse'] = DB::table('packages')->where('packages.status' , 3)->where('packages.mailbox' , $mailbox)->count();
        
        $credit_points = DB::table('member_points')->where('user_id' , $mailbox)->where('status' , 0)->where('type' , 1)->sum('balance');
        $debit_points = DB::table('member_points')->where('user_id' , $mailbox)->where('status' , 0)->where('type' , 2)->sum('balance');
        $data['member_points'] = $credit_points - $debit_points;
        
        $users = User::where('user_id' , $id)->first();
        //dd($users);
        if($users){
            //$referral_code = base64_encode($users->referral_code);
            $referral_code = base64_encode($users->referral_code);
			$data['referral_code'] = $referral_code;
        }else{
			$referral_code = '';
            $data['referral_code'] =  $referral_code;
        }
        
        $credit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 1)->where('type' , 1)->sum('balance');
        $debit_ref_points = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 2)->sum('balance');
        $ref_debit_points = DB::table('member_points')->where('user_id' , $mailbox)->where('status' , 0)->where('type' , 3)->sum('balance');
        
        $data['pending_balance'] = DB::table('member_referral_points')->where('from_user_id' , $users->user_id)->where('status' , 0)->where('type' , 1)->sum('balance');
        $ref_available_balance = $credit_ref_points - $debit_ref_points;
        
        $data['available_balance'] = $ref_available_balance - $ref_debit_points;
        return view('users/dashboard/dashboard' , $data);
    }

    public function listViewReady(){
        $mailbox = Session::get('mailbox');
        $query = DB::table('packages')
                    ->select('packages.*','users.first_name','users.last_name','package_status.name')
                    ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                    ->join('package_status', 'package_status.id', '=', 'packages.status')
                    ->where('packages.status' , 1)
                    ->where('packages.mailbox' , $mailbox);
        return DataTables::of($query)->make(true);
    }


    public function listViewRecent(){
        $mailbox = Session::get('mailbox');
        $query = DB::table('packages')
                    ->select('packages.*','users.first_name','users.last_name','package_status.name')
                    ->join('users', 'packages.mailbox', '=', 'users.mailbox')
                    ->join('package_status', 'package_status.id', '=', 'packages.status')
                    ->where('packages.status' ,'!=' , 1)
                    ->where('packages.mailbox' , $mailbox);
        return DataTables::of($query)->make(true);
    }

	public function profile(Request $request) {
		$data['title'] = 'Manages Profile';
		$data['class'] = 'dashboard';
		$data['table'] = 'Update Profile';
		$user_id= Session::get('user_id');
		if ($request->isMethod('get')) {
			$data['users'] = User::where('user_id' , $user_id)->first();
			return view('front/dashboard/create' , $data);
		}else{
			$validator = Validator::make($request->all(), [
				'name' => 'required',
				'password' => 'same:confirm_pass',
				'phone' => 'required|numeric',
				'address' => 'required',
			]);
			if ($validator->fails()) {
				return redirect('user/profile')
					->withInput()
					->withErrors($validator);

			}else{
				$password = $request->password;
				if($password == ''){
					User::where('user_id', $user_id)
							  ->update([
										'name' => $request->name,
										'phone' => $request->phone,
										'address' => $request->address
								]);
					Session::put('name', $request->name);
					Session::flash('success_msg', 'Profile has been updated successfully.');
					return redirect('user/profile');
				}else{
					User::where('user_id', $user_id)
							  ->update([
										'name' => $request->name,
										'phone' => $request->phone,
										'address' => $request->address,
										'password' => Hash::make($password)

								]);
					Session::put('name', $request->name);
					Session::put('phone', $request->phone);
					Session::flash('success_msg', 'Profile has been updated successfully.');
					return redirect('user/profile');
				}
			}
		}

    }
     public function changePassword(Request $request) {
        $data['title'] = 'Change Password';
        $data['class'] = 'users';
        $data['table'] = 'Change Password';
        $user_id = Session::get('site_user_id');
        if ($request->isMethod('get')) {
            //$data['email'] = $id;
            return view('users/users/change_password', $data);
        }else{
            $validator = Validator::make($request->all(), [
                'new_password' => 'required|same:confirm_password',
                'confirm_password' => 'required',
            ]);
            if ($validator->fails()) {
                return redirect('user/change/password')
                        ->withInput()
                        ->withErrors($validator);
            }else{
                $users = User::where('user_id', $user_id)->first();
                if($users){
                    $user_password = $users->password;
                    if(Hash::check($request->old_password, $user_password)){
                        $password = $request->input("new_password");
                        User::where('user_id', $user_id)->update(['password' => Hash::make($password)]);
                        Session::flash('error_msg', 'Your password was reset successfully. You may now log in with new password.'); 
                        $request->session()->flush();
                        return redirect('user/change/password');
                    }else{
                        Session::flash('error_msg', 'Your current password does not matched'); 
                        return redirect('user/change/password');
                    }
                }else{
                    Session::flash('error_msg', 'User does not exist in our database.'); 
                    return redirect('user/change/password');
                }  
            }
        }
    }
}
