<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\API\UserController;
use App\Http\Controllers\API\AuthorizeuserApiController;
use App\Http\Controllers\API\DashboardApiController;
use App\Http\Controllers\API\PackagesApiController;
use App\Http\Controllers\API\InvoicesApiController;
use App\Http\Controllers\Zoom\MeetingController;
use App\Http\Controllers\API\PurchaseApiController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Auth::routes();
Route::get('GetUsers','API\V1\ApiController@GetUsers');
Route::post('GetUsers','API\V1\ApiController@GetUsersNew');
Route::post('savePackage','API\V1\ApiController@savePackage');
Route::post('checkPackage','API\V1\ApiController@checkPackage');
Route::post('updatePackageStatus','API\V1\ApiController@updatePackageStatus');
Route::post('updatePackageUser','API\V1\ApiController@updatePackageUser');
Route::post('deletePackage','API\V1\ApiController@deletePackage');
Route::post('createPackageManifest','API\V1\ApiController@createPackageManifest');
Route::post('updatePackageManifest','API\V1\ApiController@updatePackageManifest');

Route::get('/GetMetraAppInformation', [UserController::class, 'GetMetraAppInformation']);
Route::get('/getOutlets', [UserController::class, 'getOutlets']);
Route::get('/getAreas', [UserController::class, 'getAreas']);
Route::get('/getDays', [UserController::class, 'getDays']);
Route::post('/RegisterUser', [UserController::class, 'registerUser']);
Route::post('/loginUser', [UserController::class, 'loginUser']);
Route::post('/ForgotPassword', [UserController::class, 'forgotPassword']);
Route::get('/GetMetaInformation', [UserController::class, 'GetMetaInformation']);


Route::middleware('auth:api')->group(function() {
    Route::post('/Logout', [UserController::class, 'logout']);
    Route::post('/ChangePassword', [UserController::class, 'updatePassword']);
    Route::get('/DeleteUser', [UserController::class, 'DeleteUser']);
    Route::get('/GetProfile', [UserController::class, 'getProfile']);
    Route::post('/EditProfile', [UserController::class, 'editProfile']);
    
    Route::get('/GetDashboardData', [DashboardApiController::class, 'GetDashboardData']);
    Route::post('/GetReadyforPickupPackages', [DashboardApiController::class, 'GetReadyforPickupPackages']);
    Route::get('/GetAddressData', [DashboardApiController::class, 'GetAddressData']);
    Route::post('/GetReferralUsers', [DashboardApiController::class, 'GetReferralUsers']);
    
    Route::post('/AddAuthorizeUser', [AuthorizeuserApiController::class, 'AddAuthorizeUser']);
    Route::post('/GetAuthorizeUsers', [AuthorizeuserApiController::class, 'GetAuthorizeUsers']);
    Route::post('/EditAuthorizeUser', [AuthorizeuserApiController::class, 'EditAuthorizeUser']);
    Route::post('/UpdateAuthorizeUser', [AuthorizeuserApiController::class, 'UpdateAuthorizeUser']);
    Route::post('/DeleteAuthorizeUser', [AuthorizeuserApiController::class, 'DeleteAuthorizeUser']);
    
    Route::post('/AddPreAlert', [PackagesApiController::class, 'AddPreAlert']);
    Route::post('/UploadInvoice', [PackagesApiController::class, 'UploadInvoice']);
    Route::post('/GetAllPackages', [PackagesApiController::class, 'GetAllPackages']);
    Route::post('/GetPackagesSearch', [PackagesApiController::class, 'GetPackagesSearch']);
    Route::get('/GetDeliveryPackages', [PackagesApiController::class, 'GetDeliveryPackages']);
    Route::post('/CreateDeliveryRequest', [PackagesApiController::class, 'CreateDeliveryRequest']);
    Route::post('/GetAllInvoices', [InvoicesApiController::class, 'GetAllInvoices']);
    Route::post('/GetInvoicesSearch', [InvoicesApiController::class, 'GetInvoicesSearch']);
    Route::post('/InvoicesDetail', [InvoicesApiController::class, 'InvoicesDetail']);
    
    Route::post('/AddPurchase', [PurchaseApiController::class, 'AddPurchase']);
    Route::post('/GetPurchase', [PurchaseApiController::class, 'GetPurchase']);
    Route::post('/EditPurchase', [PurchaseApiController::class, 'EditPurchase']);
    Route::post('/UpdatePurchase', [PurchaseApiController::class, 'UpdatePurchase']);
    
});