<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/check_phpinfo', function() {
    return phpinfo();
});
Route::get('/clear-cache', function() {
    $exitCode = Artisan::call('cache:clear');
    // return what you want
});
Route::get('/config-cache', function() {
    $exitCode = Artisan::call('config:cache');
    // return what you want
});

//Upload Product Image Routes
Route::post('product/files/upload','Vendor\KartsControllor@uploadFile');
Route::post('product/delete_img/{name}','Vendor\KartsControllor@deleteFile');

//Admin Auth Routes
Route::match(['post', 'get'],'/','Admin\LoginControllor@showLoginForm');
Route::match(['post', 'get'],'/admin','Admin\LoginControllor@showLoginForm');
Route::get('/admin/logout','Admin\LoginControllor@logout');
Route::match(['post', 'get'],'/admin/forget/password','Admin\LoginControllor@forgetPassword');
Route::match(['post', 'get'],'/user/reset_password/{id}', 'Admin\LoginControllor@resetUserPassword');
Route::match(['post', 'get'],'/admin/reset_password/{id}', 'Admin\LoginControllor@resetPassword');

Route::get('/updateReferral','Admin\LoginControllor@updateReferral');
Route::post('/register','Admin\LoginControllor@adminRegister');
Route::get('/register','Admin\LoginControllor@register');
Route::get('/register/{code}','Admin\LoginControllor@refRelregister');

Route::get('/admin/upload','Admin\InvoiceControllor@uploadUserCSV');
Route::get('/admin/upload/weight','Admin\InvoiceControllor@ratesUploadCSV');
Route::match(['post', 'get'], '/admin/calculater/home','Admin\RateControllor@calculaterHome');

Route::get('/admin/delivery/packages', 'Admin\PickupRequestControllor@indexDelivery');
Route::group(['middleware' => 'admin'], function () {
    Route::get('/admin/dashboard','Admin\DashboardControllor@dashboard');
    Route::get('/admin/invoice/unpaid','Admin\DashboardControllor@unpaidInvoice');
    Route::GET('admin/auth/users/{id}', 'Admin\UserControllor@viewAuthUser')->name('auth-users');
    Route::GET('auth-users-list/{id}', 'Admin\UserControllor@listViewAuthUser')->name('auth-users-list');
    
    Route::get('/admin/update/user/package','Admin\DashboardControllor@updateUserName');
    Route::get('/admin/update/status/package','Admin\DashboardControllor@updatePackageStatusName');
    Route::get('/admin/update/invoice/username','Admin\DashboardControllor@updateInvoiceName');
    
    Route::match(['post', 'get'],'/admin/package/invoice/add/{id}','Admin\InvoiceControllor@addNew');
    Route::get('/admin/update/invoice/status','Admin\DashboardControllor@updateInvoiceStatus');
    Route::get('/admin/update/package/status','Admin\DashboardControllor@updatePackageStatus');
    
    Route::match(['post', 'get'],'admin/profile','Admin\DashboardControllor@profile');
    Route::match(['post', 'get'],'admin/settings','Admin\DashboardControllor@settings');
    Route::match(['post', 'get'],'admin/settings','Admin\DashboardControllor@settings');
    Route::GET('ready-list', 'Admin\DashboardControllor@listViewReady')->name('package-ready-list');
    Route::GET('recent-list', 'Admin\DashboardControllor@listViewRecent')->name('recent-list');
      //Roles & Permission Routs
    Route::get('/admin/roles/new','Admin\RoleNewControllor@index');
    Route::get('/admin/permission/assign','Admin\RoleNewControllor@permission');
    Route::match(['post', 'get'], '/admin/roles/add','Admin\RoleNewControllor@create');
    Route::get('/admin/roles/delete/{role_id}','Admin\RoleNewControllor@delete');
    Route::match(['post', 'get'],'/admin/roles/edit/{role_id}','Admin\RoleNewControllor@edit');
    Route::get('/admin/assign/role/{module_id}/{role_id}','Admin\RoleNewControllor@assignRole');
    Route::get('/admin/unassign/role/{module_id}/{role_id}','Admin\RoleNewControllor@unassignRole');
    Route::get('/admin/role/permission/{role_id}','Admin\RoleNewControllor@ajaxPermission');
    //Discount Routes
    Route::get('/admin/discounts','Admin\DiscountController@index');
    Route::match(['post', 'get'], '/admin/discount/add','Admin\DiscountController@create');
    Route::get('/admin/discount/delete/{id}','Admin\DiscountController@delete');
    Route::match(['post', 'get'],'/admin/discount/edit/{id}','Admin\DiscountController@edit');
    //Admin users Routes
    Route::GET('/admin/users/list', 'Admin\AdminControllor@view')->name('admin-list');
    Route::GET('admin-list', 'Admin\AdminControllor@listView')->name('admin-list');
    Route::match(['post', 'get'], '/admin/user/add','Admin\AdminControllor@create');
    Route::match(['post', 'get'],'/admin/edit/{id}','Admin\AdminControllor@edit');
    Route::get('/admin/delete/{id}','Admin\AdminControllor@delete');
Route::get('/admin/invoice/print/{id}','Admin\InvoiceControllor@invoicePrint');
    //Roles Routes
    Route::GET('/admin/roles', 'Admin\RoleControllor@view')->name('roles');
    Route::GET('role-list', 'Admin\RoleControllor@listView')->name('role-list');
    Route::post('/save-role','Admin\RoleControllor@save');
    Route::post('/delete-role','Admin\AdminControllor@delete');
    //Users Routes
    Route::get('/admin/users','Admin\UserControllor@index');
    //Route::GET('/admin/users', 'Admin\UserControllor@view')->name('users');
    Route::GET('users-list', 'Admin\UserControllor@listView')->name('users-list');
    Route::get('/admin/users/{status}/{id}','Admin\UserControllor@updateStatus');
    Route::match(['post', 'get'],'/admin/user/edit/{id}','Admin\UserControllor@edit');
    Route::get('/admin/user/delete/{id}','Admin\UserControllor@delete');
    Route::get('/admin/user/profile/{id}','Admin\UserControllor@userProfile');
    Route::GET('/user-ready-list/{mailbox}', 'Admin\UserControllor@listViewReady')->name('user-ready-list');
    Route::get('/export/users', 'ExcelExportController@exportUser')->name('exportUser');
    Route::match(['post', 'get'],'/admin/users/export_download','Admin\InvoiceControllor@exportDownloadInvoice');
    //purchase request Routes
    Route::GET('/admin/purchase/request', 'Admin\PurchaseControllor@view')->name('purchases');
    Route::GET('purchase-list', 'Admin\PurchaseControllor@listView')->name('purchase-list');
    //Outlets Routes
    Route::GET('/admin/outlets', 'Admin\OutletControllor@view')->name('outlets');
    Route::GET('outlets-list', 'Admin\OutletControllor@listView')->name('outlets-list');
    Route::match(['post', 'get'], '/admin/outlet/add','Admin\OutletControllor@create');
    Route::post('/delete-outlet','Admin\OutletControllor@delete');
    Route::match(['post', 'get'],'/admin/outlet/edit/{id}','Admin\OutletControllor@edit');
    Route::GET('admin/outlet/packages/{id}', 'Admin\OutletControllor@viewPackages')->name('outlets-packages');
    Route::GET('outlets-packages-list/{id}', 'Admin\OutletControllor@listViewPackages')->name('outlets-packages-list');
    //Packages Routes
    Route::GET('/admin/posts', 'Admin\PackegsControllor@viewPost')->name('packeges-all');
    Route::post('allposts', 'Admin\PackegsControllor@allPosts')->name('allposts');
    Route::GET('/posts.show.{id}', 'Admin\PackegsControllor@edit')->name('edit');

    Route::GET('/admin/get/package/all', 'Admin\PackegsControllor@viewAll')->name('packeges-all');
    Route::GET('packeges-all-list', 'Admin\PackegsControllor@listViewAll')->name('packeges-all-list');

    Route::GET('/admin/packeges/{type}', 'Admin\PackegsControllor@view')->name('packeges');
    Route::GET('packeges-list/{type}', 'Admin\PackegsControllor@listView')->name('packeges-list');
    Route::GET('/admin/status/packeges/{type}', 'Admin\PackegsControllor@viewStatus')->name('packeges-status');
    Route::GET('packeges-status-list/{type}', 'Admin\PackegsControllor@listViewStatus')->name('packeges-status-list');

    Route::match(['post', 'get'], '/admin/calculater','Admin\RateControllor@calculater');
    Route::GET('/admin/category/packages/{type}', 'Admin\PackegsControllor@viewCategory')->name('packeges-category');
    Route::GET('packeges-category-list/{type}', 'Admin\PackegsControllor@listViewCategory')->name('packeges-category-list');

    Route::get('/admin/last/packeges','Admin\PackegsControllor@latestPackeges');
    Route::get('/admin/packege/update','Admin\PackegsControllor@update');
    Route::match(['post', 'get'],'/admin/create/manifest','Admin\PackegsControllor@createMani');
    Route::match(['post', 'get'],'/admin/packege/update/status','Admin\PackegsControllor@updateStatus');
    Route::match(['post', 'get'], '/admin/packege/add','Admin\PackegsControllor@create');
    Route::match(['post', 'get'],'/admin/package/add/{id}','Admin\PackegsControllor@addPackage');
    Route::match(['post', 'get'],'/admin/package/edit/{id}','Admin\PackegsControllor@edit');
    Route::post('/delete-package','Admin\PackegsControllor@delete');
    Route::match(['post', 'get'], '/admin/packege/import','Admin\PackegsControllor@import');

    Route::get('/admin/user/packeges/{id}','Admin\PackegsControllor@packeges');
    Route::get('/admin/packege/weight/{id}','Admin\PackegsControllor@weight');
    Route::get('/admin/packeges/weight/edit/{id}/{inv_id}','Admin\PackegsControllor@weightEdit');
    Route::get('/admin/temporary/packeges','Admin\PackegsControllor@temporaryPackage');
    //Package status
    Route::get('/admin/package/status','Admin\StatusControllor@index');
    Route::match(['post', 'get'], '/admin/status/add','Admin\StatusControllor@create');
    Route::get('/admin/status/delete/{id}','Admin\StatusControllor@delete');
    Route::match(['post', 'get'],'/admin/status/edit/{id}','Admin\StatusControllor@edit');
    //Rate Routes
    Route::get('/admin/rates','Admin\RateControllor@index');
    Route::match(['post', 'get'], '/admin/rate/add','Admin\RateControllor@create');
    //Route::get('/admin/status/delete/{id}','Admin\StatusControllor@delete');
    Route::match(['post', 'get'],'/admin/rate/edit/{id}','Admin\RateControllor@edit');
    //Invoice Route
    Route::GET('/admin/invoices', 'Admin\InvoiceControllor@view')->name('invoices');
    Route::GET('invoices-list', 'Admin\InvoiceControllor@listView')->name('invoices-list');
    Route::GET('/admin/invoices/email/{status}', 'Admin\InvoiceControllor@viewEmail')->name('invoices-email');
    Route::GET('/admin/view/invoice/{status}', 'Admin\InvoiceControllor@viewEmail')->name('invoices-email');
    Route::GET('invoices-email-list/{status}', 'Admin\InvoiceControllor@listViewEmail')->name('invoices-email-list');

    Route::match(['post', 'get'],'/admin/invoices/mass/payments/{status}', 'Admin\InvoiceControllor@viewMassPayments')->name('invoices-mass-payments');
    Route::GET('invoices-mass-payments-list/{status}', 'Admin\InvoiceControllor@listViewMassPayments')->name('invoices-mass-payments-list');
Route::match(['post', 'get'],'/admin/invoices/update/mass/payments', 'Admin\InvoiceControllor@payMassPayments')->name('payMassPayments');
    Route::match(['post', 'get'], '/admin/invoice/add','Admin\InvoiceControllor@create');
    Route::post('/delete-invoice','Admin\InvoiceControllor@delete');
    Route::match(['post', 'get'],'/admin/invoice/edit/{id}','Admin\InvoiceControllor@edit');
    //Route::get('/admin/invoice/print/{id}','Admin\InvoiceControllor@printInvoice');
    Route::get('/user/invoices','Admin\InvoiceControllor@userInvoices');
    Route::match(['post', 'get'],'/admin/invoice/find/package','Admin\InvoiceControllor@findPackeg');
    Route::match(['post', 'get'],'/admin/create/invoice','Admin\InvoiceControllor@createInvoice');
    Route::post('/admin/invoice/submit','Admin\InvoiceControllor@submitInvoice');
    Route::get('/admin/invoice/{id}','Admin\InvoiceControllor@invoice');
    Route::get('/admin/invoice/print/{id}','Admin\InvoiceControllor@invoicePrint');
    Route::post('/admin/invoice/send','Admin\InvoiceControllor@sendInvoice');
    Route::get('/admin/resend/email/{id}','Admin\InvoiceControllor@resendInvoice');
    Route::get('/admin/invoice/update/{status}/{id}','Admin\InvoiceControllor@updateInvoiceStatus');
    Route::match(['post', 'get'],'/admin/invoices/export','Admin\InvoiceControllor@exportInvoice');
    Route::match(['post', 'get'],'/admin/invoices/export_download','Admin\InvoiceControllor@exportDownloadInvoice');
    Route::get('/admin/invpackege/delete/{id}','Admin\PackegsControllor@deletePackage');
    Route::get('/admin/invpackege/delete/edit/{id}/{invID}','Admin\PackegsControllor@deletePackageEdit');
    Route::post('/update-invoice-status','Admin\InvoiceControllor@updateInvoiceStatusNew');
    
    Route::post('/get-invoice-data','Admin\InvoiceControllor@getInvoiceData');
    Route::post('/get-invoice-mass-data','Admin\InvoiceControllor@getMassInvoiceData');
    
    //Old Invoice Route
    Route::GET('/admin/old/invoices', 'Admin\InvoiceOldControllor@view')->name('invoices-old');
    Route::GET('invoices-list-old', 'Admin\InvoiceOldControllor@listView')->name('invoices-list-old');
    Route::GET('/admin/old/invoices/email/{status}', 'Admin\InvoiceOldControllor@viewEmail')->name('invoices-email-old');
    Route::GET('invoices-email-list-old/{status}', 'Admin\InvoiceOldControllor@listViewEmail')->name('invoices-email-list-old');
    Route::get('/admin/old/resend/email/{id}','Admin\InvoiceOldControllor@resendInvoice');
    Route::get('/admin/old/invoice/update/{status}/{id}','Admin\InvoiceOldControllor@updateInvoiceStatus');
    Route::get('/admin/old/invoice/{id}','Admin\InvoiceOldControllor@invoice');
    Route::post('/delete-invoice-old','Admin\InvoiceOldControllor@delete');
    //End

    Route::match(['post', 'get'],'admin/change/password','Admin\DashboardControllor@changePassword');

    //Weight Routes
    Route::GET('/admin/weight', 'Admin\WeightControllor@view')->name('weight');
    Route::GET('weight-list', 'Admin\WeightControllor@listView')->name('weight-list');
    Route::post('/save-weight','Admin\WeightControllor@save');
    //Send Email Routes
    Route::match(['post', 'get'],'/send/email','Admin\DashboardControllor@sendEmail');
    //Menifest Routes
    Route::get('/admin/package/manifest','Admin\PackegsControllor@manifest');
    Route::get('/admin/package/export/excel/{id}','Admin\PackegsControllor@exportExcel');
    Route::match(['post', 'get'],'/admin/manifest/export/{id}','Admin\PackegsControllor@exportManifest');

    Route::GET('/admin/list/manifest', 'Admin\PackegsControllor@viewMenifest')->name('manifest');
    Route::GET('packeges-menifest-list', 'Admin\PackegsControllor@listViewMenifest')->name('packeges-menifest-list');
    Route::match(['post', 'get'],'/admin/create/manifest','Admin\PackegsControllor@createMani');
    Route::match(['post', 'get'],'/admin/manifest/create','Admin\PackegsControllor@createManifest');
    Route::match(['post', 'get'],'/admin/manifest/edit/{id}','Admin\PackegsControllor@editManifest');
    Route::get('/admin/manifest/packege/delete/{id}','Admin\PackegsControllor@deleteManifest');
    //Location Route
    Route::GET('/admin/pickup/location', 'Admin\LocationControllor@view')->name('location');
    Route::GET('location-list', 'Admin\LocationControllor@listView')->name('location-list');
    Route::match(['post', 'get'], '/save-location','Admin\LocationControllor@save');
    Route::post('/delete-location','Admin\LocationControllor@delete');
    //Areas Routes
    Route::GET('/admin/areas', 'Admin\AreaControllor@view')->name('address-areas');
    Route::GET('areas-list', 'Admin\AreaControllor@listView')->name('areas-list');
    Route::match(['post', 'get'],'/save-area','Admin\AreaControllor@save');
    Route::POST('/delete-area','Admin\AreaControllor@delete');
    Route::GET('/admin/area/{status}/{id}','Admin\AreaControllor@updateStatus');

    Route::match(['post', 'get'],'/admin/schedule/days','Admin\AreaControllor@scheduleDays');

    //Delivery Routes
    Route::GET('/admin/delivery/schedule/{type}', 'Admin\PickupRequestControllor@view')->name('requests');
    Route::GET('requests-list/{type}', 'Admin\PickupRequestControllor@listView')->name('requests-list');
    Route::GET('admin/request/{status}/{id}', 'Admin\PickupRequestControllor@updateStatus');



    Route::GET('/admin/packages/delivery/history', 'Admin\PickupRequestControllor@viewHistory')->name('requestsHistory');
    Route::GET('requests-history-list-admin', 'Admin\PickupRequestControllor@listHistoryView')->name('requests-history-list-admin');
});

Route::group(['middleware' => 'outlet'], function () {
    Route::get('/outlet/dashboard','Outlet\DashboardControllor@dashboard');
    Route::match(['post', 'get'],'outlet/profile','Outlet\DashboardControllor@profile');
    Route::GET('outlet-ready-list', 'Outlet\DashboardControllor@listViewReady')->name('outlet-ready-list');
    Route::GET('outlet-recent-list', 'Outlet\DashboardControllor@listViewRecent')->name('outlet-recent-list');
    Route::match(['post', 'get'],'outlet/change/password','Outlet\DashboardControllor@changePassword');

    Route::GET('/outlet/users', 'Outlet\UserControllor@view')->name('outlet-users');
    Route::GET('outlet-users-list', 'Outlet\UserControllor@listView')->name('outlet-users-list');

    Route::GET('/outlet/packeges', 'Outlet\PackegControllor@view')->name('outlet-packeges');
    Route::GET('outlet-packeges-list', 'Outlet\PackegControllor@listView')->name('outlet-packeges-list');
    Route::get('/outlet/package/status/update/{status}/{id}','Outlet\PackegControllor@updateStatus');

    Route::GET('/outlet/invoices', 'Outlet\InvoiceControllor@view')->name('outlet-invoices');
    Route::GET('outlet-invoices-list', 'Outlet\InvoiceControllor@listView')->name('outlet-invoices-list');
    Route::get('/outlet/invoice/{id}','Outlet\InvoiceControllor@invoice');
    Route::match(['post', 'get'], '/outlet/calculater','Outlet\RateControllor@calculater');
});

Route::group(['middleware' => 'user'], function () {
    Route::get('/user/dashboard','Users\DashboardControllor@dashboard');
    Route::match(['post', 'get'],'user/profile','Users\DashboardControllor@profile');
    Route::GET('ready-user-list', 'Users\DashboardControllor@listViewReady')->name('ready-user-list');
    Route::GET('recent-user-list', 'Users\DashboardControllor@listViewRecent')->name('recent-user-list');
    Route::match(['post', 'get'],'user/change/password','Users\DashboardControllor@changePassword');

    Route::match(['post', 'get'], '/user/packege/add','Users\PackegControllor@add');
    Route::GET('/user/packeges/track', 'Users\PackegControllor@view')->name('user-packeges');
    Route::GET('user-packeges-list', 'Users\PackegControllor@listView')->name('user-packeges-list');
Route::GET('/user/referral/list', 'Users\AuthUserController@viewUser')->name('referral-list');
    Route::GET('referral-list', 'Users\AuthUserController@listViewUser')->name('referral-list');
    Route::match(['post', 'get'],'/user/delivery/packages', 'Users\PickupRequestControllor@index');
    //Auth user Routes
    Route::GET('/user/auth/list', 'Users\AuthUserController@view')->name('auth');
    Route::GET('auth-list', 'Users\AuthUserController@listView')->name('auth-list');
    Route::match(['post', 'get'], '/user/auth/add','Users\AuthUserController@create');
    Route::match(['post', 'get'],'/user/auth/edit/{id}','Users\AuthUserController@edit');
     Route::post('/delete-auth','Users\AuthUserController@delete');
    //purchase request Routes
    Route::GET('/user/purchase/request', 'Users\PurchaseControllor@view')->name('user-purchases');
    Route::GET('user-purchase-list', 'Users\PurchaseControllor@listView')->name('user-purchase-list');
    Route::match(['post', 'get'], '/user/purchase/add','Users\PurchaseControllor@create');
    Route::match(['post', 'get'],'/user/purchase/edit/{id}','Users\PurchaseControllor@edit');
Route::match(['post', 'get'], '/user/calculater','Users\RateControllor@calculater');
    Route::GET('/user/invoices', 'Users\InvoiceControllor@view')->name('user-invoices');
    Route::GET('user-invoices-list', 'Users\InvoiceControllor@listView')->name('user-invoices-list');
    Route::get('/user/invoice/{id}','Users\InvoiceControllor@invoice');

    Route::GET('/user/packages/delivery/history', 'Users\PickupRequestControllor@viewHistory')->name('requestsHistory');
    Route::GET('requests-history-list', 'Users\PickupRequestControllor@listHistoryView')->name('requests-history-list');
});
